'From Squeak3.6 of ''6 October 2003'' [latest update: #5429] on 29 June 2004 at 10:54:20 pm'!
"Change Set:		DeprecatedMethodsFor36
Date:			9 October 2003
Author:			Doug Way

The list of all methods which were deprecated in Squeak 3.6, and removed in 3.7."!


!Behavior methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:13'!
browseAllAccessesTo: instVarName 	"Collection browseAllAccessesTo: 'contents'."
	"Create and schedule a Message Set browser for all the receiver's methods 
	or any methods of a subclass that refer to the instance variable name."

	| coll |
	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>browseAllAccessesTo:from: instead'.
	coll _ OrderedCollection new.
	Cursor wait showWhile: [
		self withAllSubAndSuperclassesDo: [:class | 
			(class whichSelectorsAccess: instVarName) do: [:sel |
				sel == #DoIt ifFalse: [
					coll add: (
						MethodReference new
							setStandardClass: class 
							methodSymbol: sel
					)
				]
			]
		].
	].
	^ self environment 
		browseMessageList: coll 
		name: 'Accesses to ' , instVarName 
		autoSelect: instVarName! !

!Behavior methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:15'!
browseAllCallsOn: aSymbol 
	"Create and schedule a Message Set browser for all the methods that call 
	on aSymbol."
	| key label |
	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>browseAllCallsOn:from: instead'.
	label _ (aSymbol isKindOf: LookupKey)
			ifTrue: ['Users of ' , (key _ aSymbol key)]
			ifFalse: ['Senders of ' , (key _ aSymbol)].
	^ self environment 
		browseMessageList: (self allCallsOn: aSymbol)
		name: label
		autoSelect: key

	"Number browseAllCallsOn: #/."! !

!Behavior methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:15'!
browseAllStoresInto: instVarName 	"Collection browseAllStoresInto: 'contents'."
	"Create and schedule a Message Set browser for all the receiver's methods 
	or any methods of a subclass that refer to the instance variable name."
	| coll |
	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>browseAllStoresInto:from: instead'.
	coll _ OrderedCollection new.
	Cursor wait showWhile: [
		self withAllSubAndSuperclassesDo: [:class | 
			(class whichSelectorsStoreInto: instVarName) do: [:sel |
				sel == #DoIt ifFalse: [
					coll add: (
						MethodReference new
							setStandardClass: class 
							methodSymbol: sel
					)
				]
			]
		].
	].
	^ self environment 
		browseMessageList: coll 
		name: 'Stores into ' , instVarName 
		autoSelect: instVarName! !

!Behavior methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:17'!
classThatUnderstands: selector
	"Answer the class that can respond to the message whose selector
	is the argument. The selector can be in the method dictionary of the
	receiver's class or any of its superclasses."

	self deprecatedExplanation: 'Method Deprecated: Use Behavior>>whichClassIncludesSelector: instead'.
	(self includesSelector: selector) ifTrue: [^ self].
	superclass == nil ifTrue: [^ nil].
	^ superclass classThatUnderstands: selector! !

!Behavior methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:17'!
confirmRemovalOf: aSelector
	"Determine if it is okay to remove the given selector.  Answer 1 if it should be removed, 2 if it should be removed followed by a senders browse, and 3 if it should not be removed."

	| count aMenu answer caption allCalls |
	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>confirmRemovalOf:on: instead'.
	allCalls _ self environment allCallsOn: aSelector.
	(count _ allCalls size) == 0 ifTrue: [^ 1].  "no senders -- let the removal happen without warning"
	count == 1 ifTrue: [
		(allCalls first actualClass == self and: 
			[allCalls first methodSymbol == aSelector]) ifTrue: [^ 1]
	].   "only sender is itself"

	aMenu _ PopUpMenu labels: 'Remove it
Remove, then browse senders
Don''t remove, but show me those senders
Forget it -- do nothing -- sorry I asked'.

	caption _ 'This message has ', count printString, ' sender'.
	count > 1 ifTrue:
		[caption _ caption copyWith: $s].
	answer _ aMenu startUpWithCaption: caption.
	answer == 3 ifTrue: [
		Smalltalk 
			browseMessageList: allCalls
			name: 'Senders of ', aSelector
			autoSelect: aSelector keywords first
	].
	answer == 0 ifTrue: [answer _ 3].  "If user didn't answer, treat it as cancel"
	^ answer min: 3! !

!Behavior methodsFor: 'deprecated' stamp: 'rw 5/13/2003 16:00'!
defaultSelectorForMethod: aMethod 
	"Given a method, invent and answer an appropriate message selector (a 
	Symbol), that is, one that will parse with the correct number of 
	arguments."

	| aStream |
	self deprecatedExplanation: 'Use CompiledMethod>>defaultSelector instead of Behavior>>defaultSelectorForMethod: aMethod.'.
	aStream _ WriteStream on: (String new: 16).
	aStream nextPutAll: 'DoIt'.
	1 to: aMethod numArgs do: [:i | aStream nextPutAll: 'with:'].
	^aStream contents asSymbol! !


!ClassDescription methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:20'!
browseClassVarRefs 
	"Put up a menu offering all class variable names; if the user chooses one, open up a message-list browser on all methods that refer to the selected class variable"

	| lines labelStream vars allVars index owningClasses |
	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>browseClassVarRefs: instead'.
	lines _ OrderedCollection new.
	allVars _ OrderedCollection new.
	owningClasses _ OrderedCollection new.
	labelStream _ WriteStream on: (String new: 200).
	self withAllSuperclasses reverseDo:
		[:class |
		vars _ class classVarNames asSortedCollection.
		vars do:
			[:var |
			labelStream nextPutAll: var; cr.
			allVars add: var.
			owningClasses add: class].
		vars isEmpty ifFalse: [lines add: allVars size]].
	labelStream contents isEmpty ifTrue: [^1 beep]. "handle nil superclass better"
	labelStream skip: -1 "cut last CR".
	index _ (PopUpMenu labels: labelStream contents lines: lines) startUp.
	index = 0 ifTrue: [^ self].
	self environment browseAllCallsOn:
		((owningClasses at: index) classPool associationAt: (allVars at: index))! !

!ClassDescription methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:20'!
browseClassVariables
	"Put up a browser showing the receiver's class variables.  2/1/96 sw"

	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>browseClassVariables: instead'.
	self classPool inspectWithLabel: 'Class Variables in ', self name! !

!ClassDescription methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:21'!
browseInstVarDefs 
	"Copied from browseInstVarRefs.  Should be consolidated some day. 7/29/96 di
	7/30/96 sw: did the consolidation"
	"Change to use SystemNavigation  27 March 2003 sd"

	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>browseInstVarDefs: instead'.
	self chooseInstVarThenDo:	
		[:aVar | SystemNavigation new browseAllStoresInto: aVar from: self]! !

!ClassDescription methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:22'!
browseInstVarRefs 
	"1/16/96 sw: moved here from Browser so that it could be used from a variety of places.
	 7/30/96 sw: call chooseInstVarThenDo: to get the inst var choice"

	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>browseInstVarRefs: instead'.
	self chooseInstVarThenDo: 
		[:aVar | SystemNavigation new browseAllAccessesTo: aVar from: self]! !


!Dictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 16:02'!
inspectFormsWithLabel: aLabel
        "Open a Form Dictionary inspector on the receiver, with the given label."

	| viewClass aList aGraphicalMenu |
 	self deprecatedExplanation: 'Use GraphicalDictionaryMenu>>openOn:withLabel in Morphic or FormInspectView>>openOn:withLabel: in MVC'.
	self couldOpenInMorphic
                ifTrue:
                        [aList _ self collect: [:f | f].
                        aList isEmpty ifTrue: [^ self inform: 'Empty!!'].
                        aGraphicalMenu _ GraphicalDictionaryMenu new 
                                initializeFor: nil
                                fromDictionary: self.
                        ^ HandMorph attach: (aGraphicalMenu wrappedInWindowWithTitle: aLabel)].

        viewClass _ PluggableTextView.
        Smalltalk at: #FormInspectView
                ifPresent: [:formInspectView | viewClass _ formInspectView].
        ^ DictionaryInspector
                openOn: self
                withEvalPane: true
                withLabel: aLabel
                valueViewClass: viewClass! !


!SystemDictionary methodsFor: 'browsing' stamp: 'sd 5/23/2003 15:17'!
browseChangedMessages
	"Create and schedule a message browser on each method that has been 
	changed."

	self deprecatedExplanation: 'Use ChangeSet current browseChangedMessages'.
	ChangeSet  browseChangedMessages! !

!SystemDictionary methodsFor: 'sources, change log' stamp: 'bkv 7/21/2003 10:01'!
newChanges: aChangeSet 
	"Set the system ChangeSet to be the argument, aChangeSet.  Tell the current project that aChangeSet is now its change set.  When called from Project enter:, the setChangeSet: call is redundant but harmless; when called from code that changes the current-change-set from within a project, it's vital"

	self deprecatedExplanation: 'Use ChangeSet newChanges:'. 
	ChangeSet newChanges: aChangeSet! !

!SystemDictionary methodsFor: 'sources, change log' stamp: 'sd 5/23/2003 15:17'!
noChanges 
	"Initialize the system ChangeSet."

	self deprecatedExplanation: 'Use ChangeSet current noChanges'. 
	ChangeSet  noChanges! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 13:54'!
allBehaviorsDo: aBlock 
	"Evaluate the argument, aBlock, for each kind of Behavior in the system 
	(that is, Object and its subclasses).
	ar 7/15/1999: The code below will not enumerate any obsolete or anonymous
	behaviors for which the following should be executed:

		Smalltalk allObjectsDo:[:obj| obj isBehavior ifTrue:[aBlock value: obj]].

	but what follows is way faster than enumerating all objects."

	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>allBehaviorsDo:'.

	aBlock value: ProtoObject.
	ProtoObject allSubclassesDoGently: aBlock.		"don't bring in ImageSegments"

	"Classes outside the ProtoObject hierarchy"
	Class subclassesDo: [:aClass |
		(aClass == ProtoObject class
			or: [aClass isInMemory not
			or: [aClass isMeta not]]) ifFalse:
			["Enumerate the non-meta class and its subclasses"
			aBlock value: aClass soleInstance.
			aClass soleInstance allSubclassesDoGently: aBlock]].! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:26'!
allCallsOn: aLiteral   "Smalltalk browseAllCallsOn: #open:label:."
	"Answer a Collection of all the methods that call on aLiteral."

	| aCollection special thorough aList byte |
	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>allCallsOn:'.
	#(23 48 'fred' (new open:label:)) size.
"Example above should find #open:label:, though it is deeply embedded here."

	aCollection _ OrderedCollection new.
	special _ self hasSpecialSelector: aLiteral ifTrueSetByte: [:b | byte _ b ].
	thorough _ (aLiteral isMemberOf: Symbol)
				and: ["Possibly search for symbols imbedded in literal arrays"
					Preferences thoroughSenders].
	Cursor wait showWhile: [
		self allBehaviorsDo: [:class |
			aList _ thorough ifTrue: [
				class thoroughWhichSelectorsReferTo: aLiteral special: special byte: byte
			] ifFalse: [
				class whichSelectorsReferTo: aLiteral special: special byte: byte
			].
			aList do: [ :sel |
				sel == #DoIt ifFalse: [
					aCollection add: (
						MethodReference new
							setStandardClass: class 
							methodSymbol: sel
					)
				]
			]
		]
	].
	^ aCollection! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:26'!
allCallsOn: firstLiteral and: secondLiteral
	"Answer a SortedCollection of all the methods that call on both aLiteral 
	and secondLiteral."

	| aCollection secondArray firstSpecial secondSpecial firstByte secondByte |
	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>allCallsOn:and:'.
	aCollection _ SortedCollection new.
	firstSpecial _ self hasSpecialSelector: firstLiteral ifTrueSetByte: [:b | firstByte _ b].
	secondSpecial _ self hasSpecialSelector: secondLiteral ifTrueSetByte: [:b | secondByte _ b].
	Cursor wait showWhile: [
		self allBehaviorsDo: [:class |
			secondArray _ class 
				whichSelectorsReferTo: secondLiteral
				special: secondSpecial
				byte: secondByte.
			((class whichSelectorsReferTo: firstLiteral special: firstSpecial byte: firstByte) select:
				[:aSel | (secondArray includes: aSel)]) do:
						[:sel | 
							aCollection add: (
								MethodReference new
									setStandardClass: class 
									methodSymbol: sel
							)
						]
		]
	].
	^aCollection! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:27'!
allClassesImplementing: aSelector  
	"Answer an Array of all classes that implement the message aSelector."

	| aCollection |
	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>allClassesImplementing:'.
	aCollection _ ReadWriteStream on: Array new.
	self allBehaviorsDo:
		[:class | (class includesSelector: aSelector)
			ifTrue: [aCollection nextPut: class]].
	^ aCollection contents! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:27'!
allGlobalRefs
	"Answer a set of symbols that may be refs to Global names.  In some sense we should only need the associations, but this will also catch, eg, HTML tag types."

	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>allGlobalRefs'.
	^ self allGlobalRefsWithout: {{}. {}}! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:27'!
allGlobalRefsWithout: classesAndMessagesPair
	"Answer a set of symbols that may be refs to Global names.  In some sense we should only need the associations, but this will also catch, eg, HTML tag types.  This method computes its result in the absence of specified classes and messages."
	| globalRefs absentClasses absentSelectors |
	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>allGlobalRefsWithout:'.
	globalRefs _ IdentitySet new: CompiledMethod instanceCount.
	absentClasses _ classesAndMessagesPair first.
	absentSelectors _ classesAndMessagesPair second.
	Cursor execute showWhile: 
		[self classNames do: 
			[:cName | ((absentClasses includes: cName)
						ifTrue: [{}]
						ifFalse: [{(self at: cName). (self at: cName) class}]) do:
				[:cl | (absentSelectors isEmpty
						ifTrue: [cl selectors]
						ifFalse: [cl selectors copyWithoutAll: absentSelectors]) do: 
					[:sel | "Include all capitalized symbols for good measure"
					(cl compiledMethodAt: sel) literals do: 
						[:m | 
						((m isMemberOf: Symbol) and: [m size > 0 and: [m first isUppercase]]) ifTrue:
							[globalRefs add: m].
						(m isMemberOf: Array) ifTrue:
							[m do: [:x | ((x isMemberOf: Symbol) and: [x size > 0 and: [x first isUppercase]]) ifTrue:
								[globalRefs add: x]]].
						(m isVariableBinding) ifTrue:
							[m key ifNotNil: [globalRefs add: m key]]]]]]].
	^ globalRefs! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:28'!
allImplementedMessages
	"Answer a Set of all the messages that are implemented in the system."

	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>allImplementedMessages'.
	^ self allImplementedMessagesWithout:  {{}. {}}! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:28'!
allImplementedMessagesWithout: classesAndMessagesPair
	"Answer a Set of all the messages that are implemented in the system, computed in the absence of the supplied classes and messages.  Note this reports messages that are in the absent selectors set."
	| messages absentClasses |
	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>allImplementedMessagesWithout:'.
	messages _ IdentitySet new: CompiledMethod instanceCount.
	absentClasses _ classesAndMessagesPair first.
	Cursor execute showWhile: 
		[self classNames do: 
			[:cName | ((absentClasses includes: cName)
						ifTrue: [{}]
						ifFalse: [{(self at: cName). (self at: cName) class}]) do:
				[:cl | messages addAll: cl selectors]]].
	^ messages! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:28'!
allImplementorsOf: aSelector  
	"Answer a SortedCollection of all the methods that implement the message 
	aSelector."

	| aCollection |
	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>allImplementorsOf:'.
	aCollection _ SortedCollection new.
	Cursor wait showWhile: [
		self allBehaviorsDo: [ :class |
			(class includesSelector: aSelector) ifTrue: [
				aCollection add: (
					MethodReference new
						setStandardClass: class 
						methodSymbol: aSelector
				)
			]
		]
	].
	^aCollection! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:28'!
allImplementorsOf: aSelector  localTo: aClass
	"Answer a SortedCollection of all the methods that implement the message 
	aSelector in, above, or below the given class."

	| aSet cls |
	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>allImplementorsOf:localTo:'.
	aSet _ Set new.
	cls _ aClass theNonMetaClass.
	Cursor wait showWhile: [
		cls withAllSuperAndSubclassesDoGently:
			[:class |
			(class includesSelector: aSelector)
				ifTrue: [aSet add: class name, ' ', aSelector]].
		cls class withAllSuperAndSubclassesDoGently:
			[:class |
			(class includesSelector: aSelector)
				ifTrue: [aSet add: class name, ' ', aSelector]]
	].
	^aSet asSortedCollection! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:29'!
allMethodsInCategory: category 

	| aCollection |
	self deprecatedExplanation: 'Method Deprecated: Use ClassDescription>>allMethodsInCategory:'.
	aCollection _ SortedCollection new.
	Cursor wait showWhile:
		[self allBehaviorsDo:
			[:x | (x organization listAtCategoryNamed: category) do:
				[:sel | aCollection add: x name , ' ' , sel]]].
	^aCollection! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:29'!
allMethodsWithSourceString: aString matchCase: caseSensitive
	"Answer a SortedCollection of all the methods that contain, in source code, aString as a substring.  Search the class comments also"
	| list classCount adder |
	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>allMethodsWithSourceString:matchCase:'.
	list _ Set new.
	adder _ [ :mrClass :mrSel |
		list add: (
			MethodReference new
				setStandardClass: mrClass
				methodSymbol: mrSel
		)
	].

'Searching all source code...'
displayProgressAt: Sensor cursorPoint
from: 0 to: Smalltalk classNames size
during:
	[:bar | classCount _ 0.
	Smalltalk allClassesDo:
		[:class | bar value: (classCount _ classCount + 1).
		(Array with: class with: class class) do:
			[:cl | 
				cl selectorsDo: [:sel | 
					((cl sourceCodeAt: sel) findString: aString 
						startingAt: 1 caseSensitive: caseSensitive) > 0 ifTrue: [
							sel == #DoIt ifFalse: [adder value: cl value: sel]]].
				(cl organization classComment asString findString: aString 
						startingAt: 1 caseSensitive: caseSensitive) > 0 ifTrue: [
							adder value: cl value: #Comment].
			]]].
	^ list asSortedCollection! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:29'!
allObjectsDo: aBlock 
	"Evaluate the argument, aBlock, for each object in the system
	 excluding SmallIntegers."

	| object |
	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>allObjectsDo:'.
	object _ self someObject.
	[0 == object] whileFalse: [
		aBlock value: object.
		object _ object nextObject.
	].! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:30'!
allObjectsSelect: aBlock 
	"Evaluate the argument, aBlock, for each object in the system excluding SmallIntegers.
	Return a collection af all objects for whom the value is true."

	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>allObjectsSelect:'.
	^ Array streamContents:
		[:s | self allObjectsDo: [:object | (aBlock value: object) ifTrue: [s nextPut: object]]]! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:32'!
allPrimitiveMessages
	"Answer an OrderedCollection of all the methods that are implemented by 
	primitives."

	| aColl method | 
	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>allPrimitiveMethods'.
	aColl _ OrderedCollection new: 200.
	Cursor execute showWhile: 
		[self allBehaviorsDo: 
			[:class | class selectorsDo: 
				[:sel | 
				method _ class compiledMethodAt: sel.
				method primitive ~= 0
					ifTrue: [aColl addLast: class name , ' ' , sel 
									, ' ' , method primitive printString]]]].
	^aColl! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:32'!
allPrimitiveMethodsInCategories: aList
	"Answer an OrderedCollection of all the methods that are implemented by primitives in the given categories.  1/26/96 sw"

	| aColl method |
	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>allPrimitiveMethodsInCategories:'.
	aColl _ OrderedCollection new: 200.
	Cursor execute showWhile: 
		[self allBehaviorsDo: 
			[:aClass | (aList includes: (SystemOrganization categoryOfElement: aClass theNonMetaClass name asString) asString)
				ifTrue: [aClass selectorsDo: 
					[:sel | 
						method _ aClass compiledMethodAt: sel.
						method primitive ~= 0
							ifTrue: [aColl addLast: aClass name , ' ' , sel 
									, ' ' , method primitive printString]]]]].
	^ aColl

"Smalltalk allPrimitiveMethodsInCategories: #('Collections-Streams' 'Files-Streams' 'Files-Abstract' 'Files-Macintosh')"! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:32'!
allSelect: aBlock 
	"Answer a SortedCollection of each method that, when used as the block 
	argument to aBlock, gives a true result."

	| aCollection |
	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>allMethodsSelect:'.
	aCollection _ SortedCollection new.
	Cursor execute showWhile: 
		[self allBehaviorsDo: 
			[:class | class selectorsDo: 
				[:sel | (aBlock value: (class compiledMethodAt: sel))
					ifTrue: [aCollection add: class name , ' ' , sel]]]].
	^aCollection! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:33'!
allSelectNoDoits: aBlock 
	"Like allSelect:, but strip out Doits"

	| aCollection |
	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>allMethodsNoDoitsSelect:'.
	aCollection _ SortedCollection new.
	Cursor execute showWhile: [
		self allBehaviorsDo: [ :class |
			class selectorsDo: [:sel |
				((sel ~~ #DoIt) and: [(aBlock value: (class compiledMethodAt: sel))]) ifTrue: [
					aCollection add: (
						MethodReference new
							setStandardClass: class 
							methodSymbol: sel
					)
				]
			]
		]
	].
	^aCollection! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:33'!
allSentMessages
	"Answer the set of selectors which are sent somewhere in the system."

	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>allSentMessages'.
	^ self allSentMessagesWithout: {{}. {}}! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:33'!
allSentMessagesWithout: classesAndMessagesPair
	"Answer the set of selectors which are sent somewhere in the system, computed in the absence of the supplied classes and messages."

	| sent absentClasses absentSelectors |
	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>allSentMessagesWithout:'.
	sent _ IdentitySet new: CompiledMethod instanceCount.
	absentClasses _ classesAndMessagesPair first.
	absentSelectors _ classesAndMessagesPair second.
	Cursor execute showWhile: 
		[self classNames do: 
			[:cName | ((absentClasses includes: cName)
						ifTrue: [{}]
						ifFalse: [{(self at: cName). (self at: cName) class}]) do:
				[:cl | (absentSelectors isEmpty
						ifTrue: [cl selectors]
						ifFalse: [cl selectors copyWithoutAll: absentSelectors]) do: 
					[:sel | "Include all sels, but not if sent by self"
					(cl compiledMethodAt: sel) literals do: 
						[:m | 
						(m isMemberOf: Symbol) ifTrue:  "might be sent"
							[m == sel ifFalse: [sent add: m]].
						(m isMemberOf: Array) ifTrue:  "might be performed"
							[m do: [:x | (x isMemberOf: Symbol) ifTrue:
								[x == sel ifFalse: [sent add: x]]]]]]]].
		"The following may be sent without being in any literal frame"
		1 to: self specialSelectorSize do: 
			[:index | 
			sent add: (self specialSelectorAt: index)]].
	Smalltalk presumedSentMessages do: [:sel | sent add: sel].
	^ sent! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:34'!
allUnSentMessages   "Smalltalk allUnSentMessages"
	"Answer the set of selectors that are implemented by some object in the system but not sent by any."

	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>allUnSentMessages'.
	^ self allUnSentMessagesWithout: {{}. {}}! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:34'!
allUnSentMessagesIn: selectorSet
	"Answer the subset of selectorSet which are not sent anywhere in the system."

	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>allUnSentMessagesIn:'.
	^ selectorSet copyWithoutAll: self allSentMessages! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:34'!
allUnSentMessagesWithout: classesAndMessagesPair
	"Answer the set of selectors that are implemented but not sent, computed in the absence of the supplied classes and messages."

	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>allUnSentMessagesWithout:'.
	^ (self allImplementedMessagesWithout: classesAndMessagesPair)
		copyWithoutAll: (self allSentMessagesWithout: classesAndMessagesPair)! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:35'!
allUnimplementedCalls 
	"Answer an Array of each message that is sent by an expression in a 
	method but is not implemented by any object in the system."

	| aStream secondStream all  |
	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>allUnimplementedCalls'.
	all _ self allImplementedMessages.
	aStream _ WriteStream on: (Array new: 50).
	Cursor execute showWhile:
		[self allBehaviorsDo:
			[:cl |
			 cl selectorsDo:
				[:sel |
				 secondStream _ WriteStream on: (String new: 5).
				(cl compiledMethodAt: sel) messages do:
					[:m | (all includes: m) ifFalse: [secondStream nextPutAll: m; space]].
				secondStream position = 0 ifFalse:
					[aStream nextPut: cl name , ' ' , sel , ' calls: ', secondStream contents]]]].
	^aStream contents! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:35'!
allUnusedClassesWithout: classesAndMessagesPair
	"Enumerates all classes in the system and returns a list of those that are apparently unused. A class is considered in use if it (a) has subclasses or (b) is referred to by some method or (c) has its name in use as a literal."
	"Smalltalk unusedClasses"

	| unused cl |
	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>allUnusedClassesWithout:'.
	unused _ Smalltalk classNames asIdentitySet
				copyWithoutAll: (self allGlobalRefsWithout: classesAndMessagesPair).
	^ unused reject:
		[:cName | cl _ Smalltalk at: cName.
		cl subclasses isEmpty not or: [cl inheritsFrom: FileDirectory]]! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 16:02'!
beep

	self deprecatedExplanation: 'Use Object>>beep or Object>>beepPrimitive instead of Smalltalk beep.'.
	self beepPrimitive.! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:35'!
browseAllCallsOn: aLiteral 
	"Create and schedule a message browser on each method that refers to
	aLiteral. For example, Smalltalk browseAllCallsOn: #open:label:."

	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>browseAllCallsOn:'.
	(aLiteral isKindOf: LookupKey) ifTrue: [
		^self 
			browseMessageList: (self allCallsOn: aLiteral) asSortedCollection
			name: 'Users of ' , aLiteral key
			autoSelect: aLiteral key
	].
	self 
		browseMessageList: (self allCallsOn: aLiteral) asSortedCollection
		name: 'Senders of ' , aLiteral
		autoSelect: aLiteral keywords first! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:36'!
browseAllCallsOn: literal1 and: literal2 
	"Create and schedule a message browser on each method that calls on the 
	two Symbols, literal1 and literal2. For example, Smalltalk 
	browseAllCallsOn: #at: and: #at:put:."

	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>browseAllCallsOn:and:'.
	^self 
		browseMessageList: (self allCallsOn: literal1 and: literal2)
		name: literal1 printString , ' -and- ' , literal2 printString! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:36'!
browseAllCallsOn: aLiteral localTo: aClass
	"Create and schedule a message browser on each method in or below the given class that refers to
	aLiteral. For example, Smalltalk browseAllCallsOn: #open:label:."

	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>browseAllCallsOn:localTo:'.

	aClass ifNil: [ ^self inform: 'no selected class' ].

	(aLiteral isKindOf: LookupKey)
		ifTrue: [self browseMessageList: (aClass allLocalCallsOn: aLiteral) asSortedCollection
					name: 'Users of ' , aLiteral key, ' local to ', aClass name
					autoSelect: aLiteral key]
		ifFalse: [self browseMessageList: (aClass allLocalCallsOn: aLiteral) asSortedCollection
					name: 'Senders of ' , aLiteral, ' local to ', aClass name
					autoSelect: aLiteral keywords first]! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:36'!
browseAllImplementorsOf: selector
	"Create and schedule a message browser on each method that implements 
	the message whose selector is the argument, selector. For example, 
	Smalltalk browseAllImplementorsOf: #at:put:."

	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>browseAllImplementorsOf:'.
	^self 
		browseMessageList: (self allImplementorsOf: selector) 
		name: 'Implementors of ' , selector! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:37'!
browseAllImplementorsOf: selector localTo: aClass
	"Create and schedule a message browser on each method in or below the given class
	that implements the message whose selector is the argument, selector. For example, 
	Smalltalk browseAllImplementorsOf: #at:put: localTo: Dictionary."

	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>browseAllImplementorsOf:localTo:'.
	aClass ifNil: [ ^self inform: 'no class selected' ].
	^self browseMessageList: (self allImplementorsOf: selector localTo: aClass)
		name: 'Implementors of ' , selector, ' local to ', aClass name! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:37'!
browseAllImplementorsOfList: selectorList
	"Create and schedule a message browser on each method that implements 
	the message whose selector is in the argument selectorList. For example, 
	Smalltalk browseAllImplementorsOf: #(at:put: size).
	1/16/96 sw: defer to the titled version"

	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>browseAllImplementorsOfList:'.
	self browseAllImplementorsOfList: selectorList title: 'Implementors of all'! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:37'!
browseAllImplementorsOfList: selectorList title: aTitle
	"Create and schedule a message browser on each method that implements the message whose selector is in the argument selectorList. For example,  Smalltalk browseAllImplementorsOf: #(at:put: size).
	1/16/96 sw: this variant adds the title argument.
	1/24/96 sw: use a SortedCollection
	2/1/96 sw: show normal cursor"

	| implementorLists flattenedList |
	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>browseAllImplementorsOfList:title:'.
	implementorLists _ selectorList collect: [:each | self allImplementorsOf: each].
	flattenedList _ SortedCollection new.
	implementorLists do: [:each | flattenedList addAll: each].
	Cursor normal show.
	^ self browseMessageList: flattenedList name: aTitle! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:38'!
browseAllMethodsInCategory: category 

	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>browseAllMethodsInCategory:'.
	^self browseMessageList: (self allMethodsInCategory: category)
		name: category! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:38'!
browseAllObjectReferencesTo: anObject except: objectsToExclude ifNone: aBlock
	"Bring up a list inspector on the objects that point to anObject.
	If there are none, then evaluate aBlock on anObject.  "

	| aList shortName |
	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>browseAllObjectReferencesTo:except:ifNone:'.
	aList _ Smalltalk pointersTo: anObject except: objectsToExclude.
	aList size > 0 ifFalse: [^ aBlock value: anObject].
	shortName _ (anObject name ifNil: [anObject printString]) contractTo: 20.
	OrderedCollectionInspector openOn: aList withEvalPane: false
		withLabel: 'Objects pointing to ', shortName.! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:38'!
browseAllSelect: aBlock
	"Create and schedule a message browser on each method that, when used 
	as the block argument to aBlock gives a true result. For example, 
	Smalltalk browseAllSelect: [:method | method numLiterals > 10]."

	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>browseAllSelect:'.
	^self browseMessageList: (self allSelect: aBlock) name: 'selected messages'! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:39'!
browseAllSelect: aBlock name: aName autoSelect: autoSelectString
	"Create and schedule a message browser on each method that, when used 
	as the block argument to aBlock gives a true result.   Do not return an #DoIt traces."

	"Smalltalk browseAllSelect: [:method | method numLiterals > 10] name: 'Methods with more than 10 literals' autoSelect: 'isDigit'"

	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>browseAllSelect:name:autoSelect:'.
	^ self 
		browseMessageList: (self allSelectNoDoits: aBlock)
		name: aName
		autoSelect: autoSelectString! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:39'!
browseAllUnSentMessages
	"Create and schedule a message browser on each method whose message is  not sent in any method in the system."

	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>browseAllUnSentMessages'.
	self browseAllImplementorsOfList: self allUnSentMessages title: 'Messages implemented but not sent'

"Smalltalk browseAllUnSentMessages"! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:40'!
browseAllUnimplementedCalls
	"Create and schedule a message browser on each method that includes a 
	message that is not implemented in any object in the system."

	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>browseAllUnimplementedCalls'.
	^self browseMessageList: self allUnimplementedCalls name: 'Unimplemented calls'! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:40'!
browseClassCommentsWithString: aString
	"Smalltalk browseClassCommentsWithString: 'my instances' "
	"Launch a message list browser on all class comments containing aString as a substring."

	| caseSensitive suffix list |
	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>browseClassCommentsWithString:'.
	suffix _ (caseSensitive _ Sensor shiftPressed)
		ifTrue: [' (case-sensitive)']
		ifFalse: [' (use shift for case-sensitive)'].
	list _ Set new.
	Cursor wait showWhile: [
		Smalltalk allClassesDo: [:class | 
			(class organization classComment asString findString: aString 
							startingAt: 1 caseSensitive: caseSensitive) > 0 ifTrue: [
								list add: (
									MethodReference new
										setStandardClass: class
										methodSymbol: #Comment
								)
							]
		]
	].
	^ self 
		browseMessageList: list asSortedCollection
		name: 'Class comments containing ' , aString printString , suffix
		autoSelect: aString! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:40'!
browseClassesWithNamesContaining: aString caseSensitive: caseSensitive 
	"Smalltalk browseClassesWithNamesContaining: 'eMorph' caseSensitive: true "
	"Launch a class-list list browser on all classes whose names containg aString as a substring."

	| suffix aList |
	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>browseClassesWithNamesContaining:caseSensitive:'.
	suffix _ caseSensitive
				ifTrue: [' (case-sensitive)']
				ifFalse: [' (use shift for case-sensitive)'].
	aList _ OrderedCollection new.
	Cursor wait
		showWhile: [Smalltalk
				allClassesDo: [:class | (class name includesSubstring: aString caseSensitive: caseSensitive)
						ifTrue: [aList add: class name]]].
	aList size > 0
		ifTrue: [ClassListBrowser new initForClassesNamed: aList asSet asSortedArray title: 'Classes whose names contain ' , aString , suffix]! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:40'!
browseMessageList: messageList name: label 
	"Create and schedule a MessageSet browser on messageList."

	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>browseMessageList:name:'.
	^ self 
		browseMessageList: messageList 
		name: label 
		autoSelect: nil! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:41'!
browseMessageList: messageList name: labelString autoSelect: autoSelectString
	| title aSize |
	"Create and schedule a MessageSet browser on the message list."

	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>browseMessageList:name:autoSelect:'.
	messageList size = 0 ifTrue: 
		[^ (PopUpMenu labels: ' OK ')
				startUpWithCaption: 'There are no
' , labelString].

	title _ (aSize _ messageList size) > 1
		ifFalse:	[labelString]
		ifTrue:	[ labelString, ' [', aSize printString, ']'].

	MessageSet 
		openMessageList: messageList 
		name: title 
		autoSelect: autoSelectString! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:44'!
browseMethodsWhoseNamesContain: aString
	"Launch a tool which shows all methods whose names contain the given string; case-insensitive.
	1/16/1996 sw, at the dawn of Squeak: this was the classic implementation that provided the underpinning for the 'method names containing it' (cmd-shift-W) feature that has always been in Squeak -- the feature that later inspired the MethodFinder (aka SelectorBrowser).
	sw 7/27/2001:	Switched to showing a MessageNames tool rather than a message-list browser, if in Morphic."

	| aList |
	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>browseMethodsWhoseNamesContain:'.
	Smalltalk isMorphic
		ifFalse:
			[aList _ Symbol selectorsContaining: aString.
			aList size > 0 ifTrue:
				[self browseAllImplementorsOfList: aList asSortedCollection title: 'Methods whose names contain ''', aString, '''']]

		ifTrue:
			[(MessageNames methodBrowserSearchingFor: aString) openInWorld]
	! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:44'!
browseMethodsWithSourceString: aString
	"Smalltalk browseMethodsWithSourceString: 'SourceString' "
	"Launch a browser on all methods whose source code contains aString as a substring."

	| caseSensitive suffix |
	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>browseMethodsWithSourceString:'.
	suffix _ (caseSensitive _ Sensor shiftPressed)
		ifTrue: [' (case-sensitive)']
		ifFalse: [' (use shift for case-sensitive)'].
	^ self 
		browseMessageList: (self allMethodsWithSourceString: aString matchCase: caseSensitive)
		name: 'Methods containing ' , aString printString , suffix
		autoSelect: aString! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:47'!
browseMethodsWithString: aString
	"Launch a browser on all methods that contain string literals with aString as a substring. The search is case-insensitive, unless the shift key is pressed, in which case the search is case-sensitive."

	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>browseMethodsWithString:'.

	'string for testing'.
	^ self browseMethodsWithString: aString matchCase: Sensor shiftPressed

	"Smalltalk browseMethodsWithString: 'Testing' matchCase: false"
	"Smalltalk browseMethodsWithString: 'Testing' matchCase: true"! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:47'!
browseMethodsWithString: aString matchCase: caseSensitive
	"Launch a browser on all methods that contain string literals with aString as a substring. Make the search case-sensitive or insensitive as dictated by the caseSensitive boolean parameter"

	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>browseMethodsWithString:matchCase:'.
	self browseAllSelect:
			[:method |
				method  hasLiteralSuchThat: [:lit |
					lit class == String and:
					[lit includesSubstring: aString caseSensitive: caseSensitive]]]
		name:  'Methods with string ', aString printString, (caseSensitive ifTrue: [' (case-sensitive)'] ifFalse: [' (case-insensitive)'])
		autoSelect: aString.
! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:48'!
browseObsoleteReferences  

	| references |
	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>browseObsoleteReferences'.
	references _ OrderedCollection new.
	(LookupKey allSubInstances select:
		[:x | ((x value isKindOf: Behavior) and: ['AnOb*' match: x value name]) or:
		['AnOb*' match: x value class name]]) 
		do: [:x | references addAll: (Smalltalk allCallsOn: x)].
	Smalltalk 
		browseMessageList: references 
		name: 'References to Obsolete Classes'! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'sd 6/9/2003 17:19'!
changes
	"Answer the current system ChangeSet."

	self deprecatedExplanation: 'This method is deprecated please use ChangeSet current instead'.
	^ChangeSet current! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'sd 6/20/2003 22:40'!
compareTallyIn: beforeFileName to: afterFileName

	| answer s beforeDict a afterDict allKeys before after diff |
	self deprecatedExplanation: 'Use SpaceTally>>compareTallyIn: beforeFileName to: afterFileName'.
	beforeDict _ Dictionary new.
	s _ FileDirectory default fileNamed: beforeFileName.
	[s atEnd] whileFalse: [
		a _ Array readFrom: s nextLine.
		beforeDict at: a first put: a allButFirst.
	].
	s close.
	afterDict _ Dictionary new.
	s _ FileDirectory default fileNamed: afterFileName.
	[s atEnd] whileFalse: [
		a _ Array readFrom: s nextLine.
		afterDict at: a first put: a allButFirst.
	].
	s close.
	answer _ WriteStream on: String new.
	allKeys _ (Set new addAll: beforeDict keys; addAll: afterDict keys; yourself) asSortedCollection.
	allKeys do: [ :each |
		before _ beforeDict at: each ifAbsent: [#(0 0 0)].
		after _ afterDict at: each ifAbsent: [#(0 0 0)].
		diff _ before with: after collect: [ :vBefore :vAfter | vAfter - vBefore].
		diff = #(0 0 0) ifFalse: [
			answer nextPutAll: each,'  ',diff printString; cr.
		].
	].
	StringHolder new contents: answer contents; openLabel: 'space diffs'.
	


! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:48'!
disablePowerManager

	self deprecatedExplanation: 'Method Deprecated: Use PowerManagement class>>disablePowerManager'.
	self disablePowerManager: 1! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:52'!
disablePowerManager: anInteger
	"Disable/Enable the architectures power manager by passing in nonzero or zero"

	self deprecatedExplanation: 'Method Deprecated: Use PowerManagement class>>disablePowerManager:'.
	self deprecatedDisablePowerManager: anInteger! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:52'!
enablePowerManager

	self deprecatedExplanation: 'Method Deprecated: Use PowerManagement class>>enablePowerManager'.
	self disablePowerManager: 0! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:53'!
forceDisplayUpdate
	"Obsolete. Send this message to Display instead of Smalltalk."

	self deprecatedExplanation: 'Method Deprecated: Use DisplayScreen>>forceDisplayUpdate'.
	Display forceDisplayUpdate.
! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'sd 6/7/2003 19:49'!
fullScreenMode: aBoolean
	"On platforms that support it, set full-screen mode to the value of the argument. (Note: you'll need to restore the Display after calling this primitive."
	"Smalltalk fullScreenMode: true. Display newDepth: Display depth"

	self deprecatedExplanation: 'Method deprecated>>Use DisplayScreen>>fullScreenMode:. Note that normally you should not invoke this method directly and alone but following the idiom  Display fullScreenMode: true. Display newDepth: Display depth.'
! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'nk 7/7/2003 18:36'!
gifReaderClass
	"Answer, if present, a class to handle the importing of GIF files from disk.
	If none, return nil."

	self deprecatedExplanation: 'refer directly to GIFReadWriter.'.
	^self at: #GIFReadWriter ifAbsent: [nil]! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'yo 7/17/2003 00:23'!
imageImports
	"Answer the global dictionary of image imports, creating it if necessary.  7/24/96 sw"

	"Smalltalk viewImageImports"
	self deprecatedExplanation: 'You should use the following expression Imports default imports to get the dictionary of all imported images'.
	(self includesKey: #ImageImports)
		ifFalse:
			[self at: #ImageImports put: Dictionary new].
	^ self at: #ImageImports! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'nk 7/7/2003 18:24'!
imageReaderClass
	"Answer, if present, a class to handle the importing of various graphic image files
	from disk. If none, return nil.
	It's not clear what the old logic that checked for ImageReader
	actually being a class was trying to fix."

	self deprecatedExplanation: 'refer directly to ImageReadWriter.'.
	^self at: #ImageReadWriter ifAbsent: [nil]! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:53'!
isThereAnImplementorOf: aSelector  
	"Answer true if there is at least one implementor of the selector found in the system, false if there are no implementors"

	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>isThereAnImplementorOf:'.
	self allBehaviorsDo:
		[:class |
			(class includesSelector: aSelector)
				ifTrue: [^ true]].
	^ false
"
Smalltalk isThereAnImplementorOf: #contents.
Smalltalk isThereAnImplementorOf: #nobodyImplementsThis.
"! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:54'!
itsyVoltage
	"On the Itsy, answer the approximate Vcc voltage. The Itsy will shut itself down when this value reaches 2.0 volts. This method allows one to build a readout of the current battery condition."

	| n |
	self deprecatedExplanation: 'Method Deprecated: Use PowerManagement class>>itsyVoltage'.
	n _ self getSystemAttribute: 1200.
	n ifNil: [^ 'no voltage attribute'].
	^ ((n asNumber / 150.0) roundTo: 0.01) asString, ' volts'
! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'nk 7/7/2003 18:40'!
jpegReaderClass
	"Answer, if present, a class to handle the importing of JPEG files from disk.
	If none, return nil."

	self deprecatedExplanation: 'refer directly to JPEGReadWriter.'.
	^self at: #JPEGReadWriter ifAbsent: [nil]! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:54'!
numberOfImplementorsOf: aSelector  
	"Answer a count of the implementors of the given selector found in the system"

	| aCount |
	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>numberOfImplementorsOf:'.
	aCount _ 0.
	self allBehaviorsDo:
		[:class |
			(class includesSelector: aSelector)
				ifTrue: [aCount _ aCount + 1]].
	^ aCount
"
Smalltalk numberOfImplementorsOf: #contents.
Smalltalk numberOfImplementorsOf: #nobodyImplementsThis. 
Smalltalk numberOfimplementorsOf: #numberOfImplementorsOf:.
"! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'sd 6/20/2003 23:05'!
printSpaceAnalysis	"Smalltalk printSpaceAnalysis"

	self deprecatedExplanation: 'Use SpaceTally>>printSpaceAnalysis'. 
	^ Smalltalk printSpaceAnalysis: 0 on: 'STspace.text'
! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'sd 6/20/2003 23:06'!
printSpaceAnalysis: threshold on: fileName
	"Smalltalk printSpaceAnalysis: 1000 on: 'STspace.text0'"

	"If threshold > 0, then only those classes with more than that number
	of instances will be shown, and they will be sorted by total instance space.
	If threshold = 0, then all classes will appear, sorted by name."
	| f codeSpace instCount instSpace totalCodeSpace totalInstCount totalInstSpace eltSize n stats totalPercent percent |
	self deprecatedExplanation: 'Use SpaceTally>>printSpaceAnalysis: threshold on: fileName instead'. 
	Smalltalk garbageCollect.
	totalCodeSpace _ totalInstCount _ totalInstSpace _ n _ 0.
	stats _ OrderedCollection new.
'Taking statistics...'
	displayProgressAt: Sensor cursorPoint
	from: 0 to: self classNames size
	during: [:bar |
	self allClassesDo:
		[:cl | codeSpace _ cl spaceUsed.
		bar value: (n _ n+1).
		Smalltalk garbageCollectMost.
		instCount _ cl instanceCount.
		instSpace _ (cl indexIfCompact > 0 ifTrue: [4] ifFalse: [8])*instCount. "Object headers"
		cl isVariable
			ifTrue: [eltSize _ cl isBytes ifTrue: [1] ifFalse: [4].
					cl allInstancesDo: [:x | instSpace _ instSpace + (x basicSize*eltSize)]]
			ifFalse: [instSpace _ instSpace + (cl instSize*instCount*4)].
		stats add: (Array with: cl name with: codeSpace) , (Array with: instCount with: instSpace).
		totalCodeSpace _ totalCodeSpace + codeSpace.
		totalInstCount _ totalInstCount + instCount.
		totalInstSpace _ totalInstSpace + instSpace]].
	totalPercent _ 0.0.

	f _ FileStream newFileNamed: fileName.
	f timeStamp.
	f nextPutAll: ('Class' padded: #right to: 30 with: $ );
			nextPutAll: ('code space' padded: #left to: 12 with: $ );
			nextPutAll: ('# instances' padded: #left to: 12 with: $ );
			nextPutAll: ('inst space' padded: #left to: 12 with: $ );
			nextPutAll: ('percent' padded: #left to: 8 with: $ ); cr.

	threshold > 0 ifTrue:
		["If inst count threshold > 0, then sort by space"
		stats _ (stats select: [:s | s third >= threshold or: [s fourth > (totalInstSpace // 500)]])
				asSortedCollection: [:s :s2 | s fourth > s2 fourth]].

	stats do:
		[:s | f nextPutAll: (s first padded: #right to: 30 with: $ );
			nextPutAll: (s second printString padded: #left to: 12 with: $ );
			nextPutAll: (s third printString padded: #left to: 12 with: $ );
			nextPutAll: (s fourth printString padded: #left to: 14 with: $ ).
		percent _ s fourth*100.0/totalInstSpace roundTo: 0.1.
		totalPercent _ totalPercent + percent.
		percent >= 0.1 ifTrue:
			[f nextPutAll: (percent printString padded: #left to: 8 with: $ )].
		f cr].

	f cr; nextPutAll: ('Total' padded: #right to: 30 with: $ );
		nextPutAll: (totalCodeSpace printString padded: #left to: 12 with: $ );
		nextPutAll: (totalInstCount printString padded: #left to: 12 with: $ );
		nextPutAll: (totalInstSpace printString padded: #left to: 14 with: $ );
		nextPutAll: ((totalPercent roundTo: 0.1) printString padded: #left to: 8 with: $ ).
	f close! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'sd 6/20/2003 23:08'!
printSpaceDifferenceFrom: fileName1 to: fileName2
	"For differential results, run printSpaceAnalysis twice with different fileNames,
	then run this method...
		Smalltalk printSpaceAnalysis: 0 on: 'STspace.text1'.
			--- do something that uses space here ---
		Smalltalk printSpaceAnalysis: 0 on: 'STspace.text2'.
		Smalltalk printSpaceDifferenceFrom: 'STspace.text1' to: 'STspace.text2'
"
	| f coll1 coll2 item |
	self deprecatedExplanation: 'Use SpaceTally>>printSpaceDifferenceFrom: fileName1 to: fileName2 instead'.
	f _ FileStream readOnlyFileNamed: fileName1.
	coll1 _ OrderedCollection new.
	[f atEnd] whileFalse: [coll1 add: (f upTo: Character cr)].
	f close.
	f _ FileStream readOnlyFileNamed: fileName2.
	coll2 _ OrderedCollection new.
	[f atEnd] whileFalse:
		[item _ (f upTo: Character cr).
		((coll1 includes: item) and: [(item endsWith: 'percent') not])
			ifTrue: [coll1 remove: item]
			ifFalse: [coll2 add: item]].
	f close.
	(StringHolder new contents: (String streamContents: 
			[:s | 
			s nextPutAll: fileName1; cr.
			coll1 do: [:x | s nextPutAll: x; cr].
			s cr; cr.
			s nextPutAll: fileName2; cr.
			coll2 do: [:x | s nextPutAll: x; cr]]))
		openLabel: 'Differential Space Analysis'.
! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:54'!
selectorsWithAnyImplementorsIn: selectorList  
	"Answer the subset of the given list which represent method selectors which have at least one implementor in the system."

	| good |
	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>allSelectorsWithAnyImplementorsIn:'.
	good _ OrderedCollection new.
	self allBehaviorsDo:
		[:class |
			selectorList do:
				[:aSelector |
					(class includesSelector: aSelector) ifTrue:
						[good add: aSelector]]].
	^ good asSet asSortedArray

"
Smalltalk selectorsWithAnyImplementorsIn: #( contents contents: nuts)
"! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:54'!
showMenuOf: selectorCollection withFirstItem: firstItem ifChosenDo: choiceBlock
	"Show a sorted menu of the given selectors, preceded by firstItem, and all
	abbreviated to 40 characters.  Evaluate choiceBlock if a message is chosen."

	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>showMenuOf:withFirstItem:ifChosenDo:'.
	^ self showMenuOf: selectorCollection withFirstItem: firstItem ifChosenDo: choiceBlock withCaption: nil! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:55'!
showMenuOf: selectorCollection withFirstItem: firstItem ifChosenDo: choiceBlock withCaption: aCaption
	"Show a sorted menu of the given selectors, preceded by firstItem, and all abbreviated to 40 characters.  Use aCaption as the menu title, if it is not nil.  Evaluate choiceBlock if a message is chosen."

	| index menuLabels sortedList aMenu |
	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>showMenuOf:withFirstItem:ifChosenDo:  withCaption:'.
	sortedList _ selectorCollection asSortedCollection.
	menuLabels _ String streamContents: 
		[:strm | strm nextPutAll: (firstItem contractTo: 40).
		sortedList do: [:sel | strm cr; nextPutAll: (sel contractTo: 40)]].
	aMenu _ PopUpMenu labels: menuLabels lines: #(1).
	index _ aCaption ifNotNil: [aMenu startUpWithCaption: aCaption] ifNil: [aMenu startUp].
	index = 1 ifTrue: [choiceBlock value: firstItem].
	index > 1 ifTrue: [choiceBlock value: (sortedList at: index - 1)]! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:55'!
sortAllCategories

	self deprecatedExplanation: 'Method Deprecated: Use ClassOrganizer>>sortAllCategories'.
	ClassOrganizer allInstances do: [:x | x sortCategories]

! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'sd 6/20/2003 22:33'!
spaceForInstancesOf: aClass
	"Answer the number of bytes consumed by all instances of the given class, including thier object headers."

	| instCount isCompact instVarBytes bytesPerElement contentBytes headerBytes total |
	self deprecatedExplanation: 'Use instead SpaceTally>>spaceForInstancesOf:'.
	instCount _ aClass instanceCount.
	instCount = 0 ifTrue: [^ 0].
	isCompact _ aClass indexIfCompact > 0.
	instVarBytes _ aClass instSize * 4.
	aClass isVariable
		ifTrue: [
			bytesPerElement _ aClass isBytes ifTrue: [1] ifFalse: [4].
			total _ 0.
			aClass allInstancesDo: [:inst |
				contentBytes _ instVarBytes + (inst size * bytesPerElement).
				headerBytes _
					contentBytes > 255
						ifTrue: [12]
						ifFalse: [isCompact ifTrue: [4] ifFalse: [8]].
				total _ total + headerBytes + contentBytes].
			^ total]
		ifFalse: [
			headerBytes _
				instVarBytes > 255
					ifTrue: [12]
					ifFalse: [isCompact ifTrue: [4] ifFalse: [8]].
			^ instCount * (headerBytes + instVarBytes)].
! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'sd 6/20/2003 22:31'!
spaceTally
	"Answer a collection of tuples representing the memory space (in bytes) consumed by the code and instances of each class in the system. The tuples have the form:
	<class> <code size> <instance count> <space for instances>
Code sizes do not currently report memory consumed by class variables. The arrays used to record these results consume a relatively insignificant amount of space."
	"(Smalltalk spaceTally asSortedCollection: [:a :b | a last > b last]) asArray"

	| results entry c |
	self deprecatedExplanation: 'Use SpaceTally>>systemWideSpaceTally'.

	"pre-allocate array of entries for results"
	results _ OrderedCollection new: self size.
	self do: [:cl |
		(cl isKindOf: Class) ifTrue: [
			entry _ Array new: 4.
			entry at: 1 put: cl.
			results add: entry]].
	results _ results asArray.

	Smalltalk garbageCollect.
	1 to: results size do: [:i |
		entry _ results at: i.
		c _ entry at: 1.
		entry at: 2 put: c spaceUsed.
		entry at: 3 put: c instanceCount.
		entry at: 4 put: (self spaceForInstancesOf: c).
		Smalltalk garbageCollectMost].
	^ results
! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'sd 6/20/2003 22:29'!
spaceTallyTo: aFileName

	| answer s |
	self deprecatedExplanation: 'Use SpaceTally>> saveTo: instead'. 
	Smalltalk garbageCollect.
	answer _ Smalltalk spaceTally.
	(FileDirectory default fileExists: aFileName) ifTrue: [
		FileDirectory default deleteFileNamed: aFileName
	].
	s _ FileDirectory default fileNamed: aFileName.
	answer do: [ :each | s nextPutAll: each printString; cr].
	s close

! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 15:55'!
unimplemented
	"Answer an Array of each message that is sent by an expression in a method but is not implemented by any object in the system."

	| all unimplemented entry |
	self deprecatedExplanation: 'Method Deprecated: Use SystemNavigation>>unimplemented'.
	all _ IdentitySet new: Symbol instanceCount * 2.
	Cursor wait showWhile: 
		[self allBehaviorsDo: [:cl | cl selectorsDo: [:aSelector | all add: aSelector]]].

	unimplemented _ IdentityDictionary new.
	Cursor execute showWhile: [
		self allBehaviorsDo: [:cl |
			 cl selectorsDo: [:sel |
				(cl compiledMethodAt: sel) messages do: [:m |
					(all includes: m) ifFalse: [
						entry _ unimplemented at: m ifAbsent: [Array new].
						entry _ entry copyWith: (cl name, '>', sel).
						unimplemented at: m put: entry]]]]].

	"remove some clutter from the result:"
	#(DoItIn: primitiveFail diffedVersionContents uniformWindowColors macOptionKeyAllowed)
		do: [:sel | unimplemented removeKey: sel ifAbsent: []].

	"these messages are not sent when running on the Zaurus:"
	#(channelData defaultAALevel: from:title: fromWaveFileNamed: imageFormOfSize:forFrame:
invokeAt:in: loadedFrames originalSamplingRate printInstructionsOn: processFile
readFrom:mergeIfStereo:skipDataChunk: samples samples:samplingRate: samplesRemaining
storeAIFFSamples:samplingRate:on: windowMenuWithLabels:colorPattern:targets:selections:title:)
		do: [:sel | unimplemented removeKey: sel ifAbsent: []].

	^ unimplemented
! !

!SystemDictionary methodsFor: 'deprecated' stamp: 'rw 5/13/2003 16:08'!
viewImageImports
	"Open up a special Form inspector on the dictionary of graphical imports."

	| imageImports |
	self deprecatedExplanation: 'Use instead the Imports default viewImage'.
	(imageImports _ self imageImports) size == 0 ifTrue:
		[^ self inform: 
'The ImageImports repository is currently empty,
so there is nothing to view at this time.  You can
use a file list to import graphics from external files
into ImageImports, and once you have done that,
you will find this command more interesting.'].

	imageImports inspectFormsWithLabel: 'Graphical Imports'! !


!Utilities class methodsFor: 'deprecated' stamp: 'nk 7/3/2003 18:50'!
actualTextStyles
	"Answer dictionary whose keys are the names of styles in the system and whose values are the actual styles"
	"TextStyle actualTextStyles"

	self deprecatedExplanation: 'Use TextStyle actualTextStyles instead.'.
	^TextStyle actualTextStyles! !

!Utilities class methodsFor: 'deprecated' stamp: 'nk 7/3/2003 18:50'!
chooseTTCFontSize: args
	"Adds the new-size selection to the font size menu."

	self deprecatedExplanation: 'Use TextStyle chooseTTCFontSize: instead.'.
	^TextStyle chooseTTCFontSize: args! !

!Utilities class methodsFor: 'deprecated' stamp: 'nk 7/3/2003 18:50'!
fontArrayForStyle: aName
	"TextStyle fontArrayForStyle: 'Arial'"
	"TextStyle fontPointSizesFor: 'NewYork'"

	self deprecatedExplanation: 'Use TextStyle fontArrayForStyle: instead.'.
	^TextStyle fontArrayForStyle: aName! !

!Utilities class methodsFor: 'deprecated' stamp: 'nk 7/3/2003 18:50'!
fontMenuForStyle: styleName target: target selector: selector

	self deprecatedExplanation: 'Use TextStyle fontMenuForStyle: target: selector: instead.'.
	^TextStyle fontMenuForStyle: styleName target: target selector: selector! !

!Utilities class methodsFor: 'deprecated' stamp: 'nk 7/3/2003 18:42'!
fontPointSizesFor: aName
	"TextStyle fontPointSizesFor: 'Arial'"
	"TextStyle fontPointSizesFor: 'NewYork'"

	self deprecatedExplanation: 'Use TextStyle fontPointSizesFor: instead.'.
	^TextStyle fontPointSizesFor: aName! !

!Utilities class methodsFor: 'deprecated' stamp: 'nk 7/3/2003 18:43'!
fontSizeSummary
	"TextStyle fontSizeSummary"

	self deprecatedExplanation: 'Use TextStyle fontSizeSummary instead.'.
	TextStyle fontSizeSummary! !

!Utilities class methodsFor: 'deprecated' stamp: 'nk 7/3/2003 18:49'!
fontSizesFor: aName
	"TextStyle fontSizesFor: 'Arial'"

	self deprecatedExplanation: 'Use TextStyle fontSizesFor: instead.'.
	^TextStyle fontSizesFor: aName! !

!Utilities class methodsFor: 'deprecated' stamp: 'nk 7/3/2003 18:49'!
fontWidthsFor: aName
	"TextStyle fontWidthsFor: 'Arial'"

	self deprecatedExplanation: 'Use TextStyle fontWidthsFor: instead.'.
	^TextStyle fontWidthsFor: aName! !

!Utilities class methodsFor: 'deprecated' stamp: 'nk 7/3/2003 18:49'!
knownTextStyles
	"TextStyle knownTextStyles"

	self deprecatedExplanation: 'Use TextStyle knownTextStyles instead.'.
	^TextStyle knownTextStyles! !

!Utilities class methodsFor: 'deprecated' stamp: 'nk 7/3/2003 18:49'!
mvcPromptForFont: aPrompt andSendTo: aTarget withSelector: aSelector
	"TextStyle mvcPromptForFont: 'Choose system font style' andSendTo: TextStyle withSelector: #setSystemFontTo:"

	self deprecatedExplanation: 'Use TextStyle mvcPromptForFont: andSendTo: withSelector:  instead.'.
	^TextStyle mvcPromptForFont: aPrompt andSendTo: aTarget withSelector: aSelector! !

!Utilities class methodsFor: 'deprecated' stamp: 'nk 7/3/2003 18:49'!
pointSizesFor: aName
	"TextStyle pointSizesFor: 'New York'"

	self deprecatedExplanation: 'Use TextStyle pointSizesFor: instead.'.
	^TextStyle pointSizesFor: aName! !

!Utilities class methodsFor: 'deprecated' stamp: 'nk 7/3/2003 18:48'!
promptForFont: aPrompt andSendTo: aTarget withSelector: aSelector
	"TextStyle promptForFont: 'Choose system font:' andSendTo: Preferences withSelector: #setSystemFontTo:"
	"NOTE: Morphic ONLY!!!!"

	self deprecatedExplanation: 'Use TextStyle promptForFont: andSendTo: withSelector:  instead.'.
	^TextStyle promptForFont: aPrompt andSendTo: aTarget withSelector: aSelector! !

