'From Squeak3.6 of ''6 October 2003'' [latest update: #5429] on 29 June 2004 at 10:54:16 pm'!

!BlockContext methodsFor: 'controlling' stamp: 'apb 3/31/2000 15:47'!
repeatForever
	^ [true] whileTrue: [self value]! !


!Delay methodsFor: 'accessing'!
delayDuration
	"Answer the receiver's instance variable delayDuration."

	^delayDuration! !


!SketchMorph methodsFor: 'initialization' stamp: 'Rik 3/1/2004 15:14'!
initialize
	^ self initializeWith: self thumbnailForm! !

!SketchMorph methodsFor: 'initialization' stamp: 'Rik 3/1/2004 15:12'!
initializeToStandAlone
	super initializeToStandAlone.
	self initializeWith: self thumbnailForm

! !

!SketchMorph methodsFor: 'initialization' stamp: 'Rik 3/1/2004 15:11'!
thumbnailForm
	^(ScriptingSystem formAtKey: 'Painting') deepCopy

! !


!TestCase methodsFor: 'Running' stamp: 'nk 8/6/2003 08:45'!
openDebuggerOnFailingTestMethod
	| guineaPig context compiledMethod debugger |
	compiledMethod _ self class compiledMethodAt: self selector.
	guineaPig _ [ self performTest ] newProcess.
	context _ guineaPig suspendedContext.
	debugger _ Debugger new
		process: guineaPig
		controller: ((Smalltalk isMorphic not and: [ScheduledControllers inActiveControllerProcess])
				ifTrue: [ScheduledControllers activeController]
				ifFalse: [nil])
		context: context
		isolationHead: nil.
	debugger openFullNoSuspendLabel: 'Debug failed test ', self printString.
	[debugger interruptedContext method == compiledMethod]
		whileFalse: [debugger send].
! !


!TestCase class methodsFor: 'Building Suites' stamp: 'nk 4/21/2002 10:59'!
addTestsFor: classNameString toSuite: suite

	| cls  |
	cls _ Smalltalk at: classNameString ifAbsent: [ ^suite ].
	^cls isAbstract 
		ifTrue:  [
			cls allSubclasses do: [ :each |
				each isAbstract ifFalse: [
					each addToSuiteFromSelectors: suite ] ].
			suite]
		ifFalse: [ cls addToSuiteFromSelectors: suite ]
! !

!TestCase class methodsFor: 'Building Suites' stamp: 'nk 4/21/2002 10:51'!
addToSuite: suite fromMethods: testMethods 
	testMethods do:  [ :selector | 
			suite addTest: (self selector: selector) ].
	^suite! !

!TestCase class methodsFor: 'Building Suites' stamp: 'nk 4/21/2002 16:37'!
addToSuiteFromSelectors: suite
	^self addToSuite: suite fromMethods: (self shouldInheritSelectors
		ifTrue: [ self allTestSelectors ]
		ifFalse: [self testSelectors ])! !

!TestCase class methodsFor: 'Building Suites' stamp: 'nk 12/23/2002 07:40'!
buildSuite
	| suite |
	suite _ TestSuite new.
	^ self isAbstract
		ifTrue: [
			suite name: self name asString.
			self allSubclasses
				do: [:each | each isAbstract
						ifFalse: [each addToSuiteFromSelectors: suite]].
			suite]
		ifFalse: [self addToSuiteFromSelectors: suite]! !

!TestCase class methodsFor: 'Building Suites' stamp: 'nk 4/21/2002 10:52'!
buildSuiteFromMethods: testMethods 
	| suite |
	suite _ (TestSuite new)
				name: self name asString;
				yourself.
	^self addToSuite: suite fromMethods: testMethods! !

