'From Squeak3.7beta of ''1 April 2004'' [latest update: #5967] on 30 June 2004 at 9:02:27 am'!
"Change Set:		InfoPipeMeddleNC
Date:			30 June 2004
Author:			Rik

These changes were applied to code lifted from Ned. Beware of update anomalies."!


!Morph methodsFor: '*connectors-queries' stamp: 'Rik 5/18/2004 16:37'!
connectedConstraints
	"Answer the constraints that have me as an input"
	| retval |
	retval _ self valueOfProperty: #connectedConstraints ifAbsent: [ ^EmptyArray ].
	retval _ retval reject: [ :ea | ea isNil ].
	retval isEmpty ifTrue: [ self removeProperty: #connectedConstraints ].
	^retval! !


!NCConnectorMorph methodsFor: 'event handling' stamp: 'Rik 4/13/2004 17:12'!
enterHandlingDrop

	| potentialConnections nextConnection hand |
	self removeDropShadow.
	self stopMonitoringEnd.
	Cursor normal show.
	self startStepping.

	"First, detach any ends that were following the hand."
	constraints do: [ :ea |
		ea input ifNotNilDo: [ :m | m isHandMorph ifTrue: [
				hand _ m.
				ea connectToNothing ] ].
		ea removeDropShadow
	].

	"Then find which ends we should potentially try to connect"
	potentialConnections _ constraints select: [ :ea | ea input isNil ].

	(self isWiring and: [ potentialConnections size = 2 ])
		ifTrue: [
			nextConnection _ potentialConnections second.
			potentialConnections _ potentialConnections copyFrom: 1 to: 1
		].

	potentialConnections do: [ :constraint | | localPoint targets |
		localPoint _ self griddedPoint: constraint targetPoint.
		targets _ self connectionTargetsAt: localPoint for: constraint.
		targets notEmpty
			ifTrue: [ Sensor shiftPressed
				ifFalse: [ constraint attachTo: targets first at: localPoint ]
				ifTrue: [ constraint attachTo: targets last at: localPoint  ] ]
			ifFalse: [ constraint connectToNothing; forceRedraw  ].
	].

	self changed; layoutChanged.

	(self isWiring and: [ nextConnection notNil ])
		ifTrue: [ | evt label pos |
			hand ifNil: [ hand _ self currentHand ].
			evt _ hand lastEvent.
			pos _ self griddedPoint: (self globalPointToLocal: evt position).
			potentialConnections first lastTargetPoint: pos. 
			nextConnection center: pos.
			self visible: true.
			label _ self valueOfProperty: #wiringLabel.
			label ifNotNil: [
				self removeProperty: #wiringLabel.
				label visible: true.
			].
			Cursor normal show.
			self setProperty: #triggeredWireFinish toValue: pos.
			fsm trigger: #wireFinish withArguments: { nextConnection . evt }.
		]
		ifFalse: [ self determineConnectionState ].

	self reduceVertices.
! !

!NCConnectorMorph methodsFor: 'initialization' stamp: 'Rik 3/7/2004 23:31'!
constraint1
	^(NCLineEndConstraintMorph new line: line firstVertex: true otherMorph: nil)
		 connectToNearestPoint;
		center: 0@0;
		lastTargetPoint: 0@0;
		yourself! !

!NCConnectorMorph methodsFor: 'initialization' stamp: 'Rik 3/7/2004 23:31'!
constraint2
	^(NCLineEndConstraintMorph new line: line firstVertex: false otherMorph: nil)
		connectToNearestPoint;
		center: line vertices second;
		lastTargetPoint: line vertices second;
		yourself! !

!NCConnectorMorph methodsFor: 'initialization' stamp: 'Rik 3/4/2004 12:42'!
initialLine
	^PolygonMorph vertices: { 0@0 . 50@0 } color: Color black borderWidth: 2 borderColor: Color black.! !

!NCConnectorMorph methodsFor: 'initialization' stamp: 'Rik 3/7/2004 23:32'!
initialize
	super initialize.

	self initializeFSM.

	super color: Color transparent.
	line _ self initialLine.
	constraints _ Array with: (self constraint1) with: (self constraint2).
	self addAllMorphs: constraints.
	self addMorphBack: line.
! !


!NCConnectorMorph class methodsFor: 'instance creation' stamp: 'nk 6/15/2002 16:38'!
supplementaryPartsDescriptions

	^ {
DescriptionForPartsBin
		formalName: 'Association'
		categoryList: #(UML)
		documentation: 'A class association for UML Class Diagrams'
		globalReceiverSymbol: #NCConnectorMorph
		nativitySelector: #newAssociation.

DescriptionForPartsBin
		formalName: 'DirectionalAssociation'
		categoryList: #(UML)
		documentation: 'A class association for UML Class Diagrams'
		globalReceiverSymbol: #NCConnectorMorph
		nativitySelector: #newDirectionalAssociation.

DescriptionForPartsBin
		formalName: 'Generalization'
		categoryList: #(UML)
		documentation: 'An inheritance (generalization) connection for UML Class Diagrams'
		globalReceiverSymbol: #NCConnectorMorph
		nativitySelector: #newGeneralizationRelationship .

DescriptionForPartsBin
		formalName: 'StateTransition'
		categoryList: #(UML)
		documentation: 'A state transition for UML State Diagrams'
		globalReceiverSymbol: #NCConnectorMorph
		nativitySelector: #newStateTransition  .

DescriptionForPartsBin
		formalName: 'Implementation'
		categoryList: #(UML)
		documentation: 'An implementation relationship for UML Class Diagrams'
		globalReceiverSymbol: #NCConnectorMorph
		nativitySelector: #newImplementationRelationship .

DescriptionForPartsBin
		formalName: 'Connector'
		categoryList: #(Connectors)
		documentation: 'A basic Connector'
		globalReceiverSymbol: #NCConnectorMorph
		nativitySelector: #newStandAlone .

DescriptionForPartsBin
		formalName: 'Empty Flap'
		categoryList: #(Connectors)
		documentation: 'An empty Flap that works like the Connectors flap'
		globalReceiverSymbol: #Flaps
		nativitySelector: #newNCPartsBinFlap  .

DescriptionForPartsBin
		formalName: 'Class Diagram Flap'
		categoryList: #(Connectors)
		documentation: 'A Flap for UML Class Diagrams'
		globalReceiverSymbol: #Flaps
		nativitySelector: #newClassDiagramConnectorsFlap   .

DescriptionForPartsBin
		formalName: 'State Diagram Flap'
		categoryList: #(Connectors)
		documentation: 'A Flap for UML State Diagrams'
		globalReceiverSymbol: #Flaps
		nativitySelector: #newFSMConnectorsFlap   .

DescriptionForPartsBin
		formalName: 'Connectors Flap'
		categoryList: #(Connectors)
		documentation: 'A Flap with some basic Connectors'
		globalReceiverSymbol: #Flaps
		nativitySelector: #newConnectorsFlap   .
}! !


!NCMakerButton methodsFor: 'initialization' stamp: 'Rik 3/5/2004 16:58'!
initialize
	super initialize.
	self initializeNCMakerButton! !

!NCMakerButton methodsFor: 'initialization' stamp: 'Rik 3/5/2004 16:58'!
initializeNCMakerButton
	self
		color: Color veryLightGray;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutPolicy: TableLayout new;
		listDirection: #topToBottom;
		listCentering: #center;
		wrapCentering: #center;
		enableDragNDrop;
		borderWidth: 2;
		borderRaised;
		actionSelector: #openInHand.
! !

