'From Squeak3.7beta of ''1 April 2004'' [latest update: #5967] on 30 June 2004 at 10:13:57 am'!
"Change Set:		Infopipes-2003
Date:			June 2004
Author:			Rik

what's left of what Rik found after separating Connectors (NC), s2s, Midi, and general meddling"!

Magnitude subclass: #InfoPipe
	instanceVariableNames: 'uid label latency ports pb'
	classVariableNames: 'LastUid'
	poolDictionaries: ''
	category: 'InfoPipes-Basic'!

!InfoPipe commentStamp: 'Rik 6/26/2004 18:26' prior: 0!
These old InfoPipes still serve as test-platforms for the Pb* hierarchy.
That is, they are treated as a set of legacy components or otherwise externally-controlled components.
--------------------------------------------------------------------------------------

This is the abstracct superclass for all of the InfoPipe classes.
No instances of this class are ever created. It exists to encapsulate
common state and behavior for its subclasses.



There are three kinds of methods in InfoPipe:
		-- abstract methods, whose body is "self subclassResponsibility".
 Subclases must define these
		-- hook methods, which are given a default implementation in InfoPipe,
but which subclasses are expected to redefine if they want different
	behavior.  initializePorts is an example.

		-- support methods, which we do not anticipate that subclasses will need to override.
		

Of course, we may be wrong. :-)

apb 2000.4.20!

InfoPipe subclass: #Buffer
	instanceVariableNames: 'contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Basic'!

!Buffer commentStamp: '<historical>' prior: 0!
This is the superclass for various kinds of InfoPipe buffers.


What buffers have in common is that they relieve the pressure created by
pumps.  That is, a pump connected to the input of a buffer may fill the buffer,
but it will never cause items to flow out of the buffer to the buffer's output.  Instead,
the buffer may overflow or continue to fill indefinitely.

If you want to empty a Buffer, connect a Pump to its output, directly or indirectly.!

Buffer subclass: #BoundedBuffer
	instanceVariableNames: 'capacity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Other'!

!BoundedBuffer commentStamp: '<historical>' prior: 0!
BoundedBuffer is a buffer of bounded size; the current size can be changed by sending the 'capacity: aNUmberOfItems' message.
The defaultCapacity can be changed in subclasses by overriding the defaultCapacity message.
The behavior should the buffer fill up can be changed by overriding the 
'overflow: theExtraItem' message.


!

InfoPipe subclass: #CompoundPipe
	instanceVariableNames: 'components activeComponents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Compound'!

!CompoundPipe commentStamp: '<historical>' prior: 0!
A CompoundPipe encapsulates a variable number (> 0) of InfoPipe components.  A CompoundPipe is constructed from a set of infopipes that are connected together.  From the outside, the CompoundPipe can be treated as a "black box", that is, like a simple InfoPipe component.

This is all very well, except for messages like latency:.  What does it mean to set the latency of a CompoundPipe?


instance variables:
components -- an orderedCollection of all the components, might not be needed
activeComponents  --  all the pumps in the compound pipe!

BoundedBuffer subclass: #ControlBuffer
	instanceVariableNames: 'upstreamPump afterChange'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Other'!
InfoPipe subclass: #Defragmentor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Other'!
Defragmentor subclass: #EagerDefragmentor
	instanceVariableNames: 'mutex producerTurn consumerTurn puller assembledItem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Other'!
Object subclass: #InfoPipeExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Examples'!

!InfoPipeExamples commentStamp: '<historical>' prior: 0!
Look on the class side for some example InfoPipes.!

InfoPipeExamples class
	instanceVariableNames: 'rm ro'!
Defragmentor subclass: #LazyDefragmentor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Other'!
InfoPipe subclass: #MergePipe
	instanceVariableNames: 'mergeNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Basic'!

!MergePipe commentStamp: '<historical>' prior: 0!
MergePipe are pipes with multi inports and single outport.

When you push at any inport, an item will be pushed to the outport. When you pull from the outport, it will try to get an item from each inport. 

instance variable:
mergeNumber  -- the number of inports for this merge pipe!

MergePipe subclass: #MixTee
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Basic'!
Object subclass: #Mode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Modes'!

!Mode commentStamp: '<historical>' prior: 0!
The Mode of a port is decided by its owner infopipe. The inport and the outport of a Pump are both Active. The inport and the outport of a Pipe are not fixed but they must be opposite and will be decided when they are connected. Other infopipes have Passive ports. !

SoleInstanceMode subclass: #Active
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Modes'!

!Active commentStamp: '<historical>' prior: 0!
An Active Inport calls other infopipes' pull methods.
An Active Outport calls other infopipes' push methods.!

Mode subclass: #InverseMode
	instanceVariableNames: 'opposite'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Modes'!

!InverseMode commentStamp: '<historical>' prior: 0!
An InverseMode is not fixed but it has to be opposite to some VarMode. If its opposite is unified, it is unified. 

instance variable:
opposite -- the opposite VarMode of this InverseMode!

Object subclass: #Monitor
	instanceVariableNames: 'mutex ownerProcess nestingLevel defaultQueue queueDict queuesMutex monitor interval monitored controled '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Monitoring'!
BoundedBuffer subclass: #NetPipe
	instanceVariableNames: 'remoteSys ipAddress proxyPort socket proxyProcess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Network'!
SoleInstanceMode subclass: #Passive
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Modes'!

!Passive commentStamp: '<historical>' prior: 0!
A Passive inport has a push method ready for other infopipes to call. 
A Passive outPort has a pull method ready for other infopipes to call.!

InfoPipe subclass: #Pipe
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Basic'!

!Pipe commentStamp: '<historical>' prior: 0!
Objects of this class are simple pipes of zero capacity.  They can be used to connect 
other InfoPipes together.  In this simulation, they have zero latency and infinite bandwidth,
so they are not very useful!!!

Pipe subclass: #Dropper
	instanceVariableNames: 'dropCondition numberDropped'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Other'!

!Dropper commentStamp: '<historical>' prior: 0!
An instances of Dropper is a Pipe that may or may not drop the item that is pushed
into it.  It has no storage, and so the decision is either to drop the item 
or to immediately push it to the sink.

The method 'dropCondition: aPredicate' is used to initialize the drop condition.  'aPredicate'
is a one argument block, which is given the current item as argument, and which should
answer true or false.

The default dropCondition is false.!

Pipe subclass: #Filter
	instanceVariableNames: 'function'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Other'!

!Filter commentStamp: '<historical>' prior: 0!
A Filter is an infopoe that can transform the item flowing through it. 

instance variable: 
function  --  the transform function

This class hasn't been completed.!

Pipe subclass: #MutableFilter
	instanceVariableNames: 'transferFunction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Mutable'!
MutableFilter subclass: #MutableFilterNN
	instanceVariableNames: 'buffer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Mutable'!
MutableFilter subclass: #MutableFilterNP
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Mutable'!
MutableFilter subclass: #MutableFilterPN
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Mutable'!
MutableFilter subclass: #MutableFilterPP
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Mutable'!
Monitor subclass: #PlugableMonitor
	instanceVariableNames: 'action'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Monitoring'!
Object subclass: #Port
	instanceVariableNames: 'mode owner connectedTo recentValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Ports'!

!Port commentStamp: '<historical>' prior: 0!
This is the superclass of all kinds of ports. Ports are the connectors of infopipes. An infopipe may have multi in ports and multi out ports. A port is associated with a name so it can be identified.

When we say two infopipes are connected, in fact it is the outport of one infopipe is connected to the inport of another infopipe.

instance variables:
owner -- the infopipe that this port belongs to.
connectedTo -- the port that this port connected to. 
mode  -- a port can have one of these three modes:
          Active: the port (actually, the owner of the port) actively requests data from its neighbous
          Passive: the port (actually, the owner of the port) passsively wait for its neighbouors requesting data 
          Var: could be Active or Passive, depnding on how it is connected.
          The type system will prevent two ports with the same mode (both are acitve or both are passive) from being connected.!

Port subclass: #InPort
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Ports'!

!InPort commentStamp: '<historical>' prior: 0!
These are ports at the input end of an infopipe.!

InPort subclass: #CompoundInPort
	instanceVariableNames: 'pseudoOwner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Ports'!

!CompoundInPort commentStamp: '<historical>' prior: 0!
These are ports at the input end of a compound pipe. Each CompoundInPort is corresponding to an inport of an upstream component.  

Each Compund inport has two owners: one is the real owner, which is the compound pipe it belongs to; one is the pseudo owner, whick is the psuedo pipe it belongs to. This pseudo pipe directs this port to a component within that compound pipe.!

InPort subclass: #NetInPort
	instanceVariableNames: 'socket'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Ports'!
Port subclass: #OpenEnd
	instanceVariableNames: ''
	classVariableNames: 'SingleInstance'
	poolDictionaries: ''
	category: 'InfoPipes-Ports'!

!OpenEnd commentStamp: '<historical>' prior: 0!
This is a special port. It has no owner, no mode, and it is connected to nothing. A port whose owner is not connected to another infopipe is connected to the open end. 

This is a singleton class.

Items pushed
out through an open end "drop onto the floor".  Attemps to pull from
an open end "suck air" (answer nil).!

Port subclass: #OutPort
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Ports'!

!OutPort commentStamp: '<historical>' prior: 0!
These are ports at the output end of an infopipe.!

OutPort subclass: #CompoundOutPort
	instanceVariableNames: 'pseudoOwner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Ports'!

!CompoundOutPort commentStamp: '<historical>' prior: 0!
These are ports at the output end of a compound pipe. Each CompoundOutPort is corresponding to an outport of a downstream component.

Each Compund outport has two owners: one is the real owner, which is the compound pipe it belongs to; one is the pseudo owner, whick is the psuedo pipe it belongs to. This pseudo pipe directs this port to a component within that compound pipe.!

InfoPipe subclass: #PseudoPipe
	instanceVariableNames: 'realPipe realPort'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Compound'!

!PseudoPipe commentStamp: '<historical>' prior: 0!
PseudoPipes exist to associate the ports of a CompoundPipe with the ports of its components. 

instance variables:
realPort  -- the port of the CompoundPipe this PseduoPipe associated wiht. A PseduoPipe can't be connected to a CompoundPort because the CompoundPort needs to be connected to the input or output of the CompoundPipe.!

PseudoPipe subclass: #InputPseudoPipe
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Compound'!

!InputPseudoPipe commentStamp: '<historical>' prior: 0!
An InputPseudoPipe associates an inport of a CompoundPipe with an inport of its upstream components. 

When pushing the inport of the CompoundPipe, it forwards the push message to the InputPseudoPipe, whose outport is connected to the inport of the component.

When pulling the inport of the component, it tryes to pull an item from the outport of the InputPseduoPipe, which forwards the pull message to the inport of the CompoundPipe.!

PseudoPipe subclass: #OutputPseudoPipe
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Compound'!

!OutputPseudoPipe commentStamp: '<historical>' prior: 0!
An OutputPseudoPipe associates an outport of a CompoundPipe with an outport of its downstream components. 

When pulling the outport of the CompoundPipe, it forwards the pull message to the OutputPseudoPipe, whose inport is connected to the outport of the component.

When pushing the outport of the component, it pushes an item to the inport of the OutputPseduoPipe, which forwards the push message to the outport of the CompoundPipe.!

InfoPipe subclass: #Pump
	instanceVariableNames: 'pumper strokeDelay strokes threadQueue threadSack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Basic'!

!Pump commentStamp: '<historical>' prior: 0!
Pumps provide the 'motive power' for a network of InfoPipes.  All of the other 
InfoPipe components are passive.  Pumps 'pull' items from their inputs, and
'push:' items into their outputs.  They may be thought of as 'presurising' the 
network.  Buffers relieve this pressure.  

In addition to a single stroke of the pump, pumps can start a background process 
so that they pump continuously.  Pumps are parameterized by the interval 
between strokes of the pump:

	startPumping: strokeIntervalInMilliseconds

The shorter the interval, the faster the rate of flow.  The stroke interval 
can be changed while the pump is running by sending the message 
'strokeInterval: anIntervalinMilliseconds'!

BoundedBuffer subclass: #ReorderingBuffer
	instanceVariableNames: 'myRandom'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Other'!

!ReorderingBuffer commentStamp: '<historical>' prior: 0!
Instances of ReorderingBuffer are BoundedBuffers from which items emerge 
in pseudo-random order.  To observe this effect, it is of course necessary for 
the buffer to contain more than one item.!

InfoPipe subclass: #Sink
	instanceVariableNames: 'bitBucket capacity itemCount interarrivalTimes lastArrivalTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Basic'!

!Sink commentStamp: '<historical>' prior: 0!
A Sink is an InfoPipe that catches items that emerge from other infopipes.
So that we can observe what it is catching, this sink keeps a bitBucket that 
records the last few items.  The size of the bitbucket can be set by sending 
the 'capacity: aNumberOfItems' message.

Other refinements of Sink might write the items to files, or display them on the
screen.
!

Sink subclass: #FileSink
	instanceVariableNames: 'fileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Other'!

!FileSink commentStamp: '<historical>' prior: 0!
An InfoPipe sink. The items pushed onto this object are writen to the underlying file.!

InfoPipe subclass: #Source
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Basic'!

!Source commentStamp: '<historical>' prior: 0!
A Source is an InfoPipe that provides other infopipes with items. It has no inport.!

Source subclass: #FileSource
	instanceVariableNames: 'fileName fileStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Other'!

!FileSource commentStamp: '<historical>' prior: 0!
The items for other infopies come from the underlying file.!

Source subclass: #SequentialSource
	instanceVariableNames: 'maxUsed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Other'!

!SequentialSource commentStamp: '<historical>' prior: 0!
A test source that emits strings that look like 

	'Item 1'
	'Item 2'

and so on in a rather boring and predictable sequence.!

InfoPipe subclass: #SplitPipe
	instanceVariableNames: 'splitNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Basic'!

!SplitPipe commentStamp: '<historical>' prior: 0!
SplitPipe are pipes with single inport and multi outports.

When you push at the input, an item will be pushed to each outport. When you pull from any outport, it will pull an item from the inport.

instance variable:
splitNubmer  --  the number of outports for this split pipe!

SplitPipe subclass: #MulticastTee
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Basic'!
SplitPipe subclass: #SwitchTee
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Basic'!
Mode subclass: #VarMode
	instanceVariableNames: 'myValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Modes'!

!VarMode commentStamp: '<historical>' prior: 0!
A VarMode has to be unified to Active or Passive before it begins to transfer information.

instance variables:
myValue -- if nil, this VarMode hasn't been unified. Otherwise, the Mode it is unified to.
!

MergePipe subclass: #ZipTee
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Basic'!

!ChatButtonMorph methodsFor: 'events' stamp: 'nk 3/25/2001 13:27'!
mouseDown: evt

	oldColor _ self fillStyle.
	self label: labelDown.
	self doButtonDownAction.

! !

!ChatButtonMorph methodsFor: 'events' stamp: 'nk 3/25/2001 13:27'!
mouseUp: evt

	"if oldColor nil, it signals that mouse had not gone DOWN inside me, e.g. because of a cmd-drag; in this case we want to avoid triggering the action!!"

	oldColor ifNil: [^self].
	self fillStyle: oldColor.
	(self containsPoint: evt cursorPoint) ifTrue: [
		self label: labelUp.
		self doButtonUpAction.
	].
! !


!InfoPipe methodsFor: 'clone' stamp: 'HJ 10/29/2000 00:29'!
clone
	| clone |
	clone _ self class new.
	self initializeClone: clone.
	^ clone! !

!InfoPipe methodsFor: 'clone' stamp: 'Rik 5/19/2004 01:25'!
copyPortsName: anInfoPipe 
	"For cloning.  
	Depends that a Dictionary answers keys and values in same order"
	|  portNames oldprts |	

	oldprts _ self ports values.
	portNames _ anInfoPipe ports keys as: OrderedCollection.
	ports _ Dictionary new.
	portNames with: oldprts do: [:name :port | ports at: name put: port].
! !

!InfoPipe methodsFor: 'pipe operations' stamp: 'HJ 10/29/2000 00:29'!
afterLatency: anObject 
	"answers an object, but only after wating for an appropriate 
	latency.
	Jitter could be introduced here too."
	latency ifNotNil: [latency wait].
	^ anObject! !

!InfoPipe methodsFor: 'pipe operations' stamp: 'HJ 10/29/2000 00:29'!
pull
	"answers anItem obtained from the pipe. Exactly where it comes 
	from depends 
	on the refinement. It might be pulled from this 
	pipe's source, it might be 
	obtained from an internal buffer, or 
	it might just be created out of thin air."
	self subclassResponsibility! !

!InfoPipe methodsFor: 'pipe operations' stamp: 'HJ 10/29/2000 00:29'!
push: anItem 
	"push anItem into the pipe. Exactly where it goes depends on 
	the refinement. 
	It might be pushed to this pipe's sink, it might 
	be buffered internally, or it
	might just be dropped on the floor."
	self subclassResponsibility! !

!InfoPipe methodsFor: 'user interface' stamp: 'HJ 10/29/2000 00:29'!
defaultLabelForInspector
	"Answer the default label to be used for an Inspector window on 
	the 
	receiver."
	^ self class name , ' ' , uid asString! !

!InfoPipe methodsFor: 'user interface' stamp: 'Rik 2/29/2004 21:26'!
inspectPipeline
	"Create Inspectors for me and for all of the Infopipes to which I am 
	connected. "
	| inspectors allPipes sw widget topos zoomController scrollee |
	sw _ SystemWindow new.
	widget _ ZoomAndScrollMorph new.
	widget extent: 820 @ (Display extent y - 200);
		 borderWidth: 0.
	widget color: Color red darker darker.
	sw	addMorph: widget   frame: (0 @ 0 corner: 1 @ 1).
	scrollee _ widget submorphs first submorphs first.
	zoomController _ ZoomAndScrollControllerMorph new
			setBalloonText: 'Drag in here to zoom, tilt and pan the page above'.
	zoomController target: widget.
	sw addMorphFront: zoomController.

	inspectors _ Dictionary new.
	topos _ TopoSort new.
	allPipes _ self allConnectedInfoPipes.
	allPipes do: [:pipe | topos add: pipe ].
	topos places do: [ :assn |
		inspectors at: assn value put: (
			assn value inspectorIn: scrollee at: (self placesFor: assn key)).
		].
	self addConnectorsOnPipes: allPipes widget: scrollee inspectors: inspectors.
	sw bounds: (20 @ 3 extent: (widget extent x@(Display extent y - 20))).
	sw openAsIsIn: sw currentWorld.
	^ sw! !

!InfoPipe methodsFor: 'user interface' stamp: 'apb 11/8/2001 18:47'!
inspector
	"Create and schedule an Inspector in which the user can examine the receiver's variables.
	Differs from the inspect (in Object) in that the inspector is returned."

	^ Inspector openOn: self withEvalPane: true! !

!InfoPipe methodsFor: 'user interface' stamp: 'apb 12/6/2001 16:24'!
inspectorIn: aMorph
	"Create and schedule an Inspector in which the user can examine the receiver's variables.
	Differs from the inspect (in Object) in that the inspector is returned."

	"Note that Inspector openAsMorphOn: does NOT actually open the morph!!"
	^ aMorph addMorph: (Inspector openAsMorphOn: self)! !

!InfoPipe methodsFor: 'user interface' stamp: 'Rik 2/21/2004 21:32'!
inspectorIn: aMorph at: location
	"Create and schedule an Inspector in which the user can examine the receiver's variables.
	Differs from the inspect (in Object) in that the inspector is returned."

	"Note that Inspector openAsMorphOn: does NOT actually open the morph!!"
	| inspWin |
	inspWin _ Inspector openAsMorphOn: self.
	inspWin extent: 250@270.
	inspWin position: location.
	inspWin model toggleIndex: 2.
	aMorph addMorph: inspWin.
	^ inspWin! !

!InfoPipe methodsFor: 'printing' stamp: 'Rik 2/29/2004 11:09'!
printOn: aStream 
	aStream nextPutAll: self class name; space.
	self printIDOn: aStream
! !

!InfoPipe methodsFor: 'initialize-release' stamp: 'Rik 3/18/2004 11:38'!
initialize
	self initializeUid.
	self initializePorts.
	self latency: 3.! !

!InfoPipe methodsFor: 'initialize-release' stamp: 'H.J 11/27/2000 23:44'!
initializeClone: aClone 
	aClone copyPortsName: self.
	^ aClone! !

!InfoPipe methodsFor: 'initialize-release' stamp: 'Rik 2/19/2004 01:42'!
initializePorts
	self initializeInPorts.
	self initializeOutPorts! !

!InfoPipe methodsFor: 'initialize-release' stamp: 'Rik 2/19/2004 13:28'!
initializeUid
	LastUid isNil ifTrue: [LastUid _ 44].
	uid _ LastUid _ LastUid + 1

"
LastUid _ nil
LastUid _ 12.5
"! !

!InfoPipe methodsFor: 'gomi' stamp: 'Rik 5/19/2004 02:02'!
inPortAt: name 
	self gomi.
	^self portNamed: name! !

!InfoPipe methodsFor: 'gomi' stamp: 'Rik 5/19/2004 02:06'!
nameOfInPort: anInPort 
self gomi. "unsent"
	^ self nameOfPort: anInPort ! !

!InfoPipe methodsFor: 'gomi' stamp: 'Rik 5/19/2004 01:30'!
nameOfOutPort: aPort 
self gomi. "unsent"
	^ self ports keyAtValue: aPort! !

!InfoPipe methodsFor: 'gomi' stamp: 'Rik 5/19/2004 01:28'!
openInPorts
	| result |
self gomi.
	result _ Set new.
	self inPorts do: [:eachPort |
		eachPort infoPipeConnectedTo 
			ifNil: [ result add: eachPort]].
	^ result! !

!InfoPipe methodsFor: 'gomi' stamp: 'Rik 5/19/2004 01:31'!
openOutPorts
self gomi. "unsent"! !

!InfoPipe methodsFor: 'gomi' stamp: 'Rik 5/19/2004 01:19'!
outPortAt: name 
self gomi.
	^self  portNamed: name! !

!InfoPipe methodsFor: 'gomi' stamp: 'Rik 5/19/2004 02:07'!
replaceInPortName: oldName with: newName 
	| port |
self gomi. "unsent"
	(self inPorts includesKey: newName)
		ifTrue: [self error: 'repeated names for inports']
		ifFalse: 
			[port _ self inPorts at: oldName.
			self inPorts removeKey: oldName.
			self inPorts at: newName put: port]! !

!InfoPipe methodsFor: 'gomi' stamp: 'Rik 5/19/2004 01:34'!
replaceOutPortName: oldName with: newName 
	| port |
self gomi. "only sender was a dubious one in a test"
	(self outPorts includesKey: newName)
		ifTrue: [self error: 'repeated names in outPorts']
		ifFalse: 
			[port _ self outPorts at: oldName.
			self outPorts removeKey: oldName.
			self outPorts at: newName put: port]! !

!InfoPipe methodsFor: 'accessing' stamp: 'Rik 2/19/2004 08:04'!
inConnectedTo
	^self inPorts collectNonNil: [ :ea | ea infoPipeConnectedTo] ! !

!InfoPipe methodsFor: 'accessing' stamp: 'Rik 5/19/2004 01:21'!
inPorts
	^self ports select: [ :each | each isInput]! !

!InfoPipe methodsFor: 'accessing' stamp: 'HJ 10/29/2000 00:30'!
latency
	^ (latency ifNil: [^ 0]) delayDuration! !

!InfoPipe methodsFor: 'accessing' stamp: 'HJ 10/29/2000 00:30'!
latency: timeInMilliseconds 
	timeInMilliseconds = 0
		ifTrue: [latency _ nil]
		ifFalse: [latency _ Delay forMilliseconds: timeInMilliseconds]! !

!InfoPipe methodsFor: 'accessing' stamp: 'Rik 2/17/2004 14:07'!
outConnectedTo
	^self outPorts collectNonNil: [ :ea | ea infoPipeConnectedTo] ! !

!InfoPipe methodsFor: 'accessing' stamp: 'Rik 5/19/2004 01:21'!
outPorts
	^self ports select: [ :each | each isOutput]! !

!InfoPipe methodsFor: 'testing' stamp: 'HJ 10/29/2000 00:31'!
isActive
	^ false! !

!InfoPipe methodsFor: 'configuration' stamp: 'H.J 11/15/2000 14:12'!
->> anInfoPipe 
	self outPort connect: anInfoPipe inPort.
	^ anInfoPipe! !

!InfoPipe methodsFor: 'configuration' stamp: 'H.J 11/21/2000 15:57'!
allConnectedInfoPipes
	^ self connectedInfoPipes: Set new! !

!InfoPipe methodsFor: 'configuration' stamp: 'Rik 5/19/2004 01:39'!
connectedInfoPipes: seen 
	| infoPipes |
	seen add: self.
	infoPipes _ Set new.
	infoPipes add: self.
	self portsConnectedTo do: [:aBranch | (seen includes: aBranch)
			ifFalse: [infoPipes addAll: (aBranch connectedInfoPipes: seen)]].
	^ infoPipes! !

!InfoPipe methodsFor: 'networking' stamp: 'Rik 2/6/2004 14:41'!
exportAs: name 
	OrbControl export: self as: name asSymbol! !

!InfoPipe methodsFor: 're-ports' stamp: 'Rik 5/19/2004 01:09'!
inPort
	^ self portNamed: #input1! !

!InfoPipe methodsFor: 're-ports' stamp: 'Rik 5/19/2004 01:09'!
outPort
	^self portNamed: #output1! !


!Buffer methodsFor: 'private' stamp: 'HJ 10/29/2000 00:25'!
consume: anItem 
	contents addLast: anItem! !

!Buffer methodsFor: 'private' stamp: 'HJ 10/29/2000 00:25'!
produce
	contents isEmpty ifTrue: [^ nil].
	^ contents removeFirst! !

!Buffer methodsFor: 'pipe operations' stamp: 'Rik 2/2/2004 11:01'!
flush
| output |
self gomi.
	output push: self produce! !

!Buffer methodsFor: 'pipe operations' stamp: 'HJ 10/29/2000 00:26'!
pull
	^ self afterLatency: self produce! !

!Buffer methodsFor: 'pipe operations' stamp: 'HJ 10/29/2000 00:26'!
push: anItem 
	self consume: anItem! !

!Buffer methodsFor: 'initialization' stamp: 'HJ 10/29/2000 00:26'!
initialize
	super initialize.
	contents _ OrderedCollection new! !


!BoundedBuffer methodsFor: 'control operations' stamp: 'HJ 10/29/2000 00:25'!
fullness
	"Answers the fraction of my capacity that is in use"
	^ contents size / capacity! !

!BoundedBuffer methodsFor: 'initialization' stamp: 'HJ 10/29/2000 00:25'!
defaultCapacity
	^ 8! !

!BoundedBuffer methodsFor: 'initialization' stamp: 'HJ 10/29/2000 00:25'!
initialize
	super initialize.
	self capacity: self defaultCapacity! !

!BoundedBuffer methodsFor: 'initialization' stamp: 'HJ 10/29/2000 00:25'!
initializeClone: aClone 
	super initializeClone: aClone.
	aClone capacity: self capacity! !

!BoundedBuffer methodsFor: 'private' stamp: 'HJ 10/29/2000 00:25'!
consume: anItem 
	contents size >= capacity
		ifTrue: [self overflow: anItem]
		ifFalse: [contents addLast: anItem]! !

!BoundedBuffer methodsFor: 'exception handling' stamp: 'HJ 10/29/2000 00:25'!
overflow: anAdditionalItem 
	"a hook to more sophisticated exception handling"
	^ self! !

!BoundedBuffer methodsFor: 'accessing' stamp: 'HJ 10/29/2000 00:25'!
capacity
	"Answer the receiver's instance variable capacity."
	^ capacity! !

!BoundedBuffer methodsFor: 'accessing' stamp: 'HJ 10/29/2000 00:25'!
capacity: aNumberofItems 
	aNumberofItems >= 0 & (aNumberofItems isKindOf: Integer)
		ifTrue: [capacity _ aNumberofItems]
		ifFalse: [self error: 'my capacity must be a non-negative integer']! !


!CompoundPipe methodsFor: 'initialization' stamp: 'H.J 11/20/2000 12:08'!
initialize
	super initialize.
	activeComponents _ OrderedCollection new.
	components do: [:each | each isActive ifTrue: [activeComponents add: each]]! !

!CompoundPipe methodsFor: 'initialization' stamp: 'Rik 5/19/2004 02:04'!
initializePorts
	| prt tempName |
	super initializePorts.
	components do: [:ecmp | 
		ecmp openPorts do: 
			[:aPort | 
			prt _ aPort attachTo: self.
			tempName _ ecmp nameOfPort: aPort.
			(self ports includesKey: tempName)
				ifTrue: [self error: 'duplicate port name' , tempName asString].
			self portNamed: tempName put: prt].
		]
" 
components reject: [ :cmp | cmp openPorts isEmpty]
"! !

!CompoundPipe methodsFor: 'private' stamp: 'H.J 11/20/2000 12:03'!
components: infoPipeSet 
	components _ infoPipeSet! !

!CompoundPipe methodsFor: 'pump operations' stamp: 'HJ 10/29/2000 00:27'!
faster
	activeComponents do: [:c | c faster]! !

!CompoundPipe methodsFor: 'pump operations' stamp: 'HJ 10/29/2000 00:27'!
slower
	activeComponents do: [:c | c slower]! !

!CompoundPipe methodsFor: 'pump operations' stamp: 'HJ 10/29/2000 00:27'!
startPumping
	activeComponents do: [:c | c startPumping]! !

!CompoundPipe methodsFor: 'pump operations' stamp: 'HJ 10/29/2000 00:27'!
startPumping: millisecondInterval 
	activeComponents do: [:c | c startPumping: millisecondInterval]! !

!CompoundPipe methodsFor: 'pump operations' stamp: 'HJ 10/29/2000 00:27'!
stopPumping
	activeComponents do: [:c | c stopPumping]! !

!CompoundPipe methodsFor: 'pump operations' stamp: 'HJ 10/29/2000 00:27'!
stroke
	activeComponents do: [:c | c stroke]! !

!CompoundPipe methodsFor: 'pump operations' stamp: 'HJ 10/29/2000 00:27'!
stroke: aNumber 
	aNumber timesRepeat: [self stroke]! !

!CompoundPipe methodsFor: 'pump operations' stamp: 'HJ 10/29/2000 00:27'!
strokeInterval
	^ activeComponents anyOne strokeInterval! !

!CompoundPipe methodsFor: 'pump operations' stamp: 'HJ 10/29/2000 00:27'!
strokeInterval: millisecondInterval 
	activeComponents do: [:c | c strokeInterval: millisecondInterval]! !

!CompoundPipe methodsFor: 'testing' stamp: 'HJ 10/29/2000 00:27'!
isActive
	^ activeComponents size ~= 0! !

!CompoundPipe methodsFor: 'clone' stamp: 'Rik 5/19/2004 01:54'!
clone
	| old2new inName newTo oldTo |
	old2new _ Dictionary new.
	components do: [:p | old2new at: p put: p clone].
	old2new keysAndValuesDo: [:oldFrom :newFrom | oldFrom outPorts
			keysAndValuesDo: 
				[:outName :outPort | 
				oldTo _ outPort infoPipeConnectedTo.
				newTo _ old2new at: oldTo ifAbsent: [nil].
				newTo
					ifNotNil: 
						[inName _ oldTo inPorts keyAtValue: outPort connectedTo.
						(newFrom portNamed: outName)
							connect: (newTo portNamed: inName)]]].
	^ CompoundPipe fromComponent: (old2new at: components anyOne)! !

!CompoundPipe methodsFor: 'pipe operations' stamp: 'H.J 11/20/2000 15:01'!
pull
	self shouldNotImplement! !

!CompoundPipe methodsFor: 'pipe operations' stamp: 'H.J 11/20/2000 15:00'!
push: anItem 
	self shouldNotImplement! !


!ControlBuffer methodsFor: 'accessing' stamp: 'HJ 3/28/2001 17:14'!
afterChange
^ afterChange! !

!ControlBuffer methodsFor: 'accessing' stamp: 'HJ 3/28/2001 17:14'!
afterChange: aNumber
	afterChange _ aNumber! !

!ControlBuffer methodsFor: 'accessing' stamp: 'HJ 3/28/2001 17:15'!
increaseAfterChange
	afterChange _ afterChange + 1! !

!ControlBuffer methodsFor: 'accessing' stamp: 'HJ 3/28/2001 16:07'!
upstreamPump
	^ upstreamPump! !

!ControlBuffer methodsFor: 'accessing' stamp: 'HJ 3/28/2001 16:07'!
upstreamPump: aPump 
	upstreamPump _ aPump! !

!ControlBuffer methodsFor: 'private' stamp: 'HJ 3/28/2001 19:30'!
consume: anItem 
	self fullness > 0.9 & (self afterChange > 10)
		ifTrue: [self upstreamPump slower.
			self afterChange: 0].
	self increaseAfterChange.
	super consume: anItem! !

!ControlBuffer methodsFor: 'private' stamp: 'HJ 3/28/2001 19:30'!
produce
	self fullness < 0.1 & (self afterChange > 10)
		ifTrue: [self upstreamPump faster.
			self afterChange: 0].
	self increaseAfterChange.
	^ super produce! !

!ControlBuffer methodsFor: 'initialization' stamp: 'HJ 3/28/2001 19:25'!
initialize
	super initialize.
    afterChange _ 0.! !


!Defragmentor methodsFor: 'defragmenting'!
assemble: i1 and: i2

	(Delay forMilliseconds: (self latency)) wait.
	^ '[', i1, ', ', i2, ']'! !


!EagerDefragmentor methodsFor: 'pipe operations' stamp: 'apb 1/8/2002 12:20'!
pull
	| answer |
	consumerTurn wait.
	answer _ mutex critical: [assembledItem].
	producerTurn signal.
	^ answer! !

!EagerDefragmentor methodsFor: 'initialization' stamp: 'apb 1/4/2002 12:52'!
initialize
	super initialize.
	self initializeProcess.! !

!EagerDefragmentor methodsFor: 'initialization' stamp: 'apb 1/8/2002 12:19'!
initializeProcess
	mutex _ Semaphore new signal.
	producerTurn _ Semaphore new signal.
	consumerTurn _ Semaphore new.
	puller _ [[| i1 i2 a | 
			producerTurn wait .
			i1 _ self inPort pull.
			i2 _ self inPort pull.
			a _  self assemble: i1 and: i2.
			mutex critical: [assembledItem _ a].
			consumerTurn signal] repeatForever ] fork! !


!InfoPipe class methodsFor: 'instance creation' stamp: 'HJ 10/29/2000 00:40'!
new
	^ self basicNew initialize! !


!CompoundPipe class methodsFor: 'instance creation' stamp: 'HJ 2/25/2001 23:33'!
from: anInfoPipeSet
	| c |
	c _ self basicNew.
	c components: anInfoPipeSet.
	c initialize.
	^ c! !

!CompoundPipe class methodsFor: 'instance creation' stamp: 'HJ 6/4/2001 14:09'!
fromComponent: anInfoPipe 
	| c |
	c _ self basicNew.
	c components: anInfoPipe allConnectedInfoPipes.
	c initialize.
	^ c! !


!InfoPipeExamples class methodsFor: 'netpipetest6' stamp: 'HJ 2/27/2001 00:50'!
readme6
	"The infopipe systems are the same as in testn1"
	"The configuration is similar to testy5. we will have a MergePipe 
	in system 4 and connect the two inports from sytem 1 and  
	system 3"
	"System 4 will be the dominate system"
	^ self! !

!InfoPipeExamples class methodsFor: 'netpipetest6' stamp: 'HJ 6/4/2001 18:28'!
setupDouglas6
	"InfoPipeExamples setupDouglas6"
	SequentialSource new exportAs: #source3.
	Pump new exportAs: #pump3! !

!InfoPipeExamples class methodsFor: 'netpipetest6' stamp: 'HJ 6/4/2001 18:30'!
setupState6
	"InfoPipeExamples setupState6"
	SequentialSource new exportAs: #source1.
	Pump new exportAs: #pump1! !

!InfoPipeExamples class methodsFor: 'netpipetest6' stamp: 'Rik 2004.5'!
testn6
	"InfoPipeExamples testn6"
	| source1 sink4 pump1 source3 pump3 netPipe4a netPipe4b pump4a pump4b merge4 |
	source1 _ 's2s://Infopipe1/source1' asRemoteObject.
	pump1 _ 's2s://Infopipe1/pump1' asRemoteObject.
	source3 _ 's2s://Infopipe3/source3' asRemoteObject.
	pump3 _ 's2s://Infopipe3/pump3' asRemoteObject.
	netPipe4a _ NetPipe from: 's2s://Infopipe1/'.
	netPipe4b _ NetPipe from: 's2s://Infopipe3/'.
	pump4a _ Pump new.
	pump4b _ Pump new.
	merge4 _ MixTee new.
	sink4 _ Sink new.
	source1 ->> pump1 ->> netPipe4a ->> pump4a.
	self halt.
	source3 ->> pump3 ->> netPipe4b ->> pump4b.
	pump4a outPort
		->> (merge4 inPort).
	pump4b outPort
		->> (merge4 portNamed: #input2).
	merge4 ->> sink4.
	pump1 startPumping: 1200.
	pump3 startPumping: 1200.
	pump4a startPumping: 1000.
	pump4b startPumping: 1500.
	sink4 inspect! !

!InfoPipeExamples class methodsFor: 'netpipetest5' stamp: 'HJ 2/27/2001 00:43'!
readme5
	"The infopipe systems are the same as in testn1"
	"The configuration is similar to testy4. we will have a SplitPipe  
	in system 1 and connect the two outports to sytem 2 and  
	system 4"
	"System 4 will be the dominate system"
	^ self! !

!InfoPipeExamples class methodsFor: 'netpipetest5' stamp: 'HJ 6/4/2001 18:30'!
setupState5
	"InfoPipeExamples setupState5"
	SequentialSource new exportAs: #source1.
	SwitchTee new exportAs: #split1.
	Pump new exportAs: #pump1a.
	Pump new exportAs: #pump1b.
	(NetPipe from: 's2s://Infopipe1/')
		exportAs: #netpipe2.
	Pump new exportAs: #pump2.
	Sink new exportAs: #sink2! !

!InfoPipeExamples class methodsFor: 'netpipetest5' stamp: 'Rik 2004.5'!
testn5
	"InfoPipeExamples testn5"
	| source1 netPipe2 netPipe4 pump4 sink4 split1 pump2 sink2 pump1a pump1b |
	source1 _ 's2s://Infopipe1/source1' asRemoteObject.
	pump1a _ 's2s://Infopipe1/pump1a' asRemoteObject.
	pump1b _ 's2s://Infopipe1/pump1b' asRemoteObject.
	split1 _ 's2s://Infopipe1/split1' asRemoteObject.
	netPipe2 _ 's2s://Infopipe2/netpipe2' asRemoteObject.
	pump2 _ 's2s://Infopipe2/pump2' asRemoteObject.
	sink2 _ 's2s://Infopipe2/sink2' asRemoteObject.
	netPipe4 _ NetPipe from: 's2s://Infopipe1/'.
	pump4 _ Pump new.
	sink4 _ Sink new.
	source1 ->> split1.
	(split1 outPort)
		->> pump1a inPort.
	(split1 portNamed: #output2)
		->> pump1b inPort.
	pump1a ->> netPipe2 ->> pump2 ->> sink2.
	pump1b ->> netPipe4 ->> pump4 ->> sink4.
	pump1a startPumping: 1200.
	pump1b startPumping: 1200.
	pump2 startPumping: 1000.
	pump4 startPumping: 1500.
	sink4 inspect! !

!InfoPipeExamples class methodsFor: 'netpipetest4' stamp: 'HJ 2/26/2001 16:40'!
readme4
	"The infopipe systems are the same as in testn1"
	"The configuration is similar to testy3. we will have a SplitPipe  
	in system 1 and connect the two outports to sytem 2 and  
	system 4"
	"System 4 will be the dominate system"
	^ self! !

!InfoPipeExamples class methodsFor: 'netpipetest4' stamp: 'HJ 6/4/2001 18:30'!
setupState4
	"InfoPipeExamples setupState4"
	SequentialSource new exportAs: #source1.
	Pump new exportAs: #pump1.
	SwitchTee new exportAs: #split1.
	(NetPipe from: 's2s://Infopipe1/')
		exportAs: #netpipe2.
	Pump new exportAs: #pump2.
	Sink new exportAs: #sink2! !

!InfoPipeExamples class methodsFor: 'netpipetest4' stamp: 'Rik 2004.5'!
testn4
	"InfoPipeExamples testn4"
	| source1 pump1 netPipe2 netPipe4 pump4 sink4 split1 pump2 sink2 |
	source1 _ 's2s://Infopipe1/source1' asRemoteObject.
	pump1 _ 's2s://Infopipe1/pump1' asRemoteObject.
	split1 _ 's2s://Infopipe1/split1' asRemoteObject.
	netPipe2 _ 's2s://Infopipe2/netpipe2' asRemoteObject.
	pump2 _ 's2s://Infopipe2/pump2' asRemoteObject.
	sink2 _ 's2s://Infopipe2/sink2' asRemoteObject.
	netPipe4 _ NetPipe from: 's2s://Infopipe1/'.
	pump4 _ Pump new.
	sink4 _ Sink new.
	source1 ->> pump1 ->> split1.
	(split1 outPort)
		->> netPipe2 inPort.
	(split1 portNamed: #output2)
		->> netPipe4 inPort.
	netPipe2 ->> pump2 ->> sink2.
	netPipe4 ->> pump4 ->> sink4.
	pump1 startPumping: 1200.
	pump2 startPumping: 1000.
	pump4 startPumping: 1500.
	sink4 inspect! !

!InfoPipeExamples class methodsFor: 'netpipetest3' stamp: 'HJ 2/21/2001 19:24'!
readme3
	"The infopipe systems are the same as in test1"
	"In this test, we will have a compound pipe in system 2 and crossing system 3"
	"System 4 will be the dominate system"
	^ self! !

!InfoPipeExamples class methodsFor: 'netpipetest3' stamp: 'HJ 6/4/2001 18:27'!
setupDouglas3
	"InfoPipeExamples setupDouglas3"
	(NetPipe from: 's2s://Infopipe2/')
		exportAs: #netpipe3.
	Pump new exportAs: #pump3! !

!InfoPipeExamples class methodsFor: 'netpipetest3' stamp: 'HJ 6/4/2001 18:30'!
setupState3
	"InfoPipeExamples setupState3"
	| c netpipe pumpa pumpb pipea pipeb set |
	SequentialSource new exportAs: #source1.
	Pump new exportAs: #pump1.
	(NetPipe from: 's2s://Infopipe1/')
		exportAs: #netpipe2.
	netpipe _ 's2s://Infopipe3/netpipe3' asRemoteObject.
	pumpa _ 's2s://Infopipe3/pump3' asRemoteObject.
	pumpb _ Pump new.
	pipea _ Pipe new.
	pipeb _ Pipe new.
	pumpb ->> pipea ->> pipeb ->> netpipe ->> pumpa.
	set _ Set new.
	set add: pipea.
	set add: pipeb.
	set add: pumpa.
	set add: pumpb.
	set add: netpipe.
	c _ CompoundPipe from: set.
	c exportAs: #compound2! !

!InfoPipeExamples class methodsFor: 'netpipetest3' stamp: 'HJ 6/4/2001 18:32'!
testn3
	"InfoPipeExamples testn3"
	| source1 pump1 netPipe2 compound2 netPipe4 pump4 sink4 |
	source1 _ 's2s://Infopipe1/source1' asRemoteObject.
	pump1 _ 's2s://Infopipe1/pump1' asRemoteObject.
	netPipe2 _ 's2s://Infopipe2/netpipe2' asRemoteObject.
	compound2 _ 's2s://Infopipe2/compound2' asRemoteObject.
	netPipe4 _ NetPipe from: 's2s://Infopipe3/'.
	pump4 _ Pump new.
	sink4 _ Sink new.
	source1 ->> pump1 ->> netPipe2 ->> compound2 ->> netPipe4 ->> pump4 ->> sink4.
	pump1 startPumping: 4000.
	compound2 startPumping: 4000.
	pump4 startPumping: 3500.
	sink4 inspect! !

!InfoPipeExamples class methodsFor: 'netpipetest2' stamp: 'HJ 2/21/2001 19:02'!
readme2
	"The infopipe systems are the same as in test1"
	"In this test, we will have a compound pipe in system 2"
	"System 4 will be the dominate system"
	^ self! !

!InfoPipeExamples class methodsFor: 'netpipetest2' stamp: 'HJ 6/4/2001 18:29'!
setupState2
	"InfoPipeExamples setupState2"
	| c |
	SequentialSource new exportAs: #source1.
	Pump new exportAs: #pump1.
	(NetPipe from: 's2s://Infopipe1/')
		exportAs: #netpipe2.
	c _ CompoundPipe from: Pump new ->> Pipe new ->> Pipe new ->> BoundedBuffer new ->> Pump new.
	c exportAs: #compound2! !

!InfoPipeExamples class methodsFor: 'netpipetest2' stamp: 'HJ 6/4/2001 18:32'!
testn2
	"InfoPipeExamples testn2"
	| source1 pump1 netPipe2 compound2 netPipe4 pump4 sink4 |
	source1 _ 's2s://Infopipe1/source1' asRemoteObject.
	pump1 _ 's2s://Infopipe1/pump1' asRemoteObject.
	netPipe2 _ 's2s://Infopipe2/netpipe2' asRemoteObject.
	compound2 _ 's2s://Infopipe2/compound2' asRemoteObject.
	netPipe4 _ NetPipe from: 's2s://Infopipe2/'.
	pump4 _ Pump new.
	sink4 _ Sink new.
	source1 ->> pump1 ->> netPipe2 ->> compound2 ->> netPipe4 ->> pump4 ->> sink4.
	pump1 startPumping: 4000.
	compound2 startPumping: 4000.
	pump4 startPumping: 3500.
	sink4 inspect! !

!InfoPipeExamples class methodsFor: 'netpipetest1' stamp: 'HJ 6/4/2001 18:26'!
setupDouglas
"InfoPipeExamples setupDouglas"
	(NetPipe from: 's2s://Infopipe2/')
		exportAs: #netpipe3.
	Pump new exportAs: #pump3! !

!InfoPipeExamples class methodsFor: 'netpipetest1' stamp: 'HJ 6/4/2001 18:29'!
setupState
	"InfoPipeExamples setupState"
	SequentialSource new exportAs: #source1.
	Pump new exportAs: #pump1.
	(NetPipe from: 's2s://Infopipe1/')
		exportAs: #netpipe2.
	Pump new exportAs: #pump2! !

!InfoPipeExamples class methodsFor: 'netpipetest1' stamp: 'HJ 6/4/2001 18:32'!
testn1
	"InfoPipeExamples testn1"
	| source1 pump1 netPipe2 pump2 netPipe3 pump3 netPipe4 pump4 sink4 |
	source1 _ 's2s://Infopipe1/source1' asRemoteObject.
	pump1 _ 's2s://Infopipe1/pump1' asRemoteObject.
	netPipe2 _ 's2s://Infopipe2/netpipe2' asRemoteObject.
	pump2 _ 's2s://Infopipe2/pump2' asRemoteObject.
	netPipe3 _ 's2s://Infopipe3/netpipe3' asRemoteObject.
	pump3 _ 's2s://Infopipe3/pump3' asRemoteObject.
	netPipe4 _ NetPipe from: 's2s://Infopipe3/'.
	pump4 _ Pump new.
	sink4 _ Sink new.
	source1 ->> pump1 ->> netPipe2 ->> pump2 ->> netPipe3 ->> pump3 ->> netPipe4 ->> pump4 ->> sink4.
	pump1 startPumping: 2000.
	pump2 startPumping: 2500.
	pump3 startPumping: 3000.
	pump4 startPumping: 3500.
	sink4 inspect! !

!InfoPipeExamples class methodsFor: 'netpipetest12' stamp: 'HJ 6/4/2001 18:29'!
setupDouglas12
	"InfoPipeExamples setupDouglas12"
	(NetPipe from: 's2s://Infopipe2/')
		exportAs: #netpipe3.
	Pump new exportAs: #pump3! !

!InfoPipeExamples class methodsFor: 'netpipetest12' stamp: 'HJ 6/4/2001 18:31'!
setupState12
	"InfoPipeExamples setupState12"
	(FileSource from: 'fix.txt')
		exportAs: #source1.
	Pump new exportAs: #pump1.
	(NetPipe from: 's2s://Infopipe1/')
		exportAs: #netpipe2.
	Pump new exportAs: #pump2! !

!InfoPipeExamples class methodsFor: 'netpipetest12' stamp: 'HJ 6/4/2001 18:34'!
testn12
	"InfoPipeExamples testn12"
	| source1 pump1 netPipe2 pump2 netPipe3 pump3 netPipe4 pump4 sink4 |
	source1 _ 's2s://Infopipe1/source1' asRemoteObject.
	pump1 _ 's2s://Infopipe1/pump1' asRemoteObject.
	netPipe2 _ 's2s://Infopipe2/netpipe2' asRemoteObject.
	pump2 _ 's2s://Infopipe2/pump2' asRemoteObject.
	netPipe3 _ 's2s://Infopipe3/netpipe3' asRemoteObject.
	pump3 _ 's2s://Infopipe3/pump3' asRemoteObject.
	netPipe4 _ NetPipe from: 's2s://Infopipe3/'.
	pump4 _ Pump new.
	sink4 _ FileSink on: 'destin'.
	source1 ->> pump1 ->> netPipe2 ->> pump2 ->> netPipe3 ->> pump3 ->> netPipe4 ->> pump4 ->> sink4.
	pump1 startPumping: 2000.
	pump2 startPumping: 2500.
	pump3 startPumping: 3000.
	pump4 startPumping: 3500! !

!InfoPipeExamples class methodsFor: 'netpipetest11' stamp: 'HJ 2/27/2001 16:18'!
readme11
	"The infopipe systems are the same as in testn1"
	"The configuration is similar to testc7. we will have a compound  
	pipe in system 1 consisting of a MergePipe, a netPipe, and a  
	splitpipe. The merge pipe is in system 1. The netpipe crosses  
	system 1 and 4. splitpipe is in sytem 4. We will have another  
	compound pipe in sytem4 containing this compound pipe and 
	another split pipe. There is name conflict in the two splitpipes" 
	"System 4 will be the dominate system"
	^ self! !

!InfoPipeExamples class methodsFor: 'netpipetest11' stamp: 'HJ 6/4/2001 18:28'!
setupDouglas11
	"InfoPipeExamples setupDouglas11"
	(NetPipe from: 's2s://Infopipe1/')
		exportAs: #netpipe4.
	SwitchTee new exportAs: #split4! !

!InfoPipeExamples class methodsFor: 'netpipetest11' stamp: 'HJ 6/4/2001 18:31'!
setupState11
	"InfoPipeExamples setupState11"
	| set merge1 netpipe4 split4 c |
	SequentialSource new exportAs: #source1a.
	SequentialSource new exportAs: #source1b.
	Pump new exportAs: #pump1a.
	Pump new exportAs: #pump1b.
	"below construct a compound pipe"
	merge1 _ MixTee new.
	netpipe4 _ 's2s://Infopipe4/netpipe4' asRemoteObject.
	split4 _ 's2s://Infopipe4/split4' asRemoteObject.
	merge1 ->> netpipe4 ->> split4.
	set _ Set new.
	set add: merge1.
	set add: netpipe4.
	set add: split4.
	c _ CompoundPipe from: set.
	c exportAs: #compound1! !

!InfoPipeExamples class methodsFor: 'netpipetest11' stamp: 'Rik 2004.5'!
testn11
	"InfoPipeExamples testn11"
	| pump4a pump4b source1a source1b pump1a pump1b c1 sink4a sink4b set c4 split4 sink4c pump4c |
	source1a _ 's2s://Infopipe1/source1a' asRemoteObject.
	source1b _ 's2s://Infopipe1/source1b' asRemoteObject.
	pump1a _ 's2s://Infopipe1/pump1a' asRemoteObject.
	pump1b _ 's2s://Infopipe1/pump1b' asRemoteObject.
	c1 _ 's2s://Infopipe1/compound1' asRemoteObject.
	split4 _ SwitchTee new.
	pump4a _ Pump new.
	pump4b _ Pump new.
	pump4c _ Pump new.
	sink4a _ Sink new.
	sink4b _ Sink new.
	sink4c _ Sink new.
	set _ Set new.
	(c1 outPort)
		->> split4 inPort.
	set add: c1.
	set add: split4.
	c4 _ CompoundPipe from: set.
	source1a ->> pump1a.
	source1b ->> pump1b.
	pump1a outPort
		->> (c4 inPort).
	pump1b outPort
		->> (c4 portNamed: #input2).
	(c4 portNamed: #output2)
		->> pump4b inPort.
	(c4 outPort)
		->> pump4a inPort.
	pump4a ->> sink4a.
	pump4b ->> sink4b.
	pump1a startPumping: 1200.
	pump1b startPumping: 1000.
	pump4a startPumping: 1000.
	pump4b startPumping: 1500.
	sink4a inspect.
	sink4b inspect! !

!InfoPipeExamples class methodsFor: 'netpipetest10' stamp: 'HJ 2/27/2001 15:38'!
readme10
	"The infopipe systems are the same as in testn1"
	"The configuration is similar to testc6. we will have a compound  
	pipe in system 1 consisting of a MergePipe, a netPipe, and a  
	splitpipe. The merge pipe is in system 1. The netpipe crosses  
	system 1 and 3. splitpipe is in sytem 3."
"We will have a compound pipe in system 2 consisting two pipes, two pumps, and a netpipe. Onf of the pump and the two pipes are in system 3. The other pump is in system 4. The netpipe is in system 3 and 4."

"We will have a compound pipe containing the above compound pipes"
	"System 4 will be the dominate system"
	^ self! !

!InfoPipeExamples class methodsFor: 'netpipetest10' stamp: 'HJ 6/4/2001 18:28'!
setupDouglas10
	"InfoPipeExamples setupDouglas10"
	(NetPipe from: 's2s://Infopipe1/')
		exportAs: #netpipe3.
	SwitchTee new exportAs: #split3.
	Pump new exportAs: #pump3.
	Pipe new exportAs: #pipe3a.
	Pipe new exportAs: #pipe3b.
	(NetPipe from: 's2s://Infopipe3/')
		exportAs: #netpipe4.
	Pump new exportAs: #pump4! !

!InfoPipeExamples class methodsFor: 'netpipetest10' stamp: 'HJ 6/4/2001 18:31'!
setupState10
	"InfoPipeExamples setupState10"
	| set merge1 netpipe3 split3 c pump3 pipe3a pipe3b netpipe4 pump4 |
	SequentialSource new exportAs: #source1.
	Pump new exportAs: #pump1.
	"below construct a compound pipe"
	merge1 _ MixTee new.
	netpipe3 _ 's2s://Infopipe3/netpipe3' asRemoteObject.
	split3 _ 's2s://Infopipe3/split3' asRemoteObject.
	merge1 ->> netpipe3 ->> split3.
	set _ Set new.
	set add: merge1.
	set add: netpipe3.
	set add: split3.
	c _ CompoundPipe from: set.
	c exportAs: #compound1.
	pump3 _ 's2s://Infopipe3/pump3' asRemoteObject.
	pipe3a _ 's2s://Infopipe3/pipe3a' asRemoteObject.
	pipe3b _ 's2s://Infopipe3/pipe3b' asRemoteObject.
	netpipe4 _ 's2s://Infopipe4/netpipe4' asRemoteObject.
	pump4 _ 's2s://Infopipe4/pump4' asRemoteObject.
	pump3 ->> pipe3a ->> pipe3b ->> netpipe4 ->> pump4.
	set _ Set new.
	set add: pump3.
	set add: pipe3a.
	set add: pipe3b.
	set add: netpipe4.
	set add: pump4.
	c _ CompoundPipe from: set.
	c exportAs: #compound2! !

!InfoPipeExamples class methodsFor: 'netpipetest10' stamp: 'Rik 2004.5'!
testn10
	"InfoPipeExamples testn10"
	| c1 set c4 source1 pump1 c2 sink4 |
	source1 _ 's2s://Infopipe1/source1' asRemoteObject.
	pump1 _ 's2s://Infopipe1/pump1' asRemoteObject.
	c1 _ 's2s://Infopipe1/compound1' asRemoteObject.
	c2 _ 's2s://Infopipe2/compound2' asRemoteObject.
	sink4 _ Sink new.
	set _ Set new.
	(c1 outPort)
		->> c2 inPort.
	set add: c1.
	set add: c2.
	c4 _ CompoundPipe from: set.
	source1 ->> pump1.
	pump1 outPort
		->> (c4 inPort).
	(c4 outPort)
		->> sink4 inPort.
	pump1 startPumping: 1200.
	c4 startPumping: 1000.
	sink4 inspect! !

!InfoPipeExamples class methodsFor: 'netpipetest9' stamp: 'HJ 2/27/2001 15:11'!
readme9
	"The infopipe systems are the same as in testn1"
	"The configuration is similar to testc5. we will have a compound  
	pipe in system 1 consisting of a MergePipe, a netPipe, and a  
	splitpipe. The merge pipe is in system 1. The netpipe crosses  
	system 1 and 4. splitpipe is in sytem 4. We will have another compound pipe in sytem4 containing this compound pipe"
	"System 4 will be the dominate system"
	^ self! !

!InfoPipeExamples class methodsFor: 'netpipetest9' stamp: 'HJ 6/4/2001 18:28'!
setupDouglas9
	"InfoPipeExamples setupDouglas9"
	(NetPipe from: 's2s://Infopipe1/')
		exportAs: #netpipe4.
	SwitchTee new exportAs: #split4! !

!InfoPipeExamples class methodsFor: 'netpipetest9' stamp: 'HJ 6/4/2001 18:31'!
setupState9
	"InfoPipeExamples setupState9"
	| set merge1 netpipe4 split4 c |
	SequentialSource new exportAs: #source1a.
	SequentialSource new exportAs: #source1b.
	Pump new exportAs: #pump1a.
	Pump new exportAs: #pump1b.
	"below construct a compound pipe"
	merge1 _ MixTee new.
	netpipe4 _ 's2s://Infopipe4/netpipe4' asRemoteObject.
	split4 _ 's2s://Infopipe4/split4' asRemoteObject.
	merge1 ->> netpipe4 ->> split4.
	set _ Set new.
	set add: merge1.
	set add: netpipe4.
	set add: split4.
	c _ CompoundPipe from: set.
	c exportAs: #compound1! !

!InfoPipeExamples class methodsFor: 'netpipetest9' stamp: 'Rik 2004.5'!
testn9
	"InfoPipeExamples testn9"
	| pump4a pump4b source1a source1b pump1a pump1b c1 sink4a sink4b set c4 |
	source1a _ 's2s://Infopipe1/source1a' asRemoteObject.
	source1b _ 's2s://Infopipe1/source1b' asRemoteObject.
	pump1a _ 's2s://Infopipe1/pump1a' asRemoteObject.
	pump1b _ 's2s://Infopipe1/pump1b' asRemoteObject.
	c1 _ 's2s://Infopipe1/compound1' asRemoteObject.
	pump4a _ Pump new.
	pump4b _ Pump new.
	sink4a _ Sink new.
	sink4b _ Sink new.
	set _ Set new.
	(c1 outPort)
		->> pump4a.
	set add: c1.
	set add: pump4a.
	c4 _ CompoundPipe from: set source1a ->> pump1a.
	source1a ->> pump1a.
	source1b ->> pump1b.
	pump1a outPort
		->> (c4 inPort).
	pump1b outPort
		->> (c4 portNamed: #input2).
	(c4 portNamed: #output2)
		->> pump4b inPort.
	(c4 outPort)
		->> sink4a.
	pump4b ->> sink4b.
	pump1a startPumping: 1200.
	pump1b startPumping: 1000.
	pump4a startPumping: 1000.
	pump4b startPumping: 1500.
	sink4a inspect.
	sink4b inspect! !

!InfoPipeExamples class methodsFor: 'netpipetest8' stamp: 'HJ 2/27/2001 13:58'!
readme8
	"The infopipe systems are the same as in testn1"
	"The configuration is similar to testc2. we will have a compound pipe in system 1 consisting of a MergePipe, a netPipe, and a splitpipe. The merge pipe is in system 1. The netpipe crosses system 1 and 4. splitpipe is in sytem 4."

	"System 4 will be the dominate system"
	^ self! !

!InfoPipeExamples class methodsFor: 'netpipetest8' stamp: 'HJ 6/4/2001 18:28'!
setupDouglas8
	"InfoPipeExamples setupDouglas8"
	(NetPipe from: 's2s://Infopipe1/')
		exportAs: #netpipe4.
	SwitchTee new exportAs: #split4! !

!InfoPipeExamples class methodsFor: 'netpipetest8' stamp: 'HJ 6/4/2001 18:30'!
setupState8
	"InfoPipeExamples setupState8"
	| set merge1 netpipe4 split4 c |
	SequentialSource new exportAs: #source1a.
	SequentialSource new exportAs: #source1b.
	Pump new exportAs: #pump1a.
	Pump new exportAs: #pump1b.
	"below construct a compound pipe"
	merge1 _ MixTee new.
	netpipe4 _ 's2s://Infopipe4/netpipe4' asRemoteObject.
	split4 _ 's2s://Infopipe4/split4' asRemoteObject.
	merge1 ->> netpipe4 ->> split4.
	set _ Set new.
	set add: merge1.
	set add: netpipe4.
	set add: split4.
	c _ CompoundPipe from: set.
	c exportAs: #compound1! !

!InfoPipeExamples class methodsFor: 'netpipetest8' stamp: 'Rik 2004.5'!
testn8
	"InfoPipeExamples testn8"
	| pump4a pump4b source1a source1b pump1a pump1b c1 sink4a sink4b |
	source1a _ 's2s://Infopipe1/source1a' asRemoteObject.
	source1b _ 's2s://Infopipe1/source1b' asRemoteObject.
	pump1a _ 's2s://Infopipe1/pump1a' asRemoteObject.
	pump1b _ 's2s://Infopipe1/pump1b' asRemoteObject.
	c1 _ 's2s://Infopipe1/compound1' asRemoteObject.
	pump4a _ Pump new.
	pump4b _ Pump new.
	sink4a _ Sink new.
	sink4b _ Sink new.
	source1a ->> pump1a.
	source1b ->> pump1b.
	pump1a outPort
		->> (c1 inPort).
	pump1b outPort
		->> (c1 portNamed: #input2).
	c1 outPort ->> pump4a inPort.
	c1 portNamed: #output2 ->> pump4b inPort.
	pump4a ->> sink4a.
	pump4b ->> sink4b.
	pump1a startPumping: 1200.
	pump1b startPumping: 1000.
	pump4a startPumping: 1000.
	pump4b startPumping: 1500.
	sink4a inspect.
	sink4b inspect! !

!InfoPipeExamples class methodsFor: 'netpipetest7' stamp: 'HJ 2/27/2001 13:24'!
readme7
	"The infopipe systems are the same as in testn1"
	"The configuration is similar to testy7. we will have a MergePipe 
	in system 4 and connect the two inports from sytem 1 and  
	system 3. We will have a split pipe in sytem1"
	"System 4 will be the dominate system"
	^ self! !

!InfoPipeExamples class methodsFor: 'netpipetest7' stamp: 'HJ 6/4/2001 18:28'!
setupDouglas7
	"InfoPipeExamples setupDouglas7"
	(NetPipe from: 's2s://Infopipe2/')
		exportAs: #netpipe3.
	Pump new exportAs: #pump3! !

!InfoPipeExamples class methodsFor: 'netpipetest7' stamp: 'HJ 6/4/2001 18:30'!
setupState7
	"InfoPipeExamples setupState7"
	SequentialSource new exportAs: #source1.
	Pump new exportAs: #pump1.
	SwitchTee new exportAs: #split1.
	(NetPipe from: 's2s://Infopipe1/')
		exportAs: #netpipe1.
	Pump new exportAs: #pump2! !

!InfoPipeExamples class methodsFor: 'replaced by SUnits' stamp: 'Rik 2004.5'!
testc1
	"InfoPipeExamples testc1"
	"test compound pipe"
	| c s |
	c _ CompoundPipe fromComponent: Pump new ->> Pipe new ->> Pipe new ->> BoundedBuffer new ->> Pump new.
	SequentialSource new outPort
		->> (c inPort).
	(c outPort)
		->> (s _ Sink new) inPort.
	c startPumping: 500.
	s inspectPipeline.
	^ c! !

!InfoPipeExamples class methodsFor: 'replaced by SUnits' stamp: 'Rik 2004.5'!
testc2
	"InfoPipeExamples testc2"
	"test compound pipe"
	| c p1 p2 |
	c _ CompoundPipe fromComponent: MixTee new ->> BoundedBuffer new ->> SwitchTee new.
	c inspect.
	SequentialSource new ->> (p1 _ Pump new).
	p1 outPort
		->> (c inPort).
	(c portNamed: #output2)
		->> (p2 _ Pump new) inPort.
	(p2 ->> Sink new inspect) allConnectedInfoPipes inspect.
	p1 startPumping: 500.
	p2 startPumping: 300! !

!InfoPipeExamples class methodsFor: 'replaced by SUnits' stamp: 'Rik 2004.5'!
testc3
	"InfoPipeExamples testc3"
	"test compound pipe"
	| c p1 p2 p3 p4 |
	c _ CompoundPipe fromComponent: MixTee new ->> BoundedBuffer new ->> SwitchTee new.
	c inspect.
	SequentialSource new ->> (p1 _ Pump new).
	p1 outPort
		->> (c inPort).
	(c portNamed: #output2)
		->> (p2 _ Pump new) inPort.
	p2 ->> Sink new inspect.
	SequentialSource new ->> (p3 _ Pump new).
	p3 outPort
		->> (c portNamed: #input2).
	(c outPort)
		->> (p4 _ Pump new) inPort.
	(p4 ->> Sink new inspect) allConnectedInfoPipes inspect.
	p1 startPumping: 500.
	p2 startPumping: 300.
	p3 startPumping: 500.
	p4 startPumping: 300! !

!InfoPipeExamples class methodsFor: 'replaced by SUnits' stamp: 'Rik 2004.5'!
testc4
	"test compound pipe"
	"InfoPipeExamples testc4"
	| p c |
	( SwitchTee new outPort)
		->> (p _ Pump new) inPort.
	p outPort
		->> (MixTee new inPort).
	c _ CompoundPipe fromComponent: p.
	c inspect.
	SequentialSource new outPort
		->> (c inPort).
	(c outPort)
		->> Sink new inspect inPort.
	c startPumping: 500.
	(c portNamed: #output2)
		->> (p _ Pump new) inPort.
	p ->> Sink new inspect.
	p startPumping: 500.
	SequentialSource new outPort ->> (p _ Pump new) inPort.
	p outPort
		->> (c portNamed: #input2).
	p startPumping: 300.
	p allConnectedInfoPipes inspect! !

!InfoPipeExamples class methodsFor: 'simple examples' stamp: 'HJ 1/29/2001 19:00'!
clear

	rm _ nil! !

!InfoPipeExamples class methodsFor: 'simple examples' stamp: 'Rik 2/2/2004 11:13'!
testMutableFilter
	| source nn np pn pp pump sink |
	source _ SequentialSource new.
	pn _ MutableFilterPN new.
	pn transferFunction: [ :value | value + 1 ].
	pp _ MutableFilterPP new.
	pp transferFunction: [ :value | value * 3 ].
	np _ MutableFilterNP new.
	np transferFunction: [ :value | value * 2 ].
	nn _ MutableFilterNN new.
	nn transferFunction: [ :value | value / 6 - 1 ].
	pump _ Pump new.
	sink _ Sink new.
	source outPort connect: pn inPort.
	pn outPort connect: pp inPort.
	pp outPort connect: np inPort.
	np outPort connect: nn inPort.
	nn outPort connect: pump inPort.
	pump outPort connect: sink inPort.
	pp startPumping.
	pump startPumping.
	sink inspect.
	thisContext sender isADoIt ifTrue: [ source inspectPipeline ].! !

!InfoPipeExamples class methodsFor: 'simple examples' stamp: 'Rik 2004.5'!
testc5
	"InfoPipeExamples testc5"
	"a compound pipe in a compound pipe"
	| c1 c2 p1 p2 s |
	c1 _ CompoundPipe fromComponent: MixTee new ->> BoundedBuffer new ->> SwitchTee new.
	c1 inspect.
	(c1 outPort)
		->> (p2 _ Pump new) inPort.
	c2 _ CompoundPipe fromComponent: p2.
	c2 inspect.
	SequentialSource new ->> (p1 _ Pump new).
	p1 outPort
		->> (c2 inPort).
	(c2 outPort)
		->> (s _ Sink new inspect) inPort.
	s allConnectedInfoPipes inspect.
	p1 startPumping: 500.
	p2 startPumping: 300! !

!InfoPipeExamples class methodsFor: 'simple examples' stamp: 'Rik 2004.5'!
testc6
	"InfoPipeExamples testc6"
	"two compound pipes in a compound pipe"
	| c1 c2 c3 p s |
	c1 _ CompoundPipe fromComponent: MixTee new ->> BoundedBuffer new ->> SwitchTee new.
	c1 inspect.
	c2 _ CompoundPipe fromComponent: Pump new ->> Pipe new ->> Pipe new ->> BoundedBuffer new ->> Pump new.
	c2 inspect.
	(c1 outPort)
		->> (c2 inPort).
	c3 _ CompoundPipe fromComponent: c2.
	SequentialSource new ->> (p _ Pump new).
	p outPort
		->> (c3 inPort).
	(c3 outPort)
		->> (s _ Sink new inspect) inPort.
	s allConnectedInfoPipes inspect.
	p startPumping: 500.
	c3 startPumping: 300! !

!InfoPipeExamples class methodsFor: 'simple examples' stamp: 'Rik 2004.5'!
testc7
"InfoPipeExamples testc7"
	"a compound pipe in a compound pipe, in the case need to  
	change port name"
	| c1 c2 p1 p2 s s2 |
	c1 _ CompoundPipe fromComponent: MixTee new ->> BoundedBuffer new ->> SwitchTee new.
	c1 inspect.
	(c1 outPort)
		->> (s2 _ SwitchTee new) inPort.
	s2 replaceOutPortName: #output2 with: #myport2.
	(s2 outPort)
		->> (p2 _ Pump new) inPort.
	c2 _ CompoundPipe fromComponent: p2.
	c2 inspect.
	SequentialSource new ->> (p1 _ Pump new).
	p1 outPort
		->> (c2 inPort).
	(c2 outPort)
		->> (s _ Sink new inspect) inPort.
	s allConnectedInfoPipes inspect.
	p1 startPumping: 500.
	p2 startPumping: 300! !

!InfoPipeExamples class methodsFor: 'simple examples' stamp: 'Rik 2004.5'!
testclone1
"InfoPipeExamples testclone1"
	"test compound pipe"
	| c c2 |
	c _ CompoundPipe fromComponent: Pump new ->> Pipe new ->> Pipe new ->> BoundedBuffer new ->> Pump new.
	SequentialSource new outPort
		->> (c inPort).
	(c outPort)
		->> Sink new inspect inPort.
	c startPumping: 500.
	self halt.
	c2 _ c clone.
	SequentialSource new outPort
		->> (c2 inPort).
	(c2 outPort)
		->> Sink new inspect inPort.
	c2 startPumping: 500! !

!InfoPipeExamples class methodsFor: 'simple examples' stamp: 'Rik 2004.5'!
testclone2
	"InfoPipeExamples testclone2"
	"two compound pipes in a compound pipe"
	| c1 c2 c3 p c4 |
	c1 _ CompoundPipe fromComponent: MixTee new ->> BoundedBuffer new ->> SwitchTee new.
	c1 inspect.
	c2 _ CompoundPipe fromComponent: Pump new ->> Pipe new ->> Pipe new ->> BoundedBuffer new ->> Pump new.
	(c1 outPort)
		->> (c2 inPort).
	c3 _ CompoundPipe fromComponent: c2.
	SequentialSource new ->> (p _ Pump new).
	p outPort
		->> (c3 inPort).
	(c3 outPort)
		->> Sink new inspect inPort.
	p startPumping: 500.
	c3 startPumping: 300.
	c4 _ c3 clone.
	SequentialSource new ->> (p _ Pump new).
	p outPort
		->> (c4 inPort).
	(c4 outPort)
		->> Sink new inspect inPort.
	p startPumping: 500.
	c4 startPumping: 1000! !

!InfoPipeExamples class methodsFor: 'simple examples' stamp: 'HJ 2/7/2001 14:04'!
testn1a
	| pump sink netPipe |
	pump _ Pump new.
	sink _ Sink new.
	pump exportAs: #Pump1.
	sink exportAs: #Sink1.
	netPipe _ NetPipe from: 's2s://Infopipe/'.
    netPipe exportAs: #NetPipe1! !

!InfoPipeExamples class methodsFor: 'simple examples' stamp: 'HJ 2/7/2001 14:05'!
testn1b
	| source pump netPipe remotePump remoteSink |
	source _ SequentialSource new.
	pump _ Pump new.
	netPipe _  's2s://Infopipe/NetPipe1' asRemoteObject.
	remotePump _ 's2s://Infopipe/Pump1' asRemoteObject.
	remoteSink _ 's2s://Infopipe/Sink1' asRemoteObject.
	source ->> pump ->> netPipe ->> remotePump ->> remoteSink.
	pump startPumping: 20000.
	remotePump startPumping: 5000.
	source inspect.
	pump inspect! !

!InfoPipeExamples class methodsFor: 'simple examples' stamp: 'Rik 2004.5'!
testy1
"InfoPipeExamples testy1"
	"only use the basic components and Y components to construct a  
	staight pipeline"
	rm _ OrderedCollection new.
	rm addLast: SequentialSource new.
	rm addLast: Pump new.
	self halt.
	rm addLast: MixTee new.
	rm addLast: BoundedBuffer new.
	rm addLast: SwitchTee new.
	rm addLast: Pump new.
	rm addLast: Sink new.
	(rm at: 1) outPort connect: (rm at: 2) inPort.
	(rm at: 2) outPort
		connect: ((rm at: 3)
				inPort).
	(rm at: 3) outPort connect: (rm at: 4) inPort.
	(rm at: 4) outPort connect: (rm at: 5) inPort.
	((rm at: 5)
		outPort)
		connect: (rm at: 6) inPort.
	(rm at: 6) outPort connect: (rm at: 7) inPort.
	(rm at: 2)
		startPumping: 1000.
	(rm at: 6)
		startPumping: 300.
	rm inspect.
	(rm at: 6) allConnectedInfoPipes inspect! !

!InfoPipeExamples class methodsFor: 'simple examples' stamp: 'Rik 2004.5'!
testy2
	"only use the basic components and Y components to construct a  
	staight pipeline"
	"InfoPipeExamples testy2"
	rm _ OrderedCollection new.
	rm addLast: SequentialSource new.
	rm addLast: SwitchTee new.
	rm addLast: Pump new.
	rm addLast: MixTee new.
	rm addLast: Sink new.
	(rm at: 1) outPort connect: (rm at: 2) inPort.
	((rm at: 2)
		portNamed: #output2)
		connect: (rm at: 3) inPort.
	(rm at: 3) outPort
		connect: ((rm at: 4)
				inPort).
	(rm at: 4) outPort connect: (rm at: 5) inPort.
	(rm at: 3)
		startPumping: 1000.
	rm inspect.
	(rm at: 3) allConnectedInfoPipes inspect! !

!InfoPipeExamples class methodsFor: 'simple examples' stamp: 'Rik 2004.5'!
testy3

"InfoPipeExamples testy3"
	"only use the basic components and Y components to construct a  
	broadcast pipeline"
	rm _ OrderedCollection new.
	rm addLast: SequentialSource new.
	rm addLast: Pump new.
	rm addLast: MulticastTee new.
	rm addLast: Sink new.
	rm addLast: Sink new.
	(rm at: 1) outPort connect: (rm at: 2) inPort.
	(rm at: 2) outPort connect: (rm at: 3) inPort.
	((rm at: 3)
		outPort)
		connect: (rm at: 4) inPort.
	((rm at: 3)
		portNamed: #output2)
		connect: (rm at: 5) inPort.
	(rm at: 2)
		startPumping: 1000.
	rm inspect.
	(rm at: 3) allConnectedInfoPipes inspect! !

!InfoPipeExamples class methodsFor: 'simple examples' stamp: 'Rik 2004.5'!
testy4
	"InfoPipeExamples testy4"
	"only use the basic components and Y components to construct a  
	unicast pipeline"
	rm _ OrderedCollection new.
	rm addLast: SequentialSource new.
	rm addLast: SwitchTee new.
	rm addLast: Pump new.
	rm addLast: Pump new.
	rm addLast: Sink new.
	rm addLast: Sink new.
	(rm at: 1) outPort connect: (rm at: 2) inPort.
	((rm at: 2)
		outPort)
		connect: (rm at: 3) inPort.
	((rm at: 2)
		portNamed: #output2)
		connect: (rm at: 4) inPort.
	(rm at: 3) outPort connect: (rm at: 5) inPort.
	(rm at: 4) outPort connect: (rm at: 6) inPort.
	(rm at: 3)
		startPumping: 1000.
	(rm at: 4)
		startPumping: 1000.
	rm inspect.
	(rm at: 3) allConnectedInfoPipes inspect! !

!InfoPipeExamples class methodsFor: 'simple examples' stamp: 'Rik 6/10/2004 00:00'!
testy5
	"InfoPipeExamples testy5"
	"only use the basic components and Y components to construct a multiplex pipeline"
	rm _ OrderedCollection new.
	rm addLast: SequentialSource new.
	rm addLast: SequentialSource new.
	rm addLast: Pump new.
	rm addLast: Pump new.
	rm addLast: MixTee new.
	rm addLast: Sink new.
	(rm at: 1) outPort connect: (rm at: 3) inPort.
	(rm at: 2) outPort connect: (rm at: 4) inPort.
	(rm at: 3) outPort connect: ((rm at: 5) inPort).
	(rm at: 4) outPort connect: ((rm at: 5) portNamed: #input2).
	(rm at: 5) outPort connect: (rm at: 6) inPort.
	(rm at: 3) startPumping: 1000.
	(rm at: 4) startPumping: 1000.
	rm inspect.
	(rm at: 6) allConnectedInfoPipes inspect! !

!InfoPipeExamples class methodsFor: 'simple examples' stamp: 'Rik 2004.5'!
testy6
"InfoPipeExamples testy6"
	"only use the basic components and Y components to construct a  
	gathering pipeline"
	rm _ OrderedCollection new.
	rm addLast: SequentialSource new.
	rm addLast: SequentialSource new.
	rm addLast: ZipTee new.
	rm addLast: Pump new.
	rm addLast: Sink new.
	(rm at: 1) outPort
		connect: ((rm at: 3)
				inPort).
	(rm at: 2) outPort
		connect: ((rm at: 3)
				portNamed: #input2).
	(rm at: 3)
		->> (rm at: 4)
		->> (rm at: 5).
	(rm at: 4)
		startPumping: 1000.
	rm inspect.
	(rm at: 2) allConnectedInfoPipes inspect! !

!InfoPipeExamples class methodsFor: 'simple examples' stamp: 'Rik 2004.5'!
testy7
	"InfoPipeExamples testy7"
	"only use the basic components and Y components to construct a  
	broadcast and	multiplex pipeline"
	rm _ OrderedCollection new.
	rm addLast: SequentialSource new.
	rm addLast: Pump new.
	rm addLast: MulticastTee new.
	rm addLast: MixTee new.
	rm addLast: Sink new.
	(rm at: 1)
		->> (rm at: 2).
	(rm at: 2)
		->> (rm at: 3).
	((rm at: 3)
		outPort)
		->> ((rm at: 4)
				inPort).
	((rm at: 3)
		portNamed: #output2)
		->> ((rm at: 4)
				portNamed: #input2).
	(rm at: 4)
		->> (rm at: 5).
	(rm at: 2)
		startPumping: 1000.
	rm inspect.
	(rm at: 2) allConnectedInfoPipes inspect! !

!InfoPipeExamples class methodsFor: 'defrag tests' stamp: 'apb 1/4/2002 13:06'!
testEagerDefragmentor
	"InfoPipeExamples testEagerDefragmentor"
	| p |
	p _ Pump new.
	SequentialSource new ->> EagerDefragmentor new ->> p ->> Sink new.
	p startPumping.
	thisContext sender isADoIt ifTrue: [ p inspectPipeline ].! !

!InfoPipeExamples class methodsFor: 'defrag tests' stamp: 'apb 1/4/2002 12:44'!
testLazyDefragmentor
	"InfoPipeExamples testLazyDefragmentor"
	| p |
	p _ Pump new.
	SequentialSource new ->> LazyDefragmentor new ->> p ->> Sink new.
	p startPumping.
	thisContext sender isADoIt ifTrue: [ p inspectPipeline ].! !


!LazyDefragmentor methodsFor: 'pipe operations' stamp: 'apb 1/4/2002 13:02'!
pull
	| i1 i2 |
	i1 _ self inPort pull.
	i2 _ self inPort pull.
	^ self assemble: i1 and: i2! !


!MergePipe methodsFor: 'accessing' stamp: 'H.J 11/17/2000 10:55'!
mergeNumber: branches 
	mergeNumber _ branches! !

!MergePipe methodsFor: 'pipe operations' stamp: 'Rik 2/17/2004 13:53'!
pull
	self shouldNotImplement! !

!MergePipe methodsFor: 'pipe operations' stamp: 'Rik 2/17/2004 13:52'!
push: anItem 
	self shouldNotImplement! !


!MergePipe class methodsFor: 'instance creation' stamp: 'Rik 5/17/2004 11:56'!
new
	^ self newMerge: 2! !

!MergePipe class methodsFor: 'instance creation' stamp: 'Rik 5/17/2004 11:57'!
newMerge: branches 
	| rslt |
	rslt _ self basicNew.
	rslt mergeNumber: branches.
	rslt initialize.
	^ rslt! !


!MixTee methodsFor: 'pipe operations' stamp: 'HJ 5/4/2001 00:01'!
push: anItem 
	"push anItem into the pipe. The appropriate action is to push  
	anItem
	onto this pipe's output."
	self afterLatency: nil.
	self outPort push: anItem! !


!Mode methodsFor: 'type checking' stamp: 'HJ 10/29/2000 00:32'!
bind: aMode 
	self error: 'can''t bind this mode!!'! !

!Mode methodsFor: 'type checking' stamp: 'HJ 10/29/2000 00:32'!
isCompatibleWith: aMode 
	self subclassResponsibility! !

!Mode methodsFor: 'operations' stamp: 'HJ 10/29/2000 00:33'!
opposite
	self subclassResponsibility! !

!Mode methodsFor: 'printing' stamp: 'HJ 10/29/2000 00:33'!
printOn: aStream 
	"Append to aStream, a sequence of characters that identifies me."
	aStream nextPutAll: self class name! !

!Mode methodsFor: 'accessing' stamp: 'HJ 10/30/2000 11:30'!
myValue
	^ self! !

!Mode methodsFor: 'accessing' stamp: 'HJ 10/30/2000 11:34'!
myValue: aMode 
	self error: 'cannot be bound.'! !

!Mode methodsFor: 'gomi' stamp: 'Rik 5/12/2004 16:43'!
is: aMode 
self gomi.
	self = aMode
		ifTrue: [^ true].
	self class = aMode class
		ifTrue: [^ true].
	^ false! !


!Active methodsFor: 'operations' stamp: 'Rik 5/12/2004 16:42'!
opposite
	^ Passive singleInstance! !

!Active methodsFor: 'type checking' stamp: 'Rik 5/12/2004 16:42'!
isCompatibleWith: aMode 
	aMode myValue = Passive singleInstance ifTrue: [^ true].
	aMode myValue = Active singleInstance ifTrue: [^ false].
	^ aMode bind: self opposite! !

!Active methodsFor: 'printing' stamp: 'HJ 10/29/2000 00:25'!
printOn: aStream 
	"Append to aStream, a sequence of characters that identifies me."
	aStream nextPutAll: self class name! !

!Active methodsFor: 's2s' stamp: 'HJ 2/26/2001 12:26'!
isPassedByValue
^true.! !


!InverseMode methodsFor: 'operations' stamp: 'HJ 10/29/2000 00:31'!
opposite
	^ opposite! !

!InverseMode methodsFor: 'operations' stamp: 'HJ 10/29/2000 00:32'!
opposite: aMode 
	opposite _ aMode! !

!InverseMode methodsFor: 'type checking' stamp: 'HJ 10/29/2000 00:32'!
bind: aMode 
	^ opposite bind: aMode opposite! !

!InverseMode methodsFor: 'type checking' stamp: 'HJ 10/29/2000 00:32'!
isCompatibleWith: aMode 
	^ self opposite isCompatibleWith: aMode opposite! !

!InverseMode methodsFor: 'printing' stamp: 'HJ 10/29/2000 00:32'!
printOn: aStream 
	"Append to aStream, a sequence of characters that identifies me."
	aStream nextPutAll: self class name.
	aStream nextPutAll: '('.
	opposite printOn: aStream.
	aStream nextPutAll: ')'! !


!InverseMode class methodsFor: 'instance creation' stamp: 'HJ 10/29/2000 00:39'!
new
	self error: 'use inverseOf: to maker a new ' , self class printString! !

!InverseMode class methodsFor: 'instance creation' stamp: 'HJ 10/29/2000 00:39'!
of: aMode 
	^ super new opposite: aMode! !


!Monitor methodsFor: 'accessing' stamp: 'HJ 4/9/2001 12:39'!
controled
	^ controled! !

!Monitor methodsFor: 'accessing' stamp: 'HJ 4/9/2001 12:39'!
controled: anInfoPipe
	 controled _ anInfoPipe! !

!Monitor methodsFor: 'accessing' stamp: 'HJ 4/9/2001 12:53'!
interval
	^interval ! !

!Monitor methodsFor: 'accessing' stamp: 'HJ 4/9/2001 12:53'!
interval: milliseconds
interval _ milliseconds.! !

!Monitor methodsFor: 'accessing' stamp: 'HJ 4/9/2001 12:38'!
monitored
	^monitored ! !

!Monitor methodsFor: 'accessing' stamp: 'HJ 4/9/2001 12:38'!
monitored:anInfoPipe
monitored _ anInfoPipe! !

!Monitor methodsFor: 'monitoring' stamp: 'HJ 4/9/2001 13:03'!
act
 monitored fullness > 0.9 ifTrue: [controled slower].
 monitored fullness < 0.1 ifTrue: [controled faster].! !

!Monitor methodsFor: 'monitoring' stamp: 'HJ 4/9/2001 12:49'!
defaultInterval
"in milliseconds"
^ 1000! !

!Monitor methodsFor: 'monitoring' stamp: 'HJ 4/9/2001 12:55'!
startMonitoring
^ self startMonitoring: self defaultInterval! !

!Monitor methodsFor: 'monitoring' stamp: 'HJ 4/9/2001 12:59'!
startMonitoring: millisecondInterval
self stopMonitoring.
self interval: millisecondInterval.
	^ monitor _ [[self act.
                   (Delay forMilliseconds: interval) wait] repeatForever] fork! !

!Monitor methodsFor: 'monitoring' stamp: 'HJ 4/9/2001 13:00'!
stopMonitoring
monitor ifNil: [^self].
monitor terminate.
monitor _ nil. ! !


!Monitor class methodsFor: 'instance creation' stamp: 'HJ 4/9/2001 12:40'!
monitored: infoPipea controled: infoPipeb 
	^ self basicNew monitored:infoPipea; controled:infoPipeb! !


!NetPipe methodsFor: 'accessing' stamp: 'HJ 2/15/2001 23:17'!
ipAddress
^ipAddress! !

!NetPipe methodsFor: 'accessing' stamp: 'Rik 2/11/2004 10:00'!
ipAddress: ip 
	ipAddress _ ip! !

!NetPipe methodsFor: 'accessing' stamp: 'Rik 2/2/2004 11:10'!
peerAddr: ipAddr 
| peerAddr |
self gomi.
	peerAddr_ipAddr! !

!NetPipe methodsFor: 'accessing' stamp: 'HJ 2/15/2001 17:50'!
proxyPort
^proxyPort! !

!NetPipe methodsFor: 'accessing' stamp: 'HJ 2/15/2001 17:50'!
proxyPort: aPortNumber
	^ proxyPort_aPortNumber! !

!NetPipe methodsFor: 'accessing' stamp: 'HJ 2/19/2001 19:30'!
proxyProcess
^proxyProcess! !

!NetPipe methodsFor: 'accessing' stamp: 'HJ 2/19/2001 19:30'!
proxyProcess:aProcess
	^ proxyProcess _ aProcess! !

!NetPipe methodsFor: 'accessing' stamp: 'HJ 1/31/2001 19:58'!
remoteSys
^	remoteSys! !

!NetPipe methodsFor: 'accessing' stamp: 'Rik 2/11/2004 09:59'!
remoteSys: aString 
	remoteSys _ aString! !

!NetPipe methodsFor: 'accessing' stamp: 'HJ 2/15/2001 17:51'!
socket
	^ socket ! !

!NetPipe methodsFor: 'accessing' stamp: 'HJ 2/15/2001 17:51'!
socket: aSocket
	^ socket _ aSocket! !

!NetPipe methodsFor: 'private' stamp: 'HJ 2/2/2001 12:56'!
remoteObject: objName 
	^ (self remoteSys , objName) asRemoteObject! !

!NetPipe methodsFor: 'networking' stamp: 'HJ 3/20/2001 20:01'!
listeningLoop
	| buffer item n |
	buffer _ String new: 4000.
	[self socket waitForData]
		whileTrue: [
			n _ self socket receiveDataInto: buffer.
			item _ buffer copyFrom: 1 to: n.
			self consume: item]! !

!NetPipe methodsFor: 'networking' stamp: 'HJ 2/19/2001 19:30'!
startListening
	self stopListening.
	self proxyProcess: [self listeningLoop] fork! !

!NetPipe methodsFor: 'networking' stamp: 'HJ 2/19/2001 19:31'!
stopListening
	self proxyProcess
		ifNotNil: [self proxyProcess terminate].
	self proxyProcess: nil! !


!NetPipe class methodsFor: 'as yet unclassified' stamp: 'HJ 2/2/2001 12:57'!
to: remoteSys 
	| p |
	p _ self basicNew.
	p remoteSys: remoteSys.
	p initialize.
^ p! !

!NetPipe class methodsFor: 'UDPtesting' stamp: 'HJ 2/15/2001 16:26'!
test1
"NetPipe test1"
	| sock1 sock2 sendBuf receiveBuf |
	Transcript show: 'initializing network ... '.
	Socket
		initializeNetworkIfFail: [^ Transcript show: 'failed'].
	Transcript show: 'ok';
		 cr.
	sock1 _ Socket newUDP.
	sock2 _ Socket newUDP.
	sock2 setPort: 54321.
	sock1 setPeer: NetNameResolver localHostAddress port: sock2 port.
	Transcript show: 'endpoints created';
		 cr.
	sendBuf _ 'this is a test'.
	receiveBuf _ String new: 20.
	sock1 sendData: sendBuf.
	sock2 dataAvailable
		ifTrue: [sock2 receiveDataInto: receiveBuf].
	Transcript show: receiveBuf;
		 cr.
	sock1 closeAndDestroy.
	sock2 closeAndDestroy! !

!NetPipe class methodsFor: 'UDPtesting' stamp: 'HJ 2/15/2001 16:43'!
test2
	"NetPipe test2"
	| sock1 sock2 sendBuf receiveBuf |
	Transcript show: 'initializing network ... '.
	Socket
		initializeNetworkIfFail: [^ Transcript show: 'failed'].
	Transcript show: 'ok';
		 cr.
	sock1 _ Socket newUDP.
	sock2 _ Socket newUDP.
	sock2 setPort: 54321.
	Transcript show: 'endpoints created';
		 cr.
	sendBuf _ 'this is a test'.
	receiveBuf _ String new: 20 withAll: $x.
    Transcript show: receiveBuf.
	sock1
		sendData: sendBuf
		toHost: NetNameResolver localHostAddress
		port: sock2 port.
	sock2 dataAvailable
		ifTrue: [sock2 receiveDataInto: receiveBuf].
	Transcript show: receiveBuf;
		 cr.
	sock1 closeAndDestroy.
	sock2 closeAndDestroy! !

!NetPipe class methodsFor: 'UDPtesting' stamp: 'HJ 2/15/2001 17:28'!
test3Client
	"NetPipe test3Client"
	| sock sendBuf receiveBuf |
	Transcript show: 'initializing network ... '.
	Socket
		initializeNetworkIfFail: [^ Transcript show: 'failed'].
	Transcript show: 'ok';
		 cr.
	sock _ Socket newUDP.
	sock
		setPeer: (NetNameResolver addressFromString: '129.95.40.5')
		port: 54325.
	Transcript show: 'endpoints created';
		 cr.
	sendBuf _ 'this is a test'.
	receiveBuf _ String new: 20.
	sock sendDone
		ifTrue: [sock sendData: sendBuf.
			Transcript show: sendBuf].
	Transcript show: 'is sent';
		 cr.
	sock
		waitForDataUntil: (Socket deadlineSecs: 2).
	sock dataAvailable
		ifTrue: [sock receiveDataInto: receiveBuf].
	Transcript show: receiveBuf;
		 cr.
	sock closeAndDestroy! !

!NetPipe class methodsFor: 'UDPtesting' stamp: 'HJ 2/15/2001 17:24'!
test3Server
	"NetPipe test3Server"
	| sock buf n |
	Transcript show: 'initializing network ... '.
	Socket
		initializeNetworkIfFail: [^ Transcript show: 'failed'].
	Transcript show: 'ok';
		 cr.
	sock _ Socket newUDP.
	sock setPort: 54321.
	Transcript show: 'endpoints created';
		 cr.
	buf _ String new: 20.
	[true]
		whileTrue: [sock dataAvailable
				ifTrue: [n _ sock receiveDataInto: buf.
					Transcript show: buf;
						 cr.
					sock sendData: buf count: n]]! !

!NetPipe class methodsFor: 'instance creation' stamp: 'Rik 2/11/2004 09:59'!
from: remoteSys 
	| np |
	np _ self basicNew.
	np remoteSys: remoteSys.
	np ipAddress: (NetNameResolver localAddressString).
	np initialize.
	^ np! !

!NetPipe class methodsFor: 'initialize-release' stamp: 'HJ 2/21/2001 12:28'!
localMachineSetup
	"OrbControl startOrbAtPort: 9999."
	OrbControl export: NetInPort as: #NetInPort.
	OrbControl export: Passive as: #Passive.
	OrbControl
		addSystem: #Infopipe
		atIP: '129.95.50.82'
		port: 9999! !

!NetPipe class methodsFor: 'initialize-release' stamp: 'HJ 2/16/2001 18:05'!
remoteMachineSetup
	"OrbControl startOrbAtPort: 9999."
	OrbControl
		addSystem: #Infopipe
		atHost: 'state.cse.ogi.edu'
		port: 9900! !

!NetPipe class methodsFor: 'initialize-release' stamp: 'HJ 2/21/2001 17:24'!
setup
	"NetPipe Setup"
	"start ORB"
    OrbControl releaseOrb.
	OrbControl startOrbAtPort: 9999.
	"export some useful classes"
	OrbControl export: NetInPort as: #NetInPort.
	OrbControl export: Passive as: #Passive.
	"add remote infopipe systems"
	OrbControl
		addSystem: #Infopipe1
		atIP: '129.95.40.5'
		port: 9999.
	OrbControl
		addSystem: #Infopipe2
		atIP: '129.95.40.5'
		port: 9999.
	OrbControl
		addSystem: #Infopipe3
		atHost: 'douglas.cse.ogi.edu'
		port: 9999! !


!Passive methodsFor: 'type checking' stamp: 'Rik 5/12/2004 16:41'!
isCompatibleWith: aMode 
	aMode myValue = Active singleInstance ifTrue: [^ true].
	aMode myValue = Passive singleInstance ifTrue: [^ false].
	^ aMode bind: self opposite! !

!Passive methodsFor: 'operations' stamp: 'Rik 5/12/2004 16:40'!
opposite
	^ Active singleInstance! !

!Passive methodsFor: 'printing' stamp: 'HJ 10/29/2000 00:33'!
printOn: aStream 
	"Append to aStream, a sequence of characters that identifies me."
	aStream nextPutAll: self class name! !

!Passive methodsFor: 's2s' stamp: 'Rik 3/11/2004 12:19'!
isPassedByValue
	^true.! !


!Pipe methodsFor: 'pipe operations' stamp: 'H.J 11/15/2000 14:38'!
pull
	"answers anItem obtained from this pipe. It is obtained by  
	pulling
	from this pipe's input"
	^ self afterLatency: self inPort pull! !

!Pipe methodsFor: 'pipe operations' stamp: 'H.J 11/15/2000 14:39'!
push: anItem 
	"push anItem into the pipe. The appropriate action is to push 
	anItem
	onto this pipe's output."
	self afterLatency: nil.
	self outPort push: anItem! !

!Pipe methodsFor: 'initialization' stamp: 'Rik 2/19/2004 00:03'!
initializePorts
	| vmode |
	self ports at: #input1
		put: ((InPort ownedBy: self)
				mode: (vmode _ VarMode new)).
	self ports at: #output1
		put: ((OutPort ownedBy: self)
				mode: (InverseMode of: vmode))! !


!Dropper methodsFor: 'initialization' stamp: 'HJ 10/29/2000 00:28'!
initialize
	super initialize.
	numberDropped _ 0.
	dropCondition _ [:item | false]! !

!Dropper methodsFor: 'initialization' stamp: 'HJ 10/29/2000 00:28'!
initializeClone: aClone 
	super initializeClone: aClone.
	aClone dropCondition: dropCondition! !

!Dropper methodsFor: 'pipe operations' stamp: 'HJ 10/29/2000 00:28'!
push: anItem 
	"Examine anItem. If my dropCondition is false, behave like a 
	pipe. 
	Otherwise, drop anItem"
	(dropCondition value: anItem)
		ifTrue: [numberDropped _ numberDropped + 1]
		ifFalse: [super push: anItem]! !

!Dropper methodsFor: 'accessing' stamp: 'HJ 10/29/2000 00:28'!
dropCondition: aBlock 
	"Set the receiver's instance variable dropCondition to aBlock."
	dropCondition _ aBlock! !

!Dropper methodsFor: 'accessing' stamp: 'HJ 10/29/2000 00:28'!
dropControl: aController 
	"Set the receiver's instance variable dropCondition to aController, 
	which can
	be anything that responds to the 'value:' message 
	with an appropriate Boolean"
	dropCondition _ aController! !


!Filter methodsFor: 'accessing' stamp: 'HJ 10/31/2000 15:08'!
function: aBlock 
	function _ aBlock! !

!Filter methodsFor: 'pipe operations' stamp: 'HJ 10/31/2000 15:11'!
pull
	"answers anItem obtained from this pipe. It is obtained by  
	pulling
	from this pipe's input"
	| anItem |
	anItem _ self afterLatency: self input pull.
	^ function value: anItem! !

!Filter methodsFor: 'pipe operations' stamp: 'Rik 5/17/2004 20:00'!
push: anItem 
	self afterLatency: nil.
	self outPort push: (function value: anItem)! !

!Filter methodsFor: 'initialization' stamp: 'Rik 5/17/2004 00:21'!
initialize
	super initialize.
	self function: self defaultFunction! !


!MutableFilter methodsFor: 'initialization' stamp: 'PEM. Real-time pump. 10/4/2002 16:35'!
transferFunction: aBlock
	"Set the filter transfer function."

	transferFunction _ aBlock.! !


!MutableFilterNN methodsFor: 'initialization' stamp: 'PEM. Real-time pump. 10/2/2002 18:59'!
initialize
	super initialize.
	buffer _ OrderedCollection new.! !

!MutableFilterNN methodsFor: 'pipe operations'!
pull

	| retval |

	buffer isEmpty
		ifTrue:
			[ retval _ 0 ]
		ifFalse:
			[ retval _ buffer removeFirst ].
	^ retval.! !

!MutableFilterNN methodsFor: 'pipe operations' stamp: 'PEM. Real-time pump. 10/2/2002 19:01'!
push: aValue
	buffer addLast: (transferFunction value: aValue).! !


!MutableFilterNP methodsFor: 'pipe operations'!
push: aValue
	self outPort push: (transferFunction value: aValue).! !


!MutableFilterPN methodsFor: 'pipe operations'!
pull
	^ transferFunction value: (self inPort pull).! !


!MutableFilterPP methodsFor: 'pipe operations'!
startPumping
	| strokeDelay |

	strokeDelay _ Delay forMilliseconds: 1000.
	[ [ self stroke.
	    strokeDelay wait. ] repeatForever ] fork.! !

!MutableFilterPP methodsFor: 'pipe operations'!
stroke
	self outPort push: (transferFunction value: (self inPort pull)).! !


!PlugableMonitor methodsFor: 'accessing' stamp: 'HJ 4/24/2001 17:28'!
action: aBinaryBlock
	action _ aBinaryBlock! !

!PlugableMonitor methodsFor: 'monitoring' stamp: 'HJ 4/24/2001 17:25'!
actMonitor: m control: c
	action value: m value: c! !

!PlugableMonitor methodsFor: 'monitoring' stamp: 'HJ 4/24/2001 17:27'!
startMonitoring: millisecondInterval 
	self stopMonitoring.
	self interval: millisecondInterval.
	^ monitor _ [[self actMonitor: monitored control: controled.
			(Delay forMilliseconds: interval) wait] repeatForever] fork! !


!Port methodsFor: 'accessing' stamp: 'H.J 11/15/2000 12:09'!
connectedTo
	^ connectedTo! !

!Port methodsFor: 'accessing' stamp: 'H.J 11/15/2000 12:09'!
connectedTo: aPort 
	connectedTo _ aPort! !

!Port methodsFor: 'accessing' stamp: 'H.J 11/17/2000 17:07'!
infoPipeConnectedTo
	^ self connectedTo owner! !

!Port methodsFor: 'accessing' stamp: 'H.J 11/15/2000 12:08'!
mode
	^ mode! !

!Port methodsFor: 'accessing' stamp: 'H.J 11/15/2000 12:08'!
mode: aMode 
	mode _ aMode! !

!Port methodsFor: 'accessing' stamp: 'H.J 11/15/2000 12:06'!
owner
	^ owner! !

!Port methodsFor: 'accessing' stamp: 'H.J 11/15/2000 12:06'!
owner: anInfoPipe 
	owner _ anInfoPipe! !

!Port methodsFor: 'testing' stamp: 'H.J 11/15/2000 14:06'!
isInput
	^ false! !

!Port methodsFor: 'testing' stamp: 'apb 1/4/2002 14:32'!
isOpen
	^ self connectedTo isOpenEnd! !

!Port methodsFor: 'testing' stamp: 'H.J 11/20/2000 12:17'!
isOpenEnd
	^ false! !

!Port methodsFor: 'printing' stamp: 'H.J 11/15/2000 14:00'!
printOn: aStream 
	aStream nextPutAll: self class name.
	aStream nextPutAll: '('.
	self owner printOn: aStream.
	aStream nextPutAll: '  '.
	self mode printOn: aStream.
	aStream nextPutAll: ')'! !

!Port methodsFor: 'type checking' stamp: 'Rik 6/3/2004 14:37'!
canConnectTo: aPort 
	^(self mode isCompatibleWith: aPort mode)
		ifTrue: [true]
		ifFalse: [ self mode asString , ' cannot connect to ', aPort mode asString. false ]! !

!Port methodsFor: 'initialize-release' stamp: 'H.J 11/16/2000 12:06'!
initialize
	connectedTo _ OpenEnd new! !


!InPort methodsFor: 'pipe operations' stamp: 'Rik 6/10/2004 00:05'!
pull
	^ self recentValue: self connectedTo pull! !

!InPort methodsFor: 'pipe operations' stamp: 'Rik 6/10/2004 00:06'!
push: anItem 
	self owner push: (self recentValue: anItem)! !

!InPort methodsFor: 'testing' stamp: 'H.J 11/15/2000 14:06'!
isInput
	^ true! !

!InPort methodsFor: 'configuration' stamp: 'HJ 2/22/2001 16:08'!
attachTo: aCompoundPipe 
	| pseudo t |
	pseudo _ InputPseudoPipe connectedTo: self.
	t _ CompoundInPort ownedBy: aCompoundPipe and: pseudo.
	t mode: pseudo outPort mode opposite.
	pseudo realPort: t.
	^ t! !


!CompoundInPort methodsFor: 'accessing' stamp: 'H.J 11/20/2000 13:48'!
pseudoOwner
	^ pseudoOwner! !

!CompoundInPort methodsFor: 'accessing' stamp: 'H.J 11/20/2000 13:30'!
pseudoOwner: aPseudoPipe 
	pseudoOwner _ aPseudoPipe! !

!CompoundInPort methodsFor: 'pipe operations' stamp: 'Rik 6/10/2004 00:06'!
push: anItem 
	self pseudoOwner push:  (self recentValue: anItem)! !


!NetInPort methodsFor: 'pipe operations' stamp: 'Rik 6/10/2004 00:06'!
push: anItem 
	anItem
		ifNotNil: [self socket sendDone ifTrue: [self socket sendData:  (self recentValue: anItem)]]! !

!NetInPort methodsFor: 'initialize-release' stamp: 'HJ 2/19/2001 11:51'!
initialize
	| port |
	super initialize.
	self socket: Socket newUDP.
	port _ self owner proxyPort.
	Transcript show: '!!!!!!!!the peer port is: '.
	Transcript show: port asString;
	 cr.
	self socket setPeer: (NetNameResolver addressFromString: self owner ipAddress)
		port: port! !

!NetInPort methodsFor: 'accessing' stamp: 'HJ 2/19/2001 18:29'!
connectedTo: aPort 
	connectedTo _ aPort.
	aPort isOpenEnd
		ifTrue: [self owner stopLisetning]
		ifFalse: [self owner startListening]! !

!NetInPort methodsFor: 'accessing' stamp: 'HJ 2/15/2001 17:57'!
socket
  ^socket! !

!NetInPort methodsFor: 'accessing' stamp: 'HJ 2/15/2001 17:57'!
socket: aSocket
socket _ aSocket! !


!OpenEnd methodsFor: 'testing' stamp: 'HJ 10/29/2000 00:33'!
isOpenEnd
	^ true! !

!OpenEnd methodsFor: 'testing' stamp: 'H.J 11/20/2000 12:20'!
toOpenEnd
	^ self shouldNotImplement! !

!OpenEnd methodsFor: 'pipe operations' stamp: 'Rik 6/10/2004 00:07'!
pull
	"answers anItem obtained from this pipe. We return #EndOfData, 
	indicating that the caller
 is 'sucking air' into the pipe"
	^ self recentValue: #EndOfData! !

!OpenEnd methodsFor: 'pipe operations' stamp: 'HJ 10/29/2000 00:33'!
push: anItem 
	"push anItem through this OpenEnd. The appropriate action is to 
	let lt leak onto the foor."
	^ self! !

!OpenEnd methodsFor: 'accessing' stamp: 'H.J 11/21/2000 15:21'!
connectedTo: aPort 
	^ self! !

!OpenEnd methodsFor: 'accessing' stamp: 'H.J 11/21/2000 14:17'!
infoPipeConnectedTo
	self shouldNotImplement! !

!OpenEnd methodsFor: 'accessing' stamp: 'H.J 11/21/2000 14:18'!
mode: aMode 
	self shouldNotImplement! !

!OpenEnd methodsFor: 'accessing' stamp: 'H.J 11/21/2000 14:16'!
owner: anInfoPipe 
	self shouldNotImplement! !

!OpenEnd methodsFor: 'initialization' stamp: 'HJ 10/29/2000 00:33'!
initialize
	^ self! !


!OutPort methodsFor: 'pipe operations' stamp: 'Rik 6/10/2004 00:07'!
pull
	^ self recentValue: self owner pull! !

!OutPort methodsFor: 'pipe operations' stamp: 'Rik 6/10/2004 00:08'!
push: anItem 
	^ self connectedTo push: (self recentValue: anItem)! !

!OutPort methodsFor: 'configuration' stamp: 'Rik 2/26/2004 22:53'!
->> aPortOrPipe
	self connect: aPortOrPipe inPort! !

!OutPort methodsFor: 'configuration' stamp: 'HJ 2/22/2001 16:10'!
attachTo: aCompoundPipe 
	| pseudo t |
	pseudo _ OutputPseudoPipe connectedTo: self.
	t _ CompoundOutPort ownedBy: aCompoundPipe and: pseudo.
	t mode: pseudo inPort mode opposite.
	pseudo realPort: t.
	^ t! !

!OutPort methodsFor: 'configuration' stamp: 'Rik 5/25/2004 22:23'!
connect: aPort 
	"answer whether successful at connecting"

	aPort isInput
		ifTrue: 
			[self disconnect.
			(self canConnectTo: aPort)
				ifTrue: 
					[self connectedTo: aPort.
					aPort connectedTo: self.
					^true]
				"ifFalse: [self inform: 'Incompatible types. Cannot be connected'.]"].
	^false
	! !


!CompoundOutPort methodsFor: 'accessing' stamp: 'H.J 11/20/2000 22:31'!
pseudoOwner
	^ pseudoOwner! !

!CompoundOutPort methodsFor: 'accessing' stamp: 'H.J 11/20/2000 13:41'!
pseudoOwner: aPseudoPipe 
	pseudoOwner _ aPseudoPipe! !

!CompoundOutPort methodsFor: 'pipe operations' stamp: 'Rik 6/10/2004 00:08'!
pull
	^  self recentValue: self pseudoOwner pull! !


!Port class methodsFor: 'instance creation' stamp: 'H.J 11/17/2000 16:28'!
new
	self error: 'a Port has to be created with an owner'! !

!Port class methodsFor: 'instance creation' stamp: 'H.J 11/17/2000 16:25'!
ownedBy: anInfoPipe 
	| temp |
	temp _ self basicNew.
	temp owner: anInfoPipe.
	temp initialize.
	^ temp! !


!CompoundInPort class methodsFor: 'instance creation' stamp: 'H.J 11/20/2000 13:27'!
ownedBy: anInfoPipe and: aPseudePipe 
	^ (self ownedBy: anInfoPipe)
		pseudoOwner: aPseudePipe! !


!CompoundOutPort class methodsFor: 'instance creation' stamp: 'H.J 11/20/2000 13:42'!
ownedBy: anInfoPipe and: aPseudePipe 
	^ (self ownedBy: anInfoPipe)
		pseudoOwner: aPseudePipe! !


!OpenEnd class methodsFor: 'instance creation' stamp: 'HJ 1/22/2001 12:56'!
new
	"This is a singleton object, so we just return my only instance."
	SingleInstance isNil ifTrue: [SingleInstance _ self basicNew].
	^ SingleInstance! !


!PseudoPipe methodsFor: 'accessing' stamp: 'H.J 11/20/2000 13:52'!
realPort: aPort 
	realPort _ aPort! !


!InputPseudoPipe methodsFor: 'pipe operations' stamp: 'H.J 11/20/2000 22:20'!
pull
	^ realPort pull! !

!InputPseudoPipe methodsFor: 'pipe operations' stamp: 'H.J 11/20/2000 22:22'!
push: anItem 
	"push anItem into the pipe. The appropriate action is to push 
	anItem
	onto this pipe's output."
	self afterLatency: nil.
	self outPort push: anItem! !

!InputPseudoPipe methodsFor: 'accessing' stamp: 'H.J 11/20/2000 14:51'!
inPort
	self shouldNotImplement! !


!OutputPseudoPipe methodsFor: 'pipe operations' stamp: 'H.J 11/20/2000 22:22'!
pull
	"answers anItem obtained from this pipe. It is obtained by  
	pulling
	from this pipe's input"
	^ self afterLatency: self inPort pull! !

!OutputPseudoPipe methodsFor: 'pipe operations' stamp: 'H.J 11/20/2000 13:55'!
push: anItem 
	realPort push: anItem! !

!OutputPseudoPipe methodsFor: 'accessing' stamp: 'H.J 11/20/2000 14:53'!
outPort
	self shouldNotImplement! !


!PseudoPipe class methodsFor: 'instance creation' stamp: 'H.J 11/20/2000 13:39'!
new
	self error: 'a PseudoPipe can only be created by "InputPseudoPipe connectedTo: aPort" or "OutputPseudoPipe connectedTo: aPort"'! !


!InputPseudoPipe class methodsFor: 'instance creation' stamp: 'H.J 11/20/2000 15:26'!
connectedTo: aPort 
	| p |
	p _ self basicNew initialize.
	p outPort connect: aPort.
	^ p! !


!OutputPseudoPipe class methodsFor: 'instance creation' stamp: 'H.J 11/20/2000 15:27'!
connectedTo: aPort 
	| p |
	p _ self basicNew initialize.
	aPort connect: p inPort.
	^ p! !


!Pump methodsFor: 'pump operations'!
addThread
	"Makes an additional thread available to a pump."

	^ threadSack add: [
		[threadQueue wait.
		 self stroke] repeatForever] fork! !

!Pump methodsFor: 'pump operations' stamp: 'Rik 2/19/2004 14:25'!
addThread: n
	"Makes the specified number of additional threads available to a pump."

	n timesRepeat: [ self addThread ]! !

!Pump methodsFor: 'pump operations' stamp: 'HJ 10/29/2000 00:35'!
faster
	"change the interval between strokes of my pumper, by 10%. This 
	will 
	take effect after the next stroke."
	strokeDelay delayDuration: (strokeDelay delayDuration * 0.9) asInteger! !

!Pump methodsFor: 'pump operations' stamp: 'PEM. Real-time pump. 1/13/2002 15:30'!
removeThread
	"Removes one thread from a pump.
	 The thread count is not allowed to decrease below one.
	 Returns true if a thread could be removed, false otherwise."

	| aThread |

	(threadSack size) <= 1
		ifTrue: [^false].
	aThread _ threadSack removeFirst.
	aThread terminate.
	^true.! !

!Pump methodsFor: 'pump operations' stamp: 'PEM. Real-time pump. 1/13/2002 15:28'!
removeThread: n
	"Removes the specified number of threads from a pump.
	 The thread count is not allowed to decrease below one.
	 (Use stopPumping to halt a pump.)"

	1 to: n do: [ :i | self removeThread ]! !

!Pump methodsFor: 'pump operations' stamp: 'HJ 10/29/2000 00:35'!
slower
	"change the interval between strokes of my pumper, by 10%. This 
	will 
	take effect after the next stroke."
	strokeDelay delayDuration: (strokeDelay delayDuration * 1.1) asInteger! !

!Pump methodsFor: 'pump operations' stamp: 'HJ 10/29/2000 00:35'!
startPumping
	^ self startPumping: self strokeInterval! !

!Pump methodsFor: 'pump operations'!
startPumping: millisecondInterval 
	"Starts this pump, as an autonomous process"
	"if a pumper process is already working, detatch it first, or 
	else	we might inadvertently get two pumps, which would 
	effectively be working in parallel."

	self stopPumping.
	self strokeInterval: millisecondInterval.
	^ pumper _ [
			[threadQueue signal.
			strokeDelay wait] repeatForever] fork! !

!Pump methodsFor: 'pump operations' stamp: 'HJ 10/29/2000 00:35'!
stopPumping
	pumper ifNil: [^ self].
	pumper terminate.
	pumper _ nil! !

!Pump methodsFor: 'pump operations' stamp: 'Rik 2/27/2004 01:50'!
stroke
	| item |
	item _ self afterLatency: self inPort pull.
	item = #EndOfData ifTrue: [self changed: #EndOfData].
	self outPort push: item.
	strokes _ strokes + 1! !

!Pump methodsFor: 'pump operations' stamp: 'HJ 10/29/2000 00:35'!
stroke: aNumber 
	aNumber timesRepeat: [self stroke]! !

!Pump methodsFor: 'pump operations' stamp: 'HJ 10/29/2000 00:35'!
strokeInterval
	^ strokeDelay delayDuration! !

!Pump methodsFor: 'pump operations' stamp: 'HJ 10/29/2000 00:35'!
strokeInterval: millisecondInterval 
	strokeDelay _ Delay forMilliseconds: millisecondInterval! !

!Pump methodsFor: 'initialize-release' stamp: 'HJ 10/29/2000 00:35'!
defaultStrokeInterval
	"in milliseconds"
	^ 1000! !

!Pump methodsFor: 'initialize-release'!
initialize
	super initialize.
	strokeDelay _ Delay forMilliseconds: self defaultStrokeInterval.
	strokes _ 0.
	threadSack _ OrderedCollection new.
	threadQueue _ Semaphore new.
	self addThread! !

!Pump methodsFor: 'testing' stamp: 'HJ 10/29/2000 00:36'!
isActive
	^ true! !


!ReorderingBuffer methodsFor: 'private' stamp: 'HJ 10/29/2000 00:36'!
nextRandom
	^ (myRandom next * contents size) asInteger + 1! !

!ReorderingBuffer methodsFor: 'private' stamp: 'HJ 10/29/2000 00:36'!
produce
	| randomIndex result |
	contents isEmpty ifTrue: [^ nil].
	randomIndex _ self nextRandom.
	result _ contents at: randomIndex.
	contents removeAt: randomIndex.
	^ result! !

!ReorderingBuffer methodsFor: 'initialization' stamp: 'HJ 10/29/2000 00:36'!
initialize
	super initialize.
	myRandom _ Random new! !


!Sink methodsFor: 'private' stamp: 'apb 1/4/2002 13:46'!
consume: anItem 
	| now |
	bitBucket addLast: anItem.
	[bitBucket size > capacity]
		whileTrue: [bitBucket removeFirst].
	itemCount _ itemCount + 1.
	now _ Time millisecondClockValue.
	interarrivalTimes addLast: (Time milliseconds: now since: lastArrivalTime).
	[interarrivalTimes size > capacity]
		whileTrue: [interarrivalTimes removeFirst].
	lastArrivalTime _ now.
! !

!Sink methodsFor: 'control operations' stamp: 'HJ 10/29/2000 00:37'!
capacity: bitBucketCapacity 
	"set the capacity of my bitBucket"
	capacity _ bitBucketCapacity! !

!Sink methodsFor: 'pipe operations' stamp: 'HJ 10/29/2000 00:37'!
pull
	self error: 'you can''t pull from a sink'! !

!Sink methodsFor: 'pipe operations' stamp: 'HJ 10/29/2000 00:37'!
push: anItem 
	self afterLatency: (self consume: anItem)! !

!Sink methodsFor: 'initialization' stamp: 'HJ 10/29/2000 00:37'!
defaultCapacity
	^ 15! !

!Sink methodsFor: 'accessing' stamp: 'HJ 10/29/2000 00:37'!
contents
	^ bitBucket! !

!Sink methodsFor: 'accessing' stamp: 'H.J 11/15/2000 14:52'!
outPort
	self shouldNotImplement! !


!FileSink methodsFor: 'accessing' stamp: 'HJ 10/29/2000 00:28'!
fileName
	fileName ifNil: [fileName _ self defaultLabelForInspector].
	^ fileName! !

!FileSink methodsFor: 'accessing' stamp: 'HJ 10/29/2000 00:28'!
fileName: aName 
	fileName _ aName! !

!FileSink methodsFor: 'initialization' stamp: 'HJ 10/29/2000 00:28'!
initializeClone: aClone 
	super initializeClone: aClone.
	aClone fileName: self fileName! !

!FileSink methodsFor: 'private' stamp: 'HJ 10/29/2000 00:28'!
consume: anItem 
	bitBucket nextPutAll: anItem asString.
	bitBucket cr.
	bitBucket flush! !


!FileSink class methodsFor: 'instance creation' stamp: 'HJ 10/29/2000 00:40'!
new
	| classname |
	classname _ self class printString.
	self inform: classname , ' new is not appropriate; use ' , classname , ' on: <aFileName>' self shouldNotImplement! !

!FileSink class methodsFor: 'instance creation' stamp: 'HJ 10/29/2000 00:41'!
on: aFileName 
	^ (self basicNew fileName: aFileName) initialize! !


!Source methodsFor: 'private' stamp: 'H.J 11/15/2000 14:49'!
produce
	^ 'test'! !

!Source methodsFor: 'accessing' stamp: 'H.J 11/15/2000 14:51'!
inPort
	self shouldNotImplement! !

!Source methodsFor: 'pipe operations' stamp: 'HJ 10/29/2000 00:37'!
pull
	^ self afterLatency: self produce! !

!Source methodsFor: 'pipe operations' stamp: 'HJ 10/29/2000 00:37'!
push: anItem 
	self error: 'you can''t push an item into a source.'! !


!FileSource methodsFor: 'accessing' stamp: 'HJ 10/29/2000 00:29'!
fileName: aFileName 
	fileName _ aFileName! !

!FileSource methodsFor: 'private' stamp: 'Rik 2/6/2004 11:15'!
produce
	| line |
	line _ fileStream upTo: Character cr.
	line isEmpty ifTrue: [^ line].
	line isAllDigits ifTrue: [^ line asNumber].
	^ line! !


!FileSource class methodsFor: 'instance creation' stamp: 'HJ 10/29/2000 00:40'!
from: aFileName 
	^ (self basicNew fileName: aFileName) initialize! !

!FileSource class methodsFor: 'instance creation' stamp: 'HJ 10/29/2000 00:40'!
new
	| classname |
	classname _ self class printString.
	self inform: classname , ' new is not appropriate; use ' , classname , ' from: <aFileName>' self shouldNotImplement! !


!SequentialSource methodsFor: 'pipe operations' stamp: 'Rik 2/27/2004 00:20'!
produce
	maxUsed _ maxUsed + 1.
	^ self label , maxUsed asString! !


!SplitPipe methodsFor: 'accessing' stamp: 'H.J 11/16/2000 15:51'!
splitNumber: aNumber 
	splitNumber _ aNumber! !

!SplitPipe methodsFor: 'pipe operations' stamp: 'HJ 5/4/2001 00:04'!
pull
self shouldNotImplement! !

!SplitPipe methodsFor: 'pipe operations' stamp: 'Rik 6/9/2004 20:41'!
push: anItem 
	self afterLatency: nil.
	self outPorts do: [:eachPort | eachPort push: anItem]! !


!SplitPipe class methodsFor: 'instance creation' stamp: 'Rik 5/17/2004 11:56'!
new
	^ self newSplit: 2! !

!SplitPipe class methodsFor: 'instance creation' stamp: 'H.J 11/17/2000 10:58'!
newSplit: branches 
	| t |
	t _ self basicNew.
	t splitNumber: branches.
	t initialize.
	^ t! !


!SwitchTee methodsFor: 'as yet unclassified' stamp: 'HJ 5/4/2001 00:03'!
pull
	"answers anItem obtained from this pipe. It is obtained by  
	pulling
	from this pipe's input"
	^ self afterLatency: self inPort pull! !


!VarMode methodsFor: 'accessing' stamp: 'Rik 2/19/2004 14:00'!
myValue
	^ myValue! !

!VarMode methodsFor: 'accessing' stamp: 'HJ 10/30/2000 12:03'!
myValue: aMode 
	myValue
		ifNil: 
			[myValue _ aMode.
			^ self].
	myValue myValue: aMode! !

!VarMode methodsFor: 'accessing' stamp: 'HJ 10/29/2000 00:38'!
opposite
	self isBound ifTrue: [^ myValue opposite].
	^ InverseMode of: self! !

!VarMode methodsFor: 'type checking' stamp: 'HJ 10/30/2000 11:36'!
bind: aMode 
	self isBound ifTrue: [^ false].
	self myValue: aMode.
	^ true! !

!VarMode methodsFor: 'type checking' stamp: 'HJ 10/30/2000 11:35'!
isBound
	^ self myValue notNil! !

!VarMode methodsFor: 'type checking' stamp: 'HJ 10/30/2000 11:12'!
isCompatibleWith: aMode 
	self = aMode opposite ifTrue: [^ true].
	self isBound ifFalse: [self bind: aMode opposite].
	^ myValue isCompatibleWith: aMode! !

!VarMode methodsFor: 'printing' stamp: 'HJ 10/29/2000 00:38'!
printOn: aStream 
	"Append to aStream a sequence of characters that identifies me."
	aStream nextPutAll: self class name.
	aStream nextPutAll: '('.
	myValue printOn: aStream.
	aStream nextPutAll: ')'! !


!ZipTee methodsFor: 'accessing' stamp: 'Rik 2/19/2004 12:58'!
pull
	| compositeItem |
	compositeItem _ OrderedCollection new.
	self afterLatency: nil.
	self inPorts do: [:onePort | compositeItem addLast: onePort pull].
	^ compositeItem! !

Object subclass: #Monitor
	instanceVariableNames: 'monitored controled monitor interval'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'InfoPipes-Monitoring'!
