'From Squeak3.6 of ''6 October 2003'' [latest update: #5429] on 29 June 2004 at 10:54:06 pm'!
"Change Set:		RikIO
Date:			24 February 2004
Author:			Rik Smoody

An old way of making a textual transmissible object stream"!

Object subclass: #RikIO
	instanceVariableNames: 'stream registry '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rik-Support'!

!RikIO commentStamp: '<historical>' prior: 0!
Storage scheme
simple, ascii-based syntax
Store in a form that is not so binary as BOSS, requires no compiler
Use variable names,
	NEVER instVarAt: which causes brittleness in the face of mutation

within a file, objects can refer to each other by index=identity
any such references are issued AFTER the basic creation methods of
both referent and referee
On filing in, use a Dictionary of items to keep cross-references.
Use a stack of items so any compound setting can be done with extant values on stack.

Syntax:			use key characters to obviate lookahead.
				Whitespace skipped when seeking code
#Symbol	=	push the symbol	(familiar to Smalltalkers)
1234	=	push the integer (also -5678901234)
@123	=	push reference to object indexed (must already exist)
'asdf'	=	push the string
F8.6	=	push the float
tfn	=		push true, false, and nil, respectively
$Class	=	push the classnamed Class	(Smalltalk at:, really)
RFeedsDB =	RikPool at: the given symbol	(shorthand optimization)
*Symbol	=	perform (top of stack gets Symbol as message with args from stack)
&Symbol	=	perform, result is new top of stack
[Symbol	=	perform (top of stack gets Symbol as message with args as array on stack)
]Symbol	=	perform, result is new top of stack
p, P		=	(obsolete) perform ( pop gets pop as message with args pop. pop. pop, ...)
=145	=	top of stack is stored as item 145 (stays atop stack)
>145	=	 stored as 145 and is removed from stack
^		=	pop top of stack	( presumably it has been stowed)
<		=	pop does readFrom: theRikReader (class-specific format), push result
!! upto CR is a comment

Example:
5 $Array &new: >2		!! item @2 is Array new: 5
13  3  @2 *at:put:		!! (that array) at: 3 put: 13
 #LimeStone  $Gradation &new &rockType: > 3	
		!! item 3 is a gradation with rocktype set to Limestone
	!! Avoid this kind of heaping up... better to define it, stow it, and call it back. e.g.
$Gradation &new > 3
 #LimeStone @3 *rockType:	!! this avoids dangling undefineds

 RikWriter example .
 RikReader example 
!

RikIO subclass: #RikReader
	instanceVariableNames: 'stack '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rik-Support'!

!RikReader commentStamp: '<historical>' prior: 0!
see comment in super!

RikIO subclass: #RikWriter
	instanceVariableNames: 'maxIndex deferred '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rik-Support'!

!RikWriter commentStamp: '<historical>' prior: 0!
see comment in super!


!Object methodsFor: 'Rik writing ' stamp: 'Rik 2/17/2004 00:31'!
rikContentsOn: aRikWriter  regIndex: rindex
	"my registration index is given as an optimization.
		rindex := aRikWriter indexOf: self
	instvars and indexed variables need to be restored"
	| firstH |
	firstH := ValueHolder new contents: true.
	self rikNamedVariablesOn: aRikWriter regIndex: rindex firstHolder: firstH.
	self rikIndexedFieldsOn: aRikWriter  regIndex: rindex firstHolder: firstH.
	firstH contents
		ifTrue: [ aRikWriter nextPutDef: rindex ]
		ifFalse: [ aRikWriter nextPutRef: rindex ]! !

!Object methodsFor: 'Rik writing '!
rikContentsWithSettingOn: aRikWriter  regIndex: rindex
	"my registration index is given as an optimization.
		rindex := aRikWriter indexOf: self
	cut down on gratuitous stuff getting stored
		as would be done by default rikContentsOn:regIndex:
		Perhaps there's a lower-investment way to get this done,
		but finding it could take indefinite effort 
	Blatant re-use of #representBinaryWithSettingOn:"
	| col nargs |
	col := OrderedCollection new.
	self rikSettersOn: col.
	self rikLateSettersOn: col.
	col isEmpty
	ifTrue: [aRikWriter nextPutDef: rindex ]
	ifFalse: [
		aRikWriter nextPutDefPop: rindex.
		col do: [ :assn |
			(nargs := assn key asSymbol numArgs) >= 1
				ifTrue: [ aRikWriter nextPut: assn value ].
			aRikWriter nextPutRef: rindex.
			nargs >= 2
				ifTrue: [aRikWriter nextPutDoWithArguments: (assn key)] 
				ifFalse: [aRikWriter nextPutDo: (assn key)].
			"aRikWriter cr." ].
		aRikWriter nextPutRef: rindex.
	]! !

!Object methodsFor: 'Rik writing '!
rikCreateOn: aRikWriter
	"Most objects stow according to their identity.
	Simple values (e.g. Integers) can cheat"
	self class isVariable
		ifTrue: [ aRikWriter
					nextPut: self basicSize;
					nextPutClassRef: self class;
					nextPutPushDo: #new:. ]
		ifFalse: [ aRikWriter
					nextPutClassRef: self class;
					nextPutPushDo: #new. ].! !

!Object methodsFor: 'Rik writing ' stamp: 'Rik 2/17/2004 01:14'!
rikIOString
	| rw aStream |
	rw _ RikWriter new onStream: (aStream _ (String new: 200) writeStream).
	rw nextPutTop: self. 
	^ aStream contents

"
#(This is a test) rikIOString
"! !

!Object methodsFor: 'Rik writing ' stamp: 'Rik 2/17/2004 00:30'!
rikIndexedFieldsOn: aRikWriter  regIndex: rindex firstHolder: firstH
	"my registration index is given as an optimization.
		rindex := aRikWriter indexOf: self
	firstH will remain true if there are no elements
	indexed variables need to be restored	
	"
	| val |
	1 to: self basicSize do: [ :ix |
		(val := self basicAt: ix) isNil ifFalse: [ 
			firstH contents ifTrue: [ firstH contents: false. aRikWriter nextPutDefPop: rindex ].
			aRikWriter nextPut: val;
				nextPut: ix;
				nextPutRef: rindex;
				nextPutDo: #basicAt:put:.
			] ].! !

!Object methodsFor: 'Rik writing '!
rikLateSettersOn: col
	"Add things that need to be done after normal variable setting"! !

!Object methodsFor: 'Rik writing '!
rikNamedVariablesOn: aRikWriter  regIndex: rindex firstHolder: fHolder
	"my registration index is given as an optimization.
		rindex := aRikWriter indexOf: self
	fHolder will remain true if there are no inst vars
	instvars need to be restored	
	use instVarAt: to avoid unneccessary lazy initialization
	"
	| val |
	(self rikNamedVariablesToStore) do: [ :vbl |
		(val := self instVarAt: (self class instVarIndexFor: vbl)) isNil ifFalse: [ 
			fHolder value ifTrue: [ fHolder value: false. aRikWriter nextPutDefPop: rindex ].
			aRikWriter
				nextPut: val;
				nextPutRef: rindex;
				nextPutDo: vbl , ':'
			] ].! !

!Object methodsFor: 'Rik writing '!
rikNamedVariablesToStore
	"Answer a list of the names of variables which are to be stored.
	Default to everything"
	^self class allInstVarNames.! !

!Object methodsFor: 'Rik writing '!
rikSettersOn: col
	"Add associations to the collection...
		msgSymbol -> arg(s)
		which would set up my instance variables 
	This strategy is the more fragile approach of explicitly stating what to take
	instead of taking everything."

	"There's a temptation to hack on putSettersOn: (e.g. Machine)
	so rename it before destoyring extant functionality
	so the cross-over can be less painful"! !

!Object methodsFor: 'Rik writing '!
rikWriteOn: aRikWriter
	"aRikWriter has decided that I need to be stored.
	Most objects stow according to their identity.
	Simple values (e.g. Integers) can cheat"

	| ix |
	ix := aRikWriter indexOfFerSure: self.
	self rikCreateOn: aRikWriter.
	self rikContentsOn: aRikWriter regIndex: ix.! !


!Class methodsFor: 'Rik writing'!
rikWriteOn: aRikWriter
	"aRikWriter has decided that I need to be stored.
	Classes are assumed to already exist, so just store a reference"

	aRikWriter stream nextPut: $$; print: self! !


!Collection methodsFor: 'Rik writing' stamp: 'Rik 2/17/2004 00:30'!
rikIndexedFieldsOn: aRikWriter regIndex: rindex firstHolder: firstH 
	"my registration index is given as an optimization. 
	rindex := aRikWriter indexOf: self 
	firstH will remain true if there are no elements 
	indexed variables need to be restored	 
	"

	self do: [:val |
		val isNil ifFalse: [
			firstH contents ifTrue: [firstH contents: false. aRikWriter nextPutDefPop: rindex].
			aRikWriter
				nextPut: val;
				nextPutRef: rindex;
				nextPutDo: #add:]]! !

!Collection methodsFor: 'Rik writing'!
rikWriteOn: aRikWriter
	"aRikWriter has decided that I need to be stored.
	Some classes use specific creation methods for correctness or conciseness.
	Small (< size 4) collections use with:..."

	| sz aStream |
	(sz := self size) > 4 ifTrue: [ ^super rikWriteOn: aRikWriter].
	self asArray reverseDo: [ :ea | aRikWriter nextPut: ea ].
	aRikWriter nextPutClassRef: self class.
	sz = 0 ifTrue: [	aRikWriter nextPutPushDo: #new ] 
	ifFalse: [ 
		aStream := WriteStream on: (String new: 20).
		sz timesRepeat: [ aStream nextPutAll: 'with:' ].
		aRikWriter nextPutPushDo: aStream contents. ].
	aRikWriter nextPutDef: (aRikWriter indexOfFerSure: self)! !


!ArrayedCollection methodsFor: 'Rik writing' stamp: 'Rik 2/17/2004 00:30'!
rikIndexedFieldsOn: aRikWriter  regIndex: rindex firstHolder: firstH
	"my registration index is given as an optimization.
		rindex := aRikWriter indexOf: self
	firstH will remain true if there are no elements
	indexed variables need to be restored	
	"
	| val |
	1 to: self size do: [ :ix |
		(val := self at: ix) isNil ifFalse: [ 
			firstH contents ifTrue: [ firstH contents: false. aRikWriter nextPutDefPop: rindex ].
			aRikWriter nextPut: val;
				nextPut: ix;
				nextPutRef: rindex;
				nextPutDo: #at:put:.
			] ].! !


!Dictionary methodsFor: 'Rik writing' stamp: 'Rik 4/27/2004 14:21'!
rikWriteOn: aRikWriter
	"aRikWriter has decided that I need to be stored.
	Some classes use specific creation methods for correctness or conciseness.
	Dictionarys have to use dictionary enumeration or only values would propagate"

	| firstH rindex |
	aRikWriter nextPut: array size;
				nextPutClassRef: self class;
				nextPutPushDo: #new:.
	firstH := true asValue.
	rindex := aRikWriter indexOfFerSure: self.
	self associationsDo: [ :assn |
		firstH value ifTrue: [ firstH value: false. aRikWriter nextPutDefPop: rindex ].
		aRikWriter nextPut: assn value;
			nextPut: assn key;
			nextPutRef: rindex;
			nextPutDo: #at:put:.
		].
	firstH value
		ifTrue: [ aRikWriter nextPutDef: rindex ]
		ifFalse: [ aRikWriter nextPutRef: rindex ]

""! !


!False methodsFor: 'Rik writing'!
rikWriteOn: aRikWriter
	"aRikWriter has decided that I need to be stored.
	Most objects stow according to their identity.
	Simple values (e.g. Integers) can cheat"

	aRikWriter stream nextPutAll: ' f'! !


!Float methodsFor: 'Rik writing'!
rikWriteOn: aRikWriter
	"aRikWriter has decided that I need to be stored.
	Most objects stow according to their identity.
	Simple values (e.g. Integers) can cheat
	Floats are so rarely re-used and
		often equal but non-identical, so don't bother with registry"

	aRikWriter stream nextPut: $F; print: self.! !


!Fraction methodsFor: 'Rik writing'!
rikWriteOn: aRikWriter
	"aRikWriter has decided that I need to be stored.
	Some classes use specific creation methods"

	aRikWriter
		nextPut: self denominator;
		nextPut: self numerator;
		nextPutClassRef: self class;
		nextPutPushDo: #numerator:denominator: ;
		nextPutDef: (aRikWriter indexOfFerSure: self)


""! !


!Integer methodsFor: 'Rik writing'!
rikWriteOn: aRikWriter
	"aRikWriter has decided that I need to be stored.
	Most objects stow according to their identity.
	Simple values (e.g. Integers) can cheat"

	aRikWriter stream print: self! !


!LookupKey methodsFor: 'Rik writing'!
rikWriteOn: aRikWriter
	"aRikWriter has decided that I need to be stored.
	Some classes use specific creation methods for correctness or conciseness"

	aRikWriter
		nextPut: key;
		nextPutClassRef: self class;
		nextPutPushDo: #key: ;
		nextPutDef: (aRikWriter indexOfFerSure: self)! !


!Association methodsFor: 'Rik writing'!
rikWriteOn: aRikWriter
	"aRikWriter has decided that I need to be stored.
	Some classes use specific creation methods for correctness or conciseness"

	aRikWriter
		nextPut: value;
		nextPut: key;
		nextPutClassRef: self class;
		nextPutPushDo: #key:value: ;
		nextPutDef: (aRikWriter indexOfFerSure: self)! !


!MessageSend methodsFor: 'Rik writing'!
rikWriteOn: aRikWriter
	"aRikWriter has decided that I need to be stored.
	Some classes use specific creation methods"

	aRikWriter
		nextPut: self arguments;
		nextPut: self selector;
		nextPut: self receiver;
		nextPutClassRef: self class;
		nextPutPushDo: #receiver:selector:arguments: ;
		nextPutDef: (aRikWriter indexOfFerSure: self)! !


!Metaclass methodsFor: 'Rik writing'!
rikWriteOn: aRikWriter
	"aRikWriter has decided that I need to be stored.
	Most objects stow according to their identity.
	Simple values (e.g. Integers) can cheat"

	aRikWriter nextPut: self soleInstance.
	aRikWriter nextPutPushDo: #class! !


!OrderedCollection methodsFor: 'Rik writing'!
rikNamedVariablesToStore
	"Answer a list of the names of variables which are to be stored.
	A new OrderedCollection takes care of its own firstIndex and lastIndex"
	^Array new! !


!Point methodsFor: 'Rik writing'!
rikWriteOn: aRikWriter
	"aRikWriter has decided that I need to be stored.
	Some classes use specific creation methods"

	aRikWriter
		nextPut: self y;
		nextPut: self x;
		nextPutClassRef: self class;
		nextPutPushDo: #x:y: ;
		nextPutDef: (aRikWriter indexOfFerSure: self)! !


!Rectangle methodsFor: 'Rik writing'!
rikContentsOn: aRikWriter regIndex: rindex 
	^self rikContentsWithSettingOn: aRikWriter regIndex: rindex! !

!Rectangle methodsFor: 'Rik writing'!
rikCreateOn: aRikWriter 
	"Use indirect creation method"

	aRikWriter
		nextPut: self bottom;
		nextPut: self top;
		nextPut: self right;
		nextPut: self left;
		nextPutClassRef: self class;
		nextPutPushDo: #left:right:top:bottom:.! !


!RikIO methodsFor: 'accessing'!
stream
	^stream! !

!RikIO methodsFor: 'initialize-release'!
close
	stream close! !

!RikIO methodsFor: 'initialize-release'!
onStream: aStream
	stream := aStream! !


!RikIO class methodsFor: 'instantiation'!
new
	^super new initialize! !

!RikIO class methodsFor: 'instantiation'!
onFileNamed: aString
	^(self new) onFileNamed: aString! !


!RikReader methodsFor: 'accessing'!
atEnd
	^stream skipSeparators; atEnd! !

!RikReader methodsFor: 'examples'!
stack
	"for use by example (of self class)"
	^stack! !

!RikReader methodsFor: 'initialize-release'!
initialize
	registry := IdentityDictionary new: 6666.
	stack := OrderedCollection new.! !

!RikReader methodsFor: 'initialize-release'!
onFileNamed: aString
	self onStream: aString asFilename readStream! !

!RikReader methodsFor: 'ops'!
nextPop
	"used by client confident (deep in a reading mode)
	that the next thing on the stream need not be retained after it's asked for"
	self next.
	^self pop! !

!RikReader methodsFor: 'ops'!
pop
	| rslt |
	stack isEmpty ifTrue: [Smalltalk isDevelopmentImage
		ifTrue: [self halt: 'empty stack'. rslt := nil. ^rslt.]
		ifFalse: [^rslt]]  .
	^stack removeLast! !

!RikReader methodsFor: 'ops'!
push: anObject
	^stack addLast: anObject! !

!RikReader methodsFor: 'ops'!
pushDoSymbolWithArguments
	"saw ]Symbol"

	^self push: self doSymbolWithArguments! !

!RikReader methodsFor: 'ops'!
pushMakeReference
	^self push: self makeReference! !

!RikReader methodsFor: 'ops'!
top
	stack isEmpty ifTrue: [^'empty stack' ].
	^stack last! !

!RikReader methodsFor: 'reading'!
doSymbol
	"saw *Symbol"

	^self doSymbol: self readSymbol! !

!RikReader methodsFor: 'reading'!
doSymbol: sym
	" perform a method "
	| nargs |
	^(nargs := sym numArgs) = 0
		ifTrue: [self pop perform: sym]
		ifFalse: [
			(self pop perform: sym
					withArguments: ((1 to: nargs) collect: [ :ea | self pop ]))
			]! !

!RikReader methodsFor: 'reading'!
doSymbolWithArguments
	"saw [Symbol"

	^self doSymbolWithArguments: self readSymbol! !

!RikReader methodsFor: 'reading'!
doSymbolWithArguments: sym 
	"perform a method where an array of args is on the stack"

	^sym numArgs = 0
		ifTrue: [self error]
		ifFalse: [self pop perform: sym withArguments: self pop]! !

!RikReader methodsFor: 'reading'!
makeReference
	^registry at: (Integer readFrom: self stream) put: self pop! !

!RikReader methodsFor: 'reading' stamp: 'Rik 2/16/2004 23:36'!
next
	| peek |
	(self stream) skipSeparators.
	self stream atEnd ifTrue: [ ^nil ].
	peek := self stream next.
	(peek isDigit or: [ peek == $-]) ifTrue: [stream skip: -1. ^self pushInteger ].
	peek ==$' ifTrue: [stream skip: -1. ^self pushString ].
	peek ==$@ ifTrue: [^self pushReference ].
	peek ==$= ifTrue: [^self pushMakeReference ].
	peek ==$> ifTrue: [^self makeReference ].
	peek ==$* ifTrue: [^self doSymbol ].
	peek ==$& ifTrue: [^self pushDoSymbol ].
	peek ==$[ ifTrue: [^self doSymbolWithArguments ].
	peek ==$] ifTrue: [^self pushDoSymbolWithArguments ].
	peek ==$# ifTrue: [^self pushSymbol ].
	peek ==$$ ifTrue: [^self pushClass ].
	peek ==$p ifTrue: [^self performFromStack ].
	peek ==$P ifTrue: [^self pushPerformFromStack ].
	peek ==$^ ifTrue: [^ #topLevel ].
	peek ==$< ifTrue: [^self top readFrom: self].
	peek ==$w ifTrue: [self skipWise. ^self next].	"This recursion is not expected to get deep"
	peek ==$!! ifTrue: [self skipComment. ^self next].
	peek ==$F ifTrue: [^self pushFloat ].
	peek ==$f ifTrue: [^self push: false ].
	peek ==$t ifTrue: [^self push: true ].
	peek ==$n ifTrue: [^self push: nil ].
	peek ==$h ifTrue: ["self halt." ^ self next ].
	^self error:
		('Unexpected key char: ' , peek inspectString).! !

!RikReader methodsFor: 'reading' stamp: 'Rik 2/16/2004 23:38'!
nextTop
	" Read until top-level marker is seen, then answer top-o-stack"

	[ self atEnd ] whileFalse: [
		(self next) == #topLevel
			ifTrue: [ ^self pop ]
		].
	^self error:
		'End of input file unexpec' .
	! !

!RikReader methodsFor: 'reading'!
objectAtIndex: rindex
	^registry at: rindex ifAbsent: [Smalltalk isDevelopmentImage
		ifTrue: [self halt: 'reference to un-defined index'. nil]
		ifFalse: [nil]  ]! !

!RikReader methodsFor: 'reading'!
pushClass
	^self push: (Smalltalk at: self readSymbol ifAbsent: [ nil ])! !

!RikReader methodsFor: 'reading'!
pushDoSymbol
	"saw *Symbol"

	^self push: self doSymbol! !

!RikReader methodsFor: 'reading'!
pushFloat
	^self push: (Float readFrom: self stream)! !

!RikReader methodsFor: 'reading'!
pushInteger
	^self push: (Integer readFrom: self stream)! !

!RikReader methodsFor: 'reading'!
pushReference
	^self push: (self objectAtIndex: (Integer readFrom: self stream))! !

!RikReader methodsFor: 'reading'!
pushString
	^self push: (String readFrom: self stream)! !

!RikReader methodsFor: 'reading'!
pushSymbol
	"saw #Symbol"

	^self push: self readSymbol! !

!RikReader methodsFor: 'reading'!
readAll
	"Read all the rest of my file (which may be the whole file).
	Side-effects of expressions do the work"
	[ [self atEnd] whileFalse: [
		Transcript show: 'rikRdr nextTop =>';  print: self nextTop; crFlush. ]
		] valueNowOrOnUnwindDo: [self close].! !

!RikReader methodsFor: 'reading'!
readSymbol
	| wrd |
	((wrd := self readWord) isEmpty and: [ stream peek = $'])
		ifTrue: [ wrd := String readFrom: self stream ].
	^wrd asSymbol
! !

!RikReader methodsFor: 'reading'!
readWise
	self gomi! !

!RikReader methodsFor: 'reading'!
readWord
	"Grab and answer next contiguous word including :'s (colons) "
	| rslt chr |
	rslt := WriteStream on: (String new: 20).
	[stream atEnd] whileFalse: [
		((chr := stream next) isAlphaNumeric or: [ chr == $:])
			ifTrue: [rslt nextPut: chr ]
			ifFalse: [stream skip: -1. ^rslt contents] 
		].
	^rslt contents! !

!RikReader methodsFor: 'reading'!
skipComment
	"Saw !!. Skip to end of line "
	| chr |
	[stream atEnd] whileFalse: [
		((chr := stream next) == Character cr or: [ chr == Character lf])
			ifTrue: [^self]
		].! !

!RikReader methodsFor: 'reading'!
skipWise
	"For Wise-writing compatibility... skip until a closing bracket]
	preceed whole assemblage by w   e.g.
w 
[section name]

	(For now, just edit the afflicted fields in the .ini file by hand)
	"
	self stream skipThrough: $]! !


!RikReader class methodsFor: 'examples'!
example
	" RikReader example "
	| br col |
	br := self onFileNamed: 'aaRik'.
	col := OrderedCollection new.
	[ [ br atEnd ] whileFalse: [
		br shiftHalt.
		col add: br nextTop ] ] valueNowOrOnUnwindDo: [ br close ].
	^col! !

!RikReader class methodsFor: 'examples'!
example0
	" RikReader example0 "
	| br col |
	br := self onFileNamed: 'aaRik'.
	col := OrderedCollection new.
	[ [ br atEnd ] whileFalse: [
		br shiftHalt.
		col add: br next ] ] valueNowOrOnUnwindDo: [ br close ].
	^br stack! !

!RikReader class methodsFor: 'instantiations' stamp: 'Rik 2/17/2004 01:24'!
fromString: aString
	^(self new onStream: aString readStream) nextTop

"
RikReader fromString: 
(#(This is a test) rikIOString)
"! !

!RikReader class methodsFor: 'instantiations'!
readFileNamed: fileNameString
	Transcript show: '///// RikReader < '; print: fileNameString; crFlush.
	(self onFileNamed: fileNameString) readAll.
	Transcript show: '\\\\\ RikReader < '; print: fileNameString; show: '   EOF'; crFlush.! !


!RikWriter methodsFor: 'deferring'!
defer: aMessageSend
	self deferred add: aMessageSend! !

!RikWriter methodsFor: 'deferring'!
deferred
	deferred isNil ifTrue: [deferred := OrderedCollection new].
	^deferred! !

!RikWriter methodsFor: 'deferring'!
putAllDeferred
	" The only covered use is for the message to store info of what needs to happen,
	The message itself does not need to get stored"
	| msg |
	[deferred isEmpty] whileFalse: [
		(msg := deferred removeFirst)
			arguments reverseDo: [ :arg | self nextPut: arg ].
		self nextPut: msg receiver.
		self nextPutPushDo: (msg selector).
		self putTop.
		]! !

!RikWriter methodsFor: 'initialize-release'!
initialize
	registry := IdentityDictionary new: 6666.
	maxIndex := 0.! !

!RikWriter methodsFor: 'initialize-release'!
onFileNamed: aString
	self onStream: aString asFilename writeStream! !

!RikWriter methodsFor: 'patching'!
nextPutClasses: classes 
	(SystemUtils sortForLoading: classes)
		do: [:cls | 
			self nextPutComment: cls.
			cls rikPutDefOn: self]! !

!RikWriter methodsFor: 'patching'!
patchLog: aString 
	Transcript patchLog: aString! !

!RikWriter methodsFor: 'registry'!
indexOf: anObject
	"Answer the index for an arbitrary object.
	nil is special to dictionaries... beware that it is handled correctly here too"

	^registry at: anObject ifAbsent: [nil]! !

!RikWriter methodsFor: 'registry'!
indexOfFerSure: anObject
	"Answer the index for an arbitrary object. Put it there if necessary.
	nil is special to dictionaries... must handle it specially here too"
	^anObject isNil
		ifTrue: [0]
		ifFalse: [
			registry at: anObject
					ifAbsent: [registry at: anObject put: (maxIndex := maxIndex + 1)
					]]! !

!RikWriter methodsFor: 'writing'!
cr
	stream cr! !

!RikWriter methodsFor: 'writing'!
nextPut: anObject
	| ix |
	(ix := self indexOf: anObject) isNil
		ifTrue: [ anObject rikWriteOn: self. ] 
		ifFalse: [self nextPutRef: ix] .
	stream space.! !

!RikWriter methodsFor: 'writing'!
nextPutClassRef: aClass
	self nextPutGlobalRef: aClass name! !

!RikWriter methodsFor: 'writing'!
nextPutComment: strThing
	"Don't embed cr's"
	stream nextPutAll: ' !!'; nextPutAll: strThing asString; cr! !

!RikWriter methodsFor: 'writing'!
nextPutDef: rindex
	stream nextPutAll: ' ='; print: rindex; space! !

!RikWriter methodsFor: 'writing'!
nextPutDefPop: rindex
	stream nextPutAll: ' >'; print: rindex; space! !

!RikWriter methodsFor: 'writing'!
nextPutDo: aSymbol
	stream nextPutAll: ' *'; nextPutAll: aSymbol; cr! !

!RikWriter methodsFor: 'writing'!
nextPutDoWithArguments: aSymbol
	stream nextPutAll: ' ['; nextPutAll: aSymbol; cr! !

!RikWriter methodsFor: 'writing'!
nextPutGlobalRef: aString
	stream nextPutAll: ' $'; nextPutAll: aString; space! !

!RikWriter methodsFor: 'writing'!
nextPutPushDo: aSymbol
	stream nextPutAll: ' &'; nextPutAll: aSymbol; cr! !

!RikWriter methodsFor: 'writing'!
nextPutPushDoWithArguments: aSymbol
	stream nextPutAll: ' ]'; nextPutAll: aSymbol; cr! !

!RikWriter methodsFor: 'writing'!
nextPutRef: rindex
	stream nextPutAll: ' @'; print: rindex; space! !

!RikWriter methodsFor: 'writing'!
nextPutTop: anObject
	^self nextPut: anObject; putTop! !

!RikWriter methodsFor: 'writing'!
putHalt
	"Make the reader halt"
	stream nextPutAll: ' h'; cr! !

!RikWriter methodsFor: 'writing'!
putReadFrom
	"The knowledgeable object has its own format..."
	stream nextPutAll: ' < '! !

!RikWriter methodsFor: 'writing'!
putTop
	stream nextPut: $^; cr! !

!RikWriter methodsFor: 'writing'!
space
	"Whitespace can make it easier for us to decipher"
	stream space! !

!RikWriter methodsFor: 'writing'!
tab
	stream tab! !


!RikWriter class methodsFor: 'examples' stamp: 'Rik 2/23/2004 01:15'!
example
	" RikWriter example "
	| bw |
	bw := self onFileNamed: 'aaRik'.
	[
	bw shiftHalt.
	bw nextPutTop: 123; cr.
	bw nextPutTop: 1234567890123456789012345678901234567890; cr.
	bw nextPutTop: (#fred->#cello); cr.
	
	] valueNowOrOnUnwindDo: [ bw close ]! !


!RunArray methodsFor: 'Rik writing'!
rikWriteOn: aRikWriter
	"aRikWriter has decided that I need to be stored.
	Most objects stow according to their identity.
	Simple values (e.g. Integers) can cheat"

	aRikWriter
		nextPut: values;
		nextPut: runs;
		nextPutClassRef: self class;
		nextPutPushDo: #runs:values: ;
		nextPutDef: (aRikWriter indexOfFerSure: self)! !


!String methodsFor: 'Rik writing'!
rikWriteOn: aRikWriter
	"aRikWriter has decided that I need to be stored.
	Use normal string storage, not char-at-a-time"

	self storeOn: aRikWriter stream.
	aRikWriter nextPutDef: (aRikWriter indexOfFerSure: self).! !


!Symbol methodsFor: 'Rik writing'!
rikWriteOn: aRikWriter
	"aRikWriter has decided that I need to be stored.
	Most objects stow according to their identity.
	Simple values (e.g. Integers) can cheat"
	self detect: [ :chr | chr isSeparator ]
		ifNone: [ aRikWriter stream print: self. ^self ].
	"Otherwise, there is an emrikded space"
	(aRikWriter stream)
		store: self asString.
	aRikWriter nextPutPushDo: #asSymbol.
	aRikWriter nextPutDef: (aRikWriter indexOfFerSure: self).! !


!Text methodsFor: 'Rik writing'!
rikWriteOn: aRikWriter
	"aRikWriter has decided that I need to be stored.
	Some classes use specific creation methods"

	aRikWriter
		nextPut: runs;
		nextPut: string;
		nextPutClassRef: self class;
		nextPutPushDo: #string:runs: ;
		nextPutDef: (aRikWriter indexOfFerSure: self)! !


!True methodsFor: 'Rik writing'!
rikWriteOn: aRikWriter
	"aRikWriter has decided that I need to be stored.
	Most objects stow according to their identity.
	Simple values (e.g. Integers) can cheat"

	aRikWriter stream nextPutAll: ' t'! !


!UndefinedObject methodsFor: 'Rik writing'!
rikWriteOn: aRikWriter
	"aRikWriter has decided that I need to be stored.
	Most objects stow according to their identity.
	Simple values (e.g. Integers) can cheat"

	aRikWriter stream nextPutAll: ' n'! !

